/***********************************************************************
<t@C>	battlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		drcʌmCu`
***********************************************************************/

#ifndef _BATTLIB_H_INCLUDED
#define _BATTLIB_H_INCLUDED

#include <sharpgen.h>


/* GetBatteryPerRest o̓XybN */
/* L̒lύXꍇAK FATAL < CAUTION < ... < 100_PER
   ɂȂ悤ɒlݒ肵ĉB*/
#define	BATTERY_REST_100_PER	0x7		/* obe[c 100% */
#define	BATTERY_REST_80_PER		0x6		/* obe[c 80% */
#define	BATTERY_REST_60_PER		0x5		/* obe[c 60% */
#define	BATTERY_REST_40_PER		0x4		/* obe[c 40% */
#define	BATTERY_REST_20_PER		0x3		/* obe[c 20% */
#define	BATTERY_REST_CAUTION	0x2		/* obe[c CautionLevel */
#define	BATTERY_REST_FATAL		0x1		/* obe[c FatalLevel */
#define	BATTERY_REST_ERROR		0x0		/* p[^G[ */

/* GetBatteryVolt o̓XybN */

#define	MainBatteryLevel19	0x13	/* 8.2V (8.2V ȏ		   )  */
#define	MainBatteryLevel18	0x12   	/* 8.1V (8.1V ȏ 8.2V ) */
#define	MainBatteryLevel17	0x11   	/* 8.0V (8.0V ȏ 8.1V ) */
#define	MainBatteryLevel16	0x10   	/* 7.9V (7.9V ȏ 8.0V ) */
#define	MainBatteryLevel15	0x0f   	/* 7.8V (7.8V ȏ 7.9V ) */
#define	MainBatteryLevel14	0x0e    /* 7.7V (7.7V ȏ 7.8V ) */
#define	MainBatteryLevel13	0x0d	/* 7.6V (7.6V ȏ 7.7V ) */
#define	MainBatteryLevel12	0x0c	/* 7.5V (7.5V ȏ 7.6V ) */
#define	MainBatteryLevel11	0x0b 	/* 7.4V (7.4V ȏ 7.5V ) */
#define	MainBatteryLevel10	0x0a   	/* 7.3V (7.3V ȏ 7.4V ) */
#define	MainBatteryLevel9	0x09   	/* 7.2V (7.2V ȏ 7.3V ) */
#define	MainBatteryLevel8	0x08   	/* 7.1V (7.1V ȏ 7.2V ) */
#define	MainBatteryLevel7	0x07   	/* 7.0V (7.0V ȏ 7.1V ) */
#define	MainBatteryLevel6	0x06   	/* 6.9V (6.9V ȏ 7.0V ) */
#define	MainBatteryLevel5	0x05   	/* 6.8V (6.8V ȏ 6.9V ) */
#define	MainBatteryLevel4	0x04   	/* 6.7V (6.7V ȏ 6.8V ) */
#define	MainBatteryLevel3	0x03   	/* 6.6V (6.6V ȏ 6.7V ) */
#define	MainBatteryLevel2	0x02   	/* 6.5V (6.5V ȏ 6.6V ) */
#define	MainBatteryLevel1	0x01   	/* 6.4V (6.5V  		   )  */


/* vg^Cv錾  ȉ̊֐͓pł */

/* system/battery_main.c */
UCHAR IrqGetBatteryPerRest(void);
UCHAR GetBatteryPerRest(void);
UCHAR GetBatteryVolt(void);
UCHAR GetMainVolt(void);

/* system/battery_sub.s */
void AdcReadOn(void);
void AdcReadOff(void);
USHORT ReadMbvdet(void);
USHORT ReadThmsen(void);
USHORT ReadBbvdet(void);
USHORT ReadMbvdetAndMem(void);
USHORT ReadThmsenAndMem(void);
USHORT ReadMbvdetMem(void);
USHORT ReadThmsenMem(void);

UCHAR GetMainBatteryLevel(ULONG);
UCHAR GetThermoLevel(ULONG);
UCHAR GetMainBatteryRest(UCHAR, UCHAR);

/* tFC^CxgZbg銄荞݃[` */
void BatteryFatalMsg(void);

void OpenBatteryCvr(void);


/*======================================================================
	Cu֐
		ROMVXep
		AvP[Vi[_u܂ށjA[_ufoCXhCo
		ł͎gpĂ͂ȂȂ
======================================================================*/

BOOLEAN CanBatteryAffordPCCard();


#endif /* #ifndef _BATTLIB_H_INCLUDED */
