/***********************************************************************
<t@C>	cliplib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		Nbv{[hCu`
***********************************************************************/
#ifndef _CP_LIB_DEFINED
#define	_CP_LIB_DEFINED

#include <sharpgen.h>

typedef UCHAR	CLIPID;		/* Nbv{[h̔ԍ\^ */

/* Nbv{[hԍ */
#define	CP_APL_CUT_BUF		0	/* Jbgobt@ */
#define	CP_APL_IAC_BUF		1	/* IACpCf[^obt@ */
#define	CP_APL_SELECT_BUF	2	/* ZNgobt@ */
#define	CP_GSER_INFO_BUF	3	/* Šp */
#define	CP_PAD_INK_BUF		4	/* CN[vQƃpbhp */
#define	CP_APM_BUF			5	/* APMgp(Binary) */
								/* Textt@NVpɎg */
#define	CP_APL_IAC_CTL_BUF	6	/* IACpRg[f[^obt@ */
#define	CP_GSER_RESUME_BUF	7	/* ŠČp */
#define	CP_SEARCH_TEXT_BUF	8	/* pbh󂯓np */
#define	CP_QUICK_LINK_BUF	9	/* QuickLinknp */

typedef UCHAR	CLIPNAME[5];	/* ʖ */

/* ֐` */
UCHAR	CPClear(CLIPID ClipID);
UCHAR	CPCheckLength(CLIPID ClipID,USHORT *BinSize,USHORT *TxtSize);
UCHAR	CPReadIDName(CLIPID ClipID,CLIPNAME ClipIDName);
USHORT	CPReadBin(CLIPID ClipID,void *Buf,USHORT Len);
USHORT	CPReadBinOffset(CLIPID ClipID,void *Buf,USHORT Len,USHORT Offset);
USHORT	CPReadText(CLIPID ClipID,void *Buf,USHORT Len);
USHORT	CPReadTextOffset(CLIPID ClipID,void *Buf,USHORT Len,USHORT Offset);
UCHAR	*CPWriteIDName(CLIPID ClipID,CLIPNAME ClipIDName);
UCHAR	*CPWriteBin(CLIPID ClipID,void *Buf,USHORT Len);
UCHAR	*CPWriteText(CLIPID ClipID,void *Buf,USHORT Len);
UCHAR	*CPAppendBin(CLIPID ClipID,void *Buf,USHORT Len);
UCHAR	*CPAppendText(CLIPID ClipID,void *Buf,USHORT Len);

#define	CP_BUF_LACK		1
#define	CP_NOT_FOUND	2

/* eNbv{[hp}N */

/* Jbgobt@ */
#define	BoardClear()				CPClear(CP_APL_CUT_BUF)
#define	CheckLength(bs,ts)			CPCheckLength(CP_APL_CUT_BUF,bs,ts)
#define	ReadIDName(name)			CPReadIDName(CP_APL_CUT_BUF,name)
#define	ReadBinaryBoard(b,l)		CPReadBin(CP_APL_CUT_BUF,b,l)
#define	ReadBinaryOffset(b,l,o)		CPReadBinOffset(CP_APL_CUT_BUF,b,l,o)
#define	ReadTextBoard(b,l)			CPReadText(CP_APL_CUT_BUF,b,l)
#define	ReadTextOffset(b,l,o)		CPReadTextOffset(CP_APL_CUT_BUF,b,l,o)
#define	WriteIDName(name)			CPWriteIDName(CP_APL_CUT_BUF,name)
#define	WriteBinaryBoard(b,l)		CPWriteBin(CP_APL_CUT_BUF,b,l)
#define	WriteTextBoard(b,l)			CPWriteText(CP_APL_CUT_BUF,b,l)
#define	AppendBinaryBoard(b,l)		CPAppendBin(CP_APL_CUT_BUF,b,l)
#define	AppendTextBoard(b,l)		CPAppendText(CP_APL_CUT_BUF,b,l)

/* ZNgobt@ */
#define	SelectBufClear()			CPClear(CP_APL_SELECT_BUF)
#define	CheckLenSelectBuf(bs,ts)	CPCheckLength(CP_APL_SELECT_BUF,bs,ts)
#define	ReadIDNameSelect(name)		CPReadIDName(CP_APL_SELECT_BUF,name)
#define	ReadBinSelectBuf(b,l)		CPReadBin(CP_APL_SELECT_BUF,b,l)
#define	ReadBinOffsetSelect(b,l,o)	CPReadBinOffset(CP_APL_SELECT_BUF,b,l,o)
#define	ReadTextSelectBuf(b,l)		CPReadText(CP_APL_SELECT_BUF,b,l)
#define	ReadTextOffsetSelect(b,l,o)	CPReadTextOffset(CP_APL_SELECT_BUF,b,l,o)
#define	WriteIDNameSelect(name)		CPWriteIDName(CP_APL_SELECT_BUF,name)
#define	WriteBinSelectBuf(b,l)		CPWriteBin(CP_APL_SELECT_BUF,b,l)
#define	WriteTextSelectBuf(b,l)		CPWriteText(CP_APL_SELECT_BUF,b,l)
#define	AppendBinSelectBuf(b,l)		CPAppendBin(CP_APL_SELECT_BUF,b,l)
#define	AppendTextSelectBuf(b,l)	CPAppendText(CP_APL_SELECT_BUF,b,l)

/* IACCf[^p */
#define	AplComuBufClear()			CPClear(CP_APL_IAC_BUF)
#define	CheckLenAplComuBuf(bs,ts)	CPCheckLength(CP_APL_IAC_BUF,bs,ts)
#define	ReadIDNameAplComu(name)		CPReadIDName(CP_APL_IAC_BUF,name)
#define	ReadBinAplComuBuf(b,l)		CPReadBin(CP_APL_IAC_BUF,b,l)
#define	ReadBinOffsetAplComu(b,l,o)	CPReadBinOffset(CP_APL_IAC_BUF,b,l,o)
#define	ReadTextAplComuBuf(b,l)		CPReadText(CP_APL_IAC_BUF,b,l)
#define	ReadTextOffsetAplComu(b,l,o)	CPReadTextOffset(CP_APL_IAC_BUF,b,l,o)
#define	WriteIDNameAplComu(name)	CPWriteIDName(CP_APL_IAC_BUF,name)
#define	WriteBinAplComuBuf(b,l)		CPWriteBin(CP_APL_IAC_BUF,b,l)
#define	WriteTextAplComuBuf(b,l)	CPWriteText(CP_APL_IAC_BUF,b,l)
#define	AppendBinAplComuBuf(b,l)	CPAppendBin(CP_APL_IAC_BUF,b,l)
#define	AppendTextAplComuBuf(b,l)	CPAppendText(CP_APL_IAC_BUF,b,l)

/* IACRg[f[^p */
#define	IACCtlBufClear()			CPClear(CP_APL_IAC_CTL_BUF)
#define	CheckLenIACCtlBuf(bs,ts)	CPCheckLength(CP_APL_IAC_CTL_BUF,bs,ts)
#define	ReadIDNameIACCtl(name)		CPReadIDName(CP_APL_IAC_CTL_BUF,name)
#define	ReadBinIACCtlBuf(b,l)		CPReadBin(CP_APL_IAC_CTL_BUF,b,l)
#define	ReadBinOffsetIACCtl(b,l,o)	CPReadBinOffset(CP_APL_IAC_CTL_BUF,b,l,o)
#define	WriteIDNameIACCtl(name)		CPWriteIDName(CP_APL_IAC_CTL_BUF,name)
#define	WriteBinIACCtlBuf(b,l)		CPWriteBin(CP_APL_IAC_CTL_BUF,b,l)
#define	AppendBinIACCtlBuf(b,l)		CPAppendBin(CP_APL_IAC_CTL_BUF,b,l)

#endif
