/***********************************************************************
<t@C>	comlog.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_COMLOG_H_INCLUDED
#define	_COMLOG_H_INCLUDED
/****************************************************************
	Ot@C[N
*****************************************************************/
#include        <sharpgen.h>
#include        <stdiozrs.h>

/*#########################################################################*/
/*                   M L ^ \    \  	                   */
/*#########################################################################*/
/*------< obt@TCY >------*/
#define  LIST_NAME_SIZE		(UINT)50	/* Xg\TCY	   */
#define  LOGLISTMAX		(UINT)20	/* Xgől	   */
#define  LISTVIEWMAX		(UINT)14	/* Xg\	           */
#define  TIME_STR_SIZE		(UINT)15	/* DOS^CX^vTCY */
#define  TIME_TYPE1_SIZE	(UINT)19	/* ԕϊ^CvPTCY  */
#define  NETNAMEMAX              (UINT)20        /* ڑ於TCY          */

/*------<     ߂l     >------*/
#define  TIME_SET_OK		(UCHAR)0	/* @2Q=@]L_	   */
#define  TIME_SET_NOT		(UCHAR)1	/* ^CZbg	   */
#define  TIME_SET_ERR		(UCHAR)2	/* ُI		   */

#define  CTGRY_SET_OK           (UCHAR)0	/* ڑ於	   */
#define  CTGRY_SET_NOT          (UCHAR)1	/* ڑ於	           */
#define  CTGRY_SET_ERR          (UCHAR)2	/* ُI		   */

#define  SEARCH_OK		(UCHAR)0	/* 		   */
#define  SEARCH_NOT		(UCHAR)1	/* s		   */
#define  SEARCH_ERR		(UCHAR)2	/* ُI		   */

/*------<     ̑     >------*/
#define  TIME_TYPE_1		(UCHAR)1	/* @2Q=@]L_ϊ[hP	   */

/*------<     ڑ     >------*/
#define  LOG_CTGRY_NIFT         (UCHAR)0
#define  LOG_CTGRY_BBS          (UCHAR)1
#define  LOG_CTGRY_TELNET       (UCHAR)2

/*------< ^CX^v\ >------*/

typedef struct {
  UCHAR  TimeStr[LIST_NAME_SIZE+1];
  UCHAR  TimeFlag;
} TIMEWORK;

/*------< ڑ於\ >------*/

typedef struct {
  UCHAR  NameStr[LIST_NAME_SIZE+1];
  UCHAR  NameFlag;
} NAMEWORK;

/*------< ʐML^\Ǘ\ >------*/
typedef struct {
    UCHAR   Num[LOGLISTMAX+1];			/* \[gԍ|C^	   */
    UINT    NumMax;			        /* f[^		   */
    NAMEWORK NameWork[LOGLISTMAX+1];            /* ڑ                  */
    TIMEWORK TimeWork[LOGLISTMAX+1];		/* ^CX^v\	   */
} COMVIEWWORK;


/*-------< Ot@C\ >------*/
typedef struct {
	UCHAR	Logging;	/* Ot@C ON/OFF */
	FILEHD	FileHandle;	/* t@Cnh		*/
	UCHAR	LogName[16];	/* Ot@C		*/
	UCHAR   LogCategory;    /* ڑ                       */
	UCHAR	temp[10];
	COMVIEWWORK   *ComViewWork;  /* ʐML^\Ǘ\          */
} LOGWRK, *LOGWRKPTR, **LOGWRKHD;


/*#########################################################################*/
/*                    O r  [ A [ \  p			   */
/*#########################################################################*/
/*------< f[^ʒup`  >------*/
#define LOGDATA_HEADER		"###;\xd"
#define LOGNAME_HEADER		"#01;"
#define LOGDATA_HEADER_SIZE	(USHORT)5
#define LOGNAME_HEADER_SIZE	(USHORT)4

#define TIME_KUGIRI_SIZE	(UINT)9
#define TIME_KUGIRI_CODE	0x20

#define NET_NAME_NIFT         "NIFTY   "
#define NET_NAME_BBS          "ݐYgc"
#define NET_NAME_TELNET       "TELNET  "

#define NET_NAME_SIZE         (USHORT)8

/*#########################################################################*/
/*                  t@CRg[	                           */
/*#########################################################################*/
/*=========================================================================*/
/*                         \@@́@@`				   */
/*=========================================================================*/

/*------< Ot@C >------*/
static const UCHAR LG_FileName[13] = "COM00.LOG";

LOGWRKHD ComLogEntry(USHORT ComLog, MESSAGE *Message, LOGWRKHD LogWrkHd);
LOGWRKHD ComLogConstruct(MESSAGE *Message);
void ComLogDestruct(MESSAGE *Message, LOGWRKHD LogWrkHd);
BOOLEAN ComLogNew(MESSAGE *Message, LOGWRKHD LogWrkHd);
BOOLEAN ComLogOpen(MESSAGE *Message, LOGWRKHD LogWrkHd);
BOOLEAN ComLogEnd(MESSAGE *Message, LOGWRKHD LogWrkHd);
BOOLEAN ComLogAddChar(MESSAGE *Message, LOGWRKHD LogWrkHd);
BOOLEAN ComLogWriteBlock(LOGWRK *LogWrk, UCHAR *BufPtr, USHORT BufLen);
BOOLEAN ComLogBS(LOGWRK *LogWrk);
void ComLog_GetTimeStamp(UCHAR *Buffer);
void ComLogGetFileName(LOGWRK *LogWrk);
BOOLEAN ComLogDeleteOLD(LOGWRK *LogWrk);
void LogCheckList(MESSAGE *Message, LOGWRKHD LogWrkHd);
#endif
