/***********************************************************************
<t@C>	editor.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_EDITOR_H_INCLUDED
#define	_EDITOR_H_INCLUDED
/***********************************************************************
		GfB^`
***********************************************************************/

#include	"sharpgen.h"
#include	"zdrawlib.h"

#define	PENATTR	0x04
#define	KEYATTR	0x04


/*
	GfB^[NXgN`
*/
#ifndef	_EDITWORK_DEFINED
typedef struct Editwork {
    UCHAR		Type;				/*S 0:1: 2:͑	*/
	UCHAR		InputType;			/* E̋󂫂𗘗pNXp[N	*/
	UCHAR		FrameDisp;			/* E̋󂫂𗘗pNXp[N	*/
    UCHAR		*BufTop;			/*S ܈ksnoAhX	      		*/
    USHORT		BufEnd;				/*S ܈kdmcAhX	      		*/
    USHORT		InputMaxSize;		/*S ͒}̍ő byte 	      		*/
    UCHAR		InputMinSize;		/*S ͒}̍ŏ byte 	      		*/
    USHORT		GuidEndAdr;			/*S ܉ۏb	      		*/
    UCHAR		DestinationColumn;	/*S ҏWΏۗ̈̌-1	      		*/
    USHORT		FramePositionX;		/*S ؈ς̍[ QPW x	      		*/
    USHORT		FramePositionY;		/*S ؈ς̍[ QPW y	      		*/
    USHORT		FrameSizeX;			/*S ؈ς̍[̑ QPW x   	*/
    USHORT		FrameSizeY;			/*S ؈ς̍[̑ QPW y   	*/
    UCHAR		FramePositionColumn;	/*  ؈ύ[ɑΉҏW    */
    short		FramePositionLine;	/*  ؈ύ[ɑΉҏWs    */
    UCHAR		FrameSizeColumn;	/*  \o錅-1		      		*/
    UCHAR		FrameSizeLine;		/*  \os-1		      		*/
    UCHAR		*LineTableAdr;		/*S sO		      			*/
    USHORT		DataEndAdr;			/*S }ے܉c1		      			*/
    UCHAR		CursorColumn;		/*  xTEXTW x		      			*/
    USHORT		CursorLine;			/*  xTEXTW y		      			*/
    char		CursorColumnSub;	/*  xTEXTW̕␳p      		*/
    USHORT		CursorAdr;			/*  xc		      			*/
    short		CursorOffset;		/*  xcp	      		*/
    USHORT		SelectAdr;			/*  ،Jnc	      			*/
    UCHAR		CursorModeOnChr;	/*S ㏑̋xw		      		*/
    UCHAR		CursorModeDataEnd;	/*S }ے܂̋xw		      		*/
    UCHAR		CursorModeInsert;	/*S }̋xw		      			*/
	WINDOWHD	WindowNo;			/*S \GcID		      		*/
    CDSPMODE	LcdMode;			/*S 쒆\̐ݒ	      	*/
    UCHAR		EditMode;			/*S 쏏      		*/
    UCHAR		EditMode2;			/*S 쏏      		*/
    UCHAR		EditMode3;			/*S 쏏      		*/
    UCHAR		PitchColumn;		/*S ԏlOQP)		      		*/
    UCHAR		PitchLine;			/*S sԏlOQP)		      			*/
    UCHAR		*EditTableAdr;		/*S ڈւ̗݉(13byte)  	*/
	UCHAR		SelectColumn;
	USHORT		SelectLine;
	COLOR		EdReverseColor;		/* ]F */
	COLOR		EdForeColor;		/* tHAOEhJ[ */
	COLOR		EdBackColor;		/* obNOEhJ[ */
	COLOR		EdCursorColor;		/* J[\tHAJ[ */
} EDITWORK;
#define	_EDITWORK_DEFINED
#endif

/*
	GfB^pi[XgN`
*/
#ifndef	_EDITINFO_DEFINED
typedef struct EditInfo {
    USHORT	AllDataNo;		/* Sf[^s				*/
    USHORT	DispDataNo;		/* \\s				*/
    USHORT	DispOffset;		/* \Jns				*/
    UCHAR	LastMode;		/* O̕ҏW			*/
    USHORT	Target1;		/* O̕ҏWeP			*/
    USHORT	Target2;		/* O̕ҏWeQ			*/
    USHORT	SelectStart;	/* ZNgJnʒu			*/
    short	SelectLength;	/* ZNgoCg			*/
    UCHAR	DataEmpty;		/* 0:f[^݂ 1:f[^	*/
} EDITINFO;
#define	_EDITINFO_DEFINED
#endif

/*
	tH[}bgGfB^[NXgN`
*/
#ifndef	_FORMATEDITWORK_DEFINED
typedef struct Formateditwork {
    UCHAR		Type;		   	/*S GfB^^Cv 2:tH[}bgGfB^  */
	UCHAR		InputType;		/* E̋󂫂𗘗pNXp[N(FEDIT ł͎gȂ) */
	UCHAR		FrameDisp;		/* E̋󂫂𗘗pNXp[N	*/
    UCHAR		*BufTop;	   	/*S obt@̂snoAhX		      */
    USHORT		BufEnd;	  	   	/*S obt@̂dmcAhX		      */
    USHORT		FramePositionX; /*S \؈ς̍[QPW x	      */
    USHORT		FramePositionY; /*S \؈ς̍[QPW y	      */
    UCHAR		CursorColumn;	/*  eړł̋xTEXTW x	      */
    USHORT		CursorColumnQP; /*  x QP W			      */
    USHORT		CursorAdr;	   	/*  ȟ̋xc؋k	      */
    USHORT		SelectQP;  	   	/*  ZNgJn QP W		      */
    WINDOWHD	WindowNo;	   	/*S \GcID		      */
    UCHAR		EditMode;	   	/*S \Ɠ̐ݒ	   *1 */
    UCHAR		PitchColumn;	/*S ԏlOQP)		      */
    UCHAR		EditItem;	   	/*  ݊c̍ڔԍ		      */
    UCHAR		SelectModeOn;	/*  ، 0:،Ȃ@1:،	      */
    USHORT		Width;		   	/*  \̕ipoj		      */
    USHORT		Height;		   	/*  ̍ipoj		      */
	COLOR	EdReverseColor;		/* ]F */
	COLOR	EdForeColor;		/* tHAOEhJ[ */
	COLOR	EdBackColor;		/* obNOEhJ[ */
	COLOR	EdCursorColor;		/* J[\tHAJ[ */
/*    UCHAR	*Itemp;		   		/*S ITEMWORK ... NULL		      */
} FORMATEDITWORK;
#define	_FORMATEDITWORK_DEFINED
#endif

/**************************** FORMATEDITWORK ****************************/
/* *1 bit 7   = J[\\[h					*/
/*	  6   = u_tO					*/
/*	  5   = u[htO					*/
/*	  4   = GfB^pytO				*/
/*	  3   = jڂ̕\[h(0:GfBbg\ 1:\̂)	*/
/*	  2   = ԍڂ̕\					*/
/*		0:12ԕ\ 1:24ԕ\				*/
/*	  1   = \̕Ox^]\ 0:Ox\ 1:]\		*/
/*	  0   = x\̎w						*/
/*		0:\Ȃ(\O) 1:\(cO)			*/
/************************************************************************/

/*
	tH[}bgGfB^̊eڃ[NXgN`
*/
#ifndef	_ITEMWORK_DEFINED
typedef struct Itemwork {
    UCHAR	Offset;		/*S obt@̃f[^ItZbg	  */
    UCHAR	Length;		/*S obt@̃f[^		  */
    USHORT	DispOffset;	/*  f[^̂poWwiItZbgj 	  */
    short		DataOffset;	/*S f[^̕ϊyу`FbN̋k	  */
    UCHAR	DispMode;	/*S f[^̕\[h		       *0 */
    UCHAR	Type;		/*S ڃ^Cv			       *1 */
    UCHAR	*DataDispIndex;	/*S f[^\l(type  MSB ON) *2 */
    UCHAR	Prefix;		/*S ړ̒			  */
    UCHAR	PrefixMode;	/*S ړ̕\[h	       *0 */
    UCHAR	Suffix;		/*S ڔ̒			  */
    UCHAR	SuffixMode;	/*S ڔ̕\[h	       *0 */
    UCHAR	Clear;		/*S NA̒		  */
    UCHAR	ClearMode;	/*S NA̕\[h	       *0 */
    UCHAR	*GuidData;	/*S ړAڔANA	       *3 */
} ITEMWORK;
#define	_ITEMWORK_DEFINED
#endif

#ifndef	_FEDITWORK_DEFINED
typedef struct FEditWork {
	FORMATEDITWORK	FWork;
	ITEMWORK		*ItemWork[1];
}FEDITWORK,*FEDITPTR,**FEDITHD;
#define	_FEDITWORK_DEFINED
#endif

/****************************** ITEMWORK ********************************/
/* *0 bit 7-4 = LN^TCY̎w					*/
/*		bit 7-4 R[h\c[̕TCYwƓl	*/
/*									*/
/* *1 eڂ̃^Cvݒ肵A̓e`FbNɎgp܂B	*/
/*	0:N(YEAR)DDDD1900 - 2099 (}data_offset)			*/
/*	1:(MONTH)DDDD  1 -   12					*/
/*	2:(DAY)DDDDD  1 -   31(A[NɂA͈͂ς܂)*/
/*	3:(HOUR)DDDDD   0 -   12 or  0 -  23 (12<->24 ̐ݒɂ)*/
/*	4:(MINUTE)DDDD   0 -   59					*/
/*	5:b(SECOND)DDDD   0 -   59					*/
/*	6:j(WEEK)DDDD   0 -    6					*/
/*	7:u(CALC)DDDD   0 - t[̌			*/
/*	8:`l^ol(AM_PM)  0 -    2(0:\ȂA1:AM\A2:PM\)	*/
/*	9:TDDDDDDDD   1 - 5 iPT[TTj			*/
/*	eڂ̂lrairbgVjnm̏ꍇACfbNX񂪂	*/
/*									*/
/* *2 ef[^ 0dh ŋ؂A00hŏIB				*/
/*    j@"",0dh,"",0dh,"",0dh...,"y",00h			*/
/*	    f[^ 01h ̏ꍇA\B				*/
/*    j@eCfbNXf[^́A\ꂽꍇɁAipoj	*/
/*	    Ȃ悤ɃZbgB					*/
/*									*/
/* *3 ef[^ 0dh ŋ؂A00hŏIB				*/
/*    j@"",0dh,"N",0dh,"H",00hA@0dh,"N",0dh,"H",00h	*/
/*									*/
/************************************************************************/

/*
	tH[}bgGfB^pi[XgN`
*/
#ifndef	_FORMATEDITINFO_DEFINED
typedef struct FormatEditInfo {
    UCHAR	*ItemInfo;	/* eڏւ̃|C^		*/
} FORMATEDITINFO;
#define	_FORMATEDITINFO_DEFINED
#endif

#ifndef	_ITEMINFO_DEFINED
typedef struct ItemInfo {
    UCHAR	Status;		/* 0:J[\ȂAx:xԖڂɃJ[\ */
						/* -1:f[^Ɍ肪			*/
    UCHAR	*Bdata;		/* ̓f[^itH[}bgj	*/
    UCHAR	*Cdata;		/* ̓f[^i`rbhhf[^j	*/
} ITEMINFO;
#define	_ITEMINFO_DEFINED
#endif

/* checkstatus t@NVp */
#ifndef	_FEDITINFO_DEFINED
typedef struct FEditInfo {
    ITEMINFO	*ItemInfo[1];	/* eڏւ̃|C^		*/
} FEDITINFO;
#define	_FEDITINFO_DEFINED
#endif

FEDITINFO *GetFEditInfoWork(USHORT ItemNo);

#ifndef _FORMATEDITWORK2_DEFINED
typedef	struct	Formateditwork2{
	FORMATEDITWORK	Fed_wk;
	UCHAR	*Itemp;
} FORMATEDITWORK2;
#define	_FORMATEDITWORK2_DEFINED
#endif

/*
	bZ[Wɑ΂ǉiGfB^ŗL̂́j
*/

/*
	̑߂ĒA܂͊mFl
	̓pbh̃L[̃wb_[𒸂

CODE_C_CE
CODE_12_24
CODE_COLON
CODE_SRASH
CURSOR_UP
CURSOR_DOWN
CURSOR_LEFT
CURSOR_RIGHT
*/



	/*@GfB^^CvmTypen*/

#define	NORMAL_EDITOR		0x00		/*@ʏGfB^[@*/
#define	SPECIAL_EDITOR		0x01		/*@GfB^[@*/
#define	FORMAT_EDITOR		0x02		/*@tH[}bgGfB^[@*/


	/*@J[\wmCursorModeOnChr, CursorModeDataEnd, CursorModeInsertn*/

/*@(bit7-4) O@*/
/*@(bit3)uN̗L@*/
#define	NON_BLINK		0x00		/*@uNȂ@*/
#define	BLINK			0x08		/*@uN@*/
/*@(bit2-0)J[\̃^Cv@*/
#define	NON_CURSOR		0x00		/*@J[\Ȃ@*/
#define	LINE1_CURSOR		0x01		/*@A_[CJ[\iPhbgj@*/
#define	LINE2_CURSOR		0x02		/*@QdA_[CJ[\iQhbgj@*/
#define	BOX_CURSOR		0x03		/*@^ix^j@*/
#define	SPACE_CURSOR		0x04		/*@Xy[Xix^j@*/
#define	USER_CURSOR		0x05		/*@[U[`J[\@*/
#define	INSERT_CURSOR		0x06		/*@}}[N@*/


	/*@\̐ݒmLcdModen*/
	/*@\[h̐ݒmDispMode,PrefixMode,SuffixMode,ClearModen*/

/*@(bit7-4)LN^TCY̎w@*/
#ifndef	CHAR_SIZE_32QP
#define	CHAR_SIZE_32QP		0x20		/*@RQpoiWhbgj@*/
#endif
#ifndef	CHAR_SIZE_48QP
#define	CHAR_SIZE_48QP		0x40		/*@SWpoiPQhbgj@*/
#endif
#ifndef	CHAR_SIZE_64QP
#define	CHAR_SIZE_64QP		0x60		/*@USpoiPUhbgj@*/
#endif
/*@(bit3) O@*/
/*@(bit2)\̔]w@*/
#define	DISP_NORMAL		0x00		/*@m[}\@*/
#define	DISP_REVERSE		0x04		/*@]\w@*/
/*@(bit0) O@*/


	/*@̐ݒmEditModen*/

/*@(bit7)obt@tɂȂƂ̃f[^GhɂJ[\̎w@*/
#define	CURSOR_ON_LAST_DATA	0x00		/*@ŏIf[^@*/
#define	CURSOR_ON_DATA_END	0x80		/*@f[^GhɂQdJ[\@*/
/*@(bit6) O@*/
/*@(bit5)XN[f[h̎w@*/
#define	SCROLL_NON_INT		0x00		/*@XN[ŒfȂ@*/
#define	SCROLL_INT		0x20		/*@XN[Œf@*/
/*@(bit4)ZNgPʂ̎w@*/
#define	CHAR_SELECT		0x00		/*@PʂŃZNg@*/
#define	LINE_SELECT		0x10		/*@sPʂŃZNg@*/
/*@(bit3)\V{n^n̎w@*/
#define	SYMBOL_NON_ACCESS	0x00		/*@V{ANZXȂ@*/
#define	SYMBOL_ACCESS		0x08		/*@V{On/Off@*/
/*@(bit2)}[N\̎w@*/
#define	MARK_NON_DISP		0x00		/*@}[N\Ȃ@*/
#define	MARK_DISP		0x04		/*@s}[N\@*/
/*@(bit1)}[h̎w@*/
#define	OVER_WRITE		0x00		/*@㏑[h@*/
#define	INSERT			0x02		/*@}[h@*/
/*@(bit0)J[\\̎w@*/
#define	CURSOR_NON_DISP		0x00		/*@J[\\Ȃi\[hj@*/
#define	CURSOR_DISP		0x01		/*@J[\\iGfBbg[hj@*/


	/*@Q̐ݒmEditMode2n*/

/*@(bit7) O@*/
/*@(bit6)}ɂobt@ڂ̎w@*/
#define	BUF_OVER_ERROR		0x00		/*@ڂ֎~@*/
#define	BUF_OVER_ALLOW		0x40		/*@ڂ@*/
/*@(bit5)ZNgobt@̎w@*/
#define	SELBUF_MODIFY		0x00		/*@ύX@*/
#define	SELBUF_NON_MODIFY	0x20		/*@ύXȂ@*/
/*@(bit4)\Isȍ~̃NAw@*/
#define	CONTINUOUS_CLEAR	0x00		/*@NA@*/
#define	CONTINUOUS_NON_CLEAR	0x10		/*@NAȂ@*/
/*@(bit3)f[^sɑ΂XN[̎w@*/
#define	SCROLL_UP_BOTTOM	0x00		/*@LȂ@*/
#define	SCROLL_UP_TOP		0x08		/*@f[^擪sɂȂ܂ŃXN[@*/
/*@(bit2)f[^擪sɑ΂XN[̎w@*/
#define	SCROLL_DOWN_TOP		0x00		/*@LȂ@*/
#define	SCROLL_DOWN_BOTTOM	0x04		/*@f[^擪ŉsɂȂ܂ŃXN[@*/
/*@(bit1)f[^sɉJ[\̎w@*/
#define	CURSOR_NON_MOVE		0x00		/*@LȂ@*/
#define	CURSOR_MOVE_END		0x02		/*@sɉāAJ[\L[ŃJ[\f[^GhɈړ */	/*@(bit0)f[^擪sɉJ[\̎w@*/
/* #define	CURSOR_NON_MOVE		0x00		/*@LȂ@*/
#define	CURSOR_MOVE_TOP		0x01		/*@擪sɉāAJ[\L[ŃJ[\f[^gbvɈړ@*/

	/*@R̐ݒmEditMode3n*/
/*@(bit7-2) O@*/
/*	(bit5)GfB^̘g̕\ */
/* NX̌gƂ̂ݗL */
#define	E_FRAME_DISP	0x20	/*	\ */
#define	E_FRAME_NON_DISP	0	/*	\Ȃ */
/*@(bit1)u[h̎w@*/
#define	CHAR_REPLACE		0x00		/*@PʂŒu@*/
#define	LINE_REPLACE		0x02		/*@sPʂŒu@*/
/*@(bit0)J[\ړƃXy[X}̎w@*/
#define	CURSOR_MOVE_ON_DATA	0x00		/*@f[^݈̂ړł@*/
#define	CURSOR_MOVE_FREE	0x01		/*@f[^OւړłAXy[X̎␳sȂ@*/



/*======================================*/
/*@se[umeŊmہn	*/
/*======================================*/
/*@ҏWΏۗ̈̍s{P̂Q{̑傫̃obt@B	*/
/*@(ex)@sRŝƂ@				*/
/*@		(3+1)*2=8 [Bytes]			*/



	/*@ڃ^Cv̐ݒmTypen*/

#define	YEAR		0x00		/*@N(1990-2099)@*/
#define	MONTH		0x01		/*@(1-12)@*/
#define	DAY			0x02		/*@(1-31)@*/
#define	HOUR		0x03		/*@(0-12, 0-23)@*/
#define	MINUTE		0x04		/*@(0-59)@*/
#define	SECOND		0x05		/*@b(0-59)@*/
#define	INDEX		0x06		/*@CfbNX(CfbNXf[^[P)@*/
#define	NUMBER		0x07		/*@u(t[̌)@*/
#define	AMPM		0x08		/*@`l^ol(0:\Ȃ 1:`l\ 2:ol\)@*/
#define WEEK		0x09		/*@TiPT[TTj@*/

	/*@\Ɠ̐ݒmEditModen*/

/*@(bit7-3) O@*/
/*	(bit5)tH[}bgGfB^̘g̕\ */
/* NX̌gƂ̂ݗL */
#define	FE_FRAME_DISP	0x20	/*	\ */
#define	FE_FRAME_NON_DISP	0	/*	\Ȃ */
/*	feditobj.c ̒bit7,4 ͎gpĂ͗p */
/*@(bit3)ԍڂ̕\̎w@*/
#define	TIME12		0x00		/*@PQԕ\@*/
#define	TIME24		0x08		/*@QSԕ\@*/
/*@(bit2)\]̎w@*/
/*@(bit1)u[h̎w@*/
/*@(bit0)J[\\̎w@*/


/*==============================*/
/*@bZ[W̃p[^	*/
/*==============================*/

	/*@CHANGE12_24 bZ[W TimeMode@*/
	/*@PQ^QSԐ̎w@*/

#define	TIME24MODE	0x00		/*@QSԐ@*/
#define	TIME12MODE	0x01		/*@PQԐ@*/

/*	GfB^̕ */
/* ӁI edcharobj.s Œ`Ă̂ɏڂł
   ܂ŕ̓xƂĊOɂ݂ĂȂ̂H */
#define	key_kanji	(UCHAR)0x80
#define	key_symbol	(UCHAR)0x40
#define	key_hiragana	(UCHAR)0x20
#define	key_katakana	(UCHAR)0x10
#define	key_alphabet	(UCHAR)0x08
#define	key_numeric		(UCHAR)0x04
#define	key_hankaku		(UCHAR)0x02
#define	key_zenkaku		(UCHAR)0x01
#endif
