#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _MUTILH_
#define _MUTILH_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#define ISSPACE(c)  ((c == ' ') || (c == '\t'))
#define ISASCII(c)  (('\0x0' <= c && c <= '\0x7f') ? true : false)
#define ISUPPER(c)  (('A' <= c && c <= 'Z') ? true : false)
#define ISLOWER(c)  (('a' <= c && c <= 'z') ? true : false)
#define ISDIGIT(c)  ('0' <= c && c <= '9')
#define TOLOWER(c)  ( c - 'A' + 'a')
#define TOUPPER(c)  ( c - 'a' + 'A')

#define sprint_sds(d,s1,num,s2)		StrCopy(longToAscii(num, StrCopy(d,s1)),s2)
#define sprint_ssd(d,s1,s2,num)		longToAscii(num, StrCopy(StrCopy(d,s1),s2))
#define sprint_scs(d,s1,c,s2)		StrCopy(CharCopy(StrCopy(d,s1), c), s2)
#define sprint_sss(d,s1,s2,s3)		StrCopy(StrCopy(StrCopy(d,s1),s2), s3)

typedef struct {
	int	fd;
	int (* sessionAbort)(void);		/* Test abort key, ppp connection, ... */
	int aborted;		/* Mail session aborted */
	char *readBuf;		/* Read buffer address */
	int readBufSize;	/* Size of read buffer */
	char *readBufPtr;	/* Pointer into read buffer */
	int readCount;		/* Bytes left in read buffer */

	char *writeBuf;		/* Read buffer address */
	int writeBufSize;	/* Size of read buffer */

	char *respBuf;		/* save command response */
	int respBufSize;	/* Size of response buffer */
} BulkBuf;


extern int FusionSocketErr;

/*  for debug */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
void Log(char *s1, char *s2);
/*  log(fmt, x1, x2, x3, x4, x5, x6); */


/* Function proto-type */

void QueueDelete( OBJECT_NAME q );

int asciiToLong(char *s);
/* void lonToAscii(int num, char *s); */
char *StrChar (char *s, char ch);
char *StrRevChar (char *s, char ch);
char *StrCopy (char *s1, char *s2);
char * CharCopy (char *d, char c);
int sulncmp (char *s1, char *s2, int len);
char *longToAscii( int num, char *s );
void _longToAscii( int num, char **cp );

char * control ( char c );
char uncontrol ( char * arg );

int gsbyname (char *name);
int getsocktypebyname (char *name);

int get_connect (char *host, char *service, int role);
int tcp_connect (unsigned long ipaddr, int port, int role, int nonblock);
int getByte(BulkBuf *buf, char *outchar);
/* int getByte(int fd, char *outchar); */
int sulcmp (char *s1, char *s2);
void toucase (char *line);

void InitMutil(void);
END_EXTERN_C                /* C++ support  99/9/8 */
/* End of myutil.h */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _MUTILH_ */
