/***********************************************************************
<t@C>	menulib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		j[\[X[eBeBQ
***********************************************************************/
#ifndef MENU_LIB_H_INCLUDED
#define	MENU_LIB_H_INCLUDED

#include <sharpgen.h>
#include <button.h>
#include <zdrawlib.h>
#include <iconmenu.h>

/* VXej[\[X\ */
#define	MRES_MENU_ID		0
#define	MRES_ITEM_TYPE		(MRES_MENU_ID+2)
#define	MRES_DISP_DATA_LEN	(MRES_ITEM_TYPE+1)
#define	MRES_DISP_DATA		(MRES_DISP_DATA_LEN+1)

/* ݊p */
#define	MRES_MenuID			MRES_MENU_ID
#define	MRES_ItemType		MRES_ITEM_TYPE
#define	MRES_DispDataLen	MRES_DISP_DATA_LEN
#define	MRES_DispData		MRES_DISP_DATA

/* ACRڂ̌Œ蒷 */
#define	MRES_ICON_DATA_LEN	11

/* j[ڃ^Cv */
#define	MITYPE_STRING			0x80
#define	MITYPE_SUBMENU			0x40
#define	MITYPE_WITH_ICON		0x20
#define	MITYPE_ICON				0x10
#define	MITYPE_PAGE_END			0x01

#define	MITYPE_GROUP_END		0x02

/* j[Agr[g */
#define	MATTR_DISABLE		(D_LIGHT_BUTTON+NO_SELECT_BUTTON)
#define	MATTR_CHECK_ON		0x01

/* ACR\^Cv̕擪 */
#ifndef H2EQU
#define	MRES_IC_DISP_DATA	(MRES_DISP_DATA+sizeof(RESOURCE))
#endif H2EQU

/* t@NVԍ */
#define	NEXT_MENU_ITEM_TOP	0x41
#define	GET_MENU_ITEM_TOP	0x42
#define	GET_MENU_ICON		0x43
#define	INSERT_MENU_ITEM	0x44
#define	DELETE_MENU_ITEM	0x45
#define	MODIFY_MENU_ITEM	0x46
#define	COUNT_MENU_ITEM		0x47

#define	MENU_UTIL_LAST_FUNC	COUNT_MENU_ITEM

/* ֐` */
UCHAR *NextMenuItemTop(UCHAR *MenuList);
UCHAR *GetMenuItemTop(UCHAR *MenuList,USHORT MenuID);
ICONDATA *GetMenuIcon(UCHAR *MenuList);
BOOLEAN	InsertMenuItem(HANDLE MenuListHd,USHORT MenuID,UCHAR *IMenu);
BOOLEAN DeleteMenuItem(HANDLE MenuListHd,USHORT MenuID);
BOOLEAN ModifyMenuItem(HANDLE MenuListHd,USHORT MenuID,UCHAR *MMenu);
USHORT CountMenuItem(UCHAR *MenuList);
BOOLEAN ReplaceMenuStr(ICONMENUWORK *IMWork,USHORT No,UCHAR *SrcStr);

/* }N */
#ifndef H2EQU
#define	GetMenuID(ml)		(GetWFromBArray((ml)+MRES_MENU_ID))
#define	GetMenuItemType(ml)	(*((ml)+MRES_ITEM_TYPE))
#define	GetMenuStrTop(ml)	\
((GetMenuItemType(ml)&MITYPE_WITH_ICON)?	\
 (ml)+MRES_IC_DISP_DATA : (ml)+MRES_DISP_DATA)

#endif H2EQU

#endif
