/***********************************************************************
<t@C>	optmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/


#ifndef	_OPTMSG_H_INCLUDED
#define	_OPTMSG_H_INCLUDED
	/* IvṼbZ[W */

/* bZ[W */

struct	OPT_SEND	/* */
{
	USHORT	MessageID;	/*  OptSendID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	Mode;		/*@Mf[^Ώێށ@*/
	UCHAR	Machine;	/*@@  */
	USHORT	MachineAplAid;	/*@@ɂAvw@*/
	USHORT	TransMethod;	/*@M@uړorʁvw*/
	APLID	AplID;		/* AvID */
/* ^ */
	UCHAR	*FileName;	/*@o̓t@C@*/
	UCHAR	*DTMFileName;	/*@hmcdwt@C@*/
	USHORT	FirstIndexNo;	/*@Mf[^̐擪CfNXio@*/
	USHORT	LastIndexNo;	/*@Mf[^̍ŏICfNXio@*/
	UCHAR	ExFlg;		/*@gO
			̃tOȍ~̃oLǂB0:,1:L*/
	UCHAR	ExMode;		/*@g[h
					Ո[o^uړʂvw*/
/* ^ */
};


struct	OPT_RECEIVE	/* */
{
	USHORT	MessageID;	/*  OptReceiveID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	Machine;	/*@@  */
	USHORT	TransMethod;	/*@M@uoruvw@*/
	APLID	AplID;		/* AvID */
/* ^ */
	UCHAR	*pInputCsvFileName;	/*@̓t@C@*/
	UCHAR	*pOutputDrvName;	/*@o̓t@C@*/
	UCHAR	*RecvLastBoxFile;	/*@ŌɎMf[^BoxFile@*/
	UCHAR	*FileName;	/*@̓t@C@*/
	UCHAR	*DTMFileName;	/*@anwt@C@*/
	UCHAR	Mode;	/*@[h  */
/* ^ */
};

struct	OPT_TRANS	/* @\ʕ */
{
	USHORT	MessageID;	/*  OptSendID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	Mode;		/*@of[^Ώێށ@*/
	USHORT	SdTrnsMethod;	/*@o@uړorʁvw*/
	USHORT	RvTrnsMethod;	/*@󂯑@uuorǉvw*/
	APLID	AplID;		/* AvID */
};
struct	OPT_GKN_SEND
{
	USHORT	MessageID;	/*  OptGknSendID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*DTMFileName;	/*@hmcdwt@C@*/
	USHORT	FirstIndexNo;	/*@Mf[^̐擪CfNXio@*/
};

struct	OPT_GKN_RECEIVE
{
	USHORT	MessageID;	/*  OptGknReceiveID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*DTMFileName;	/*@anwt@C@*/
};

struct	OPT_PRINT	/* */
{
	USHORT	MessageID;	/*  OptPrintID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*DTMFileName;	/*@hmcdwt@C@*/
	USHORT	FirstIndexNo;	/*@Mf[^̐擪CfNXio@*/
	USHORT	LastIndexNo;	/*@Mf[^̍ŏICfNXio@*/
	USHORT	Printer;	/*  v^@  */
	USHORT	Mode;		/*@󎚂f[^Ώێށ@*/
};

struct	OPT_CONTROL
{
	USHORT	MessageID;	/*  OptControlID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	Mode;		/*@[h@*/
	UCHAR	*DTMFileName;	/*@hmcdwt@C@*/
	USHORT	FirstIndexNo;	/*@Mf[^̐擪CfNXio@*/
	USHORT	LastIndexNo;	/*@Mf[^̍ŏICfNXio@*/
};

struct	OPT_WP_SEND
{
	USHORT	MessageID;	/*  OptWPSendID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	Mode;		/*@[h@*/
	UCHAR	*DTMFileName;	/*@hmcdwt@C@*/
	UCHAR	*FileName;	/*@o̓t@C@*/
	USHORT	FirstIndexNo;	/*@Mf[^̐擪CfNXio@*/
	USHORT	DataNum;	/*@Mf[^̌@*/
	UCHAR	Machine;	/*@@  */
};

struct	OPT_WP_RECEIVE
{
	USHORT	MessageID;	/*  OptWPReceiveID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	Mode;		/*@[h@*/
	UCHAR	*DTMFileName;	/*@anwt@C@*/
	UCHAR	*FileName;	/*@̓t@C@*/
	UCHAR	Machine;	/*@@  */
};


/* bZ[W */

struct	OPT_FINISHED	/* */
{
	USHORT	MessageID;	/* OptFinishedID */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	LastCardID;	/* MŌ̃J[hhc */
	UCHAR	*RecvLastBoxFile;	/*@ŌɎMf[^BoxFile@*/
};

struct	OPT_STOPPED	/* */
{
	USHORT	MessageID;	/* OptStoppedID */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	LastCardID;	/* MŌ̃J[hhc */
	UCHAR	*RecvLastBoxFile;	/*@ŌɎMf[^BoxFile@*/
};

struct	OPT_SYSTEM_ERROR
{
	USHORT	MessageID;	/* OptSystemErrorID */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	OPT_RETURNED
{
	USHORT	MessageID;	/* OptReturnedID */
	USHORT	OccuredTime;	/*  ^C~O  */
};

/************************************************/
/*@IvVbZ[Whc̒`		*/
/*	͈́F@SWOO`SWXX		*/
/*	͈́F@SXOO`SXXX		*/
/************************************************/

	/* bZ[W */
#define	OptSendID		4800
#define	OptReceiveID		4801
#define	OptGknSendID		4802
#define	OptGknReceiveID		4803
#define	OptPrintID		4804
#define	OptControlID		4805
#define	OptWPSendID		4806
#define	OptWPReceiveID		4807
#define	OptTransID		4808

	/* bZ[W */
#define	OptFinishedID		4900
#define	OptStoppedID		4901
#define	OptSystemErrorID	4902
#define	OptReturnedID		4903
#define	OptFinNoAddID		4904
#define	OptStpChgDataID		4905
#define	OptCancelID		4906
#define	OptCpyAddID		4907
#define	OptCpyRepID		4908
#define	OptMovAddID		4909
#define	OptMovRepID		4910

#endif

