/***********************************************************************
<t@C>	pioresume.h

	Copyright (c) 1995-1999 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-EX1
***********************************************************************/

#ifndef	_PIO_RESUME_H_INCLUDED

#include <pio.h>
#include <picoprop.h>
#include <pioimage.h>
#include <su_lfont.h>

/*======================================================================
		W[`
======================================================================*/
typedef struct PIODBRESUME {
	UCHAR			version;		/* 0x10 */
	PIOITEMNO		sortKeyItemNo;	/* \[gL[ID(1-) */
	UCHAR			isAscendent;	/* (true) or ~(false) */
	CATEGORYID		categoryId;		/* i荞ݒ̃JeS[ID */
	CARDID			cardId;			/* ڂĂJ[hID */
	UCHAR			isEdit;			/* ҏWǂ */
	PIOIMGITEMNO	imgItemNo;		/* ډ摜_ԍ */
	ULONG			editPlugName;	/* ҏWvOC */
	CARDID			editCardId;		/* ҏWJ[hID */
	PIOIMGITEMNO	editImgItemNo;	/* ҏW摜_ԍ */
	LFONTSIZE		listFontSize;	/* XgtHgTCY */
	LFONTSIZE		viewFontSize;	/* ڍׁ^ҏWtHgTCY */
	UCHAR			reserved1;
	UCHAR			reserved2;
	PICOVIEWMODE	listVType;		/* PICOXgr[^Cv */
	PICOVIEWMODE	viewVType;		/* PICOr[r[^Cv */
} PIODBRESUME;

#define	PIO_DB_RESUME_ITEM	"DBRS"

/*======================================================================
		}CRecAvP[Vp[^͗p[N
======================================================================*/
typedef struct ZPINAPPPARAM {
	UCHAR		*params;			/* p[^`Nobt@ */
	UCHAR		*boxFName;			/* BOXt@C */
	USHORT		boxFNameLen;
	CARDID		cardId;
	ITEMNAME	titleItem;
	UCHAR		*titleStr;
	USHORT		titleStrLen;
	UCHAR		*driveStr;
	USHORT		driveStrLen;
	UCHAR		*dbName;
	USHORT		dbNameLen;
	PIODBID		dbId;
	UCHAR		*ctgrTitleStr;
	USHORT		ctgrTitleLen;
	CATEGORYID	ctgrId;
	UCHAR		imgItemNo;
	USHORT		screenId;
	ULONG		plugName;
	/* ւ̒ǉ͉(Av̍\ō̂͋֎~ */
	UCHAR		*searchCond;
	USHORT		searchCondLen;
	USHORT		searchMode;
} ZPINAPPPARAM;

/*======================================================================
		֐錾
======================================================================*/
PIOERR
PioDbListGetResumeInfo(PIODBLIST *dbList,
					   PIODBLISTID itemNo,PIODBRESUME *resumeInfo);
PIOERR
PioDbListSetResumeInfo(PIODBLIST *dbList,
					   PIODBLISTID itemNo,PIODBRESUME *resumeInfo);
ZPINAPPPARAM*
PioParsePinAppParam(void);

#define	_PIO_RESUME_H_INCLUDED
#endif	/* _PIO_RESUME_H_INCLUDED */
