/***************************************************************************/
/* pppcmn.h	PPP Common Header			                   */
/*-------------------------------------------------------------------------*/
/* ppp.hƂƂincludeꍇppp.hinclude悤ɂĉ    */
/***************************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _PPPCMN_
#define _PPPCMN_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#define	NOIPADDR		0x00000000L
#define RESULT_OFFSET		10
#define ASYNC_OFFSET		20
enum eventenum {
	EVENT_NONE,
	EVENT_INIT,
	EVENT_OPEN,
	EVENT_CLOSE,
	EVENT_DOWN,
	EVENT_SETSTATUS,
	EVENT_CHKTCPIP,
	EVENT_SETASYNCQ,			/* No Result */

	EVENT_INITRESULT = EVENT_INIT + RESULT_OFFSET,
	EVENT_OPENRESULT,
	EVENT_CLOSERESULT,
	EVENT_DOWNRESULT,
	EVENT_SETSTATUSRESULT,
	EVENT_CHKTCPIPRESULT,

	EVENT_CLOSED = ASYNC_OFFSET + 1,
	EVENT_LQR
};

typedef struct qevent {
	enum eventenum	eventtype;
	OBJECT_NAME 	resultqueue;
	int		parameter;
} qevent;

#ifndef MAX_STATES
#define MAX_STATES	    16	/* vjcdefs.hŒ`Ă܂   */
#endif				/* ύX̏ꍇӂKvł	 */

#ifndef _PPP_			/* ppp.hłl̒`Ă܂ */
				/* ύX̏ꍇӂKvł	 */
#define PPP_LCPLAYER	    0
#define PPP_IPCPLAYER	    1
#define PPP_PAPLAYER	    2
#define NUM_PPP_LAYERS	    3

#define PPP_LCPPACKET	    0				
#define PPP_IPCPPACKET	    1				
#define PPP_PAPPACKET	    2				/*                  */
#define PPP_IPPACKET	    3				/*                  */
#define PPP_UNKNOWNPACKET   4				/*                  */
#define NUM_PACKETTYPE	    5				/*                  */

#define MAX_NEGOT	    64
#define LCP_MIN_MTU	    256
#define LCP_DEF_MTU	    1500

#define LCP_MAX_MTU	    LCP_DEF_MTU
/* 
#define LCP_MAX_MTU	    2048
*/
#define LCP_PASSAUT	    0xc023
#define LCP_CHALHS	    0xc223
#define IPCP_VANJAC	    0x002d

typedef struct {
    u8  ppp_address;
    u8  ppp_control;
    a16 ppp_protocol;
    } ppph;

typedef struct {
    u8  lcp_code;
    u8  lcp_id;
    a16 lcp_len;
    } lcph;

typedef struct {
    u8  ipcp_code;
    u8  ipcp_id;
    a16 ipcp_len;
    } ipcph;

typedef struct {
    u8  pap_code;
    u8  pap_id;
    a16 pap_len;
    } paph;

typedef struct {
    u16 maxmru;
    u32 asynctl;
    u16 authpro;
    u16 qualpro;
    u32 magic;
    u8  procomp;
    u8  addcomp;
    } lcpconfig;

typedef struct {
    u16 comprot;
    u32 ipaddrs;
    u8  maxslot;
    u8  comslot;
    } ipcpconfig;

typedef struct wantflag {			
	int 		maxmru;			/* őMpPbgTCY */
	int	 	asynctl;		/* LN^}bsO */
	int 		authpro;		/* F؃vgR */
	int 		qualpro;		/* Nj^ij */
	int 		magic;			/* }WbNio[ij */
	int 		procomp;		/* vgRtB[hk */
	int 		addcomp;		/* AhXtB[hk */
	int		ipaddrs;		/* IPAhX */
	int 		comprot;		/* kvgR */
	int 		maxslot;		/* VJk̍őXbg */
	int 		comslot;		/* VJk̃XbgID̈k */
} wantflag;

typedef struct {
    u8 terminate;
    u8 configure;
    u8 failure;
} pppretries;

typedef struct pppevent {
    u8      ppp_event;
    u8      ppp_layer;
    void *  ppp_mp;
} pppevent;

#endif

typedef struct pspstatusT {			
        void            * ppp_ndp;	    	
        int             ppp_CompressOn;
        int             ppp_chn; /* Cman channel */
        u8              ppp_state[NUM_PPP_LAYERS];
        u8              ppp_status[NUM_PPP_LAYERS];
        lcpconfig       ppplcp_theirconfig;
        lcpconfig       ppplcp_myconfig;
        lcpconfig       ppplcp_negotconfig;
        ipcpconfig      pppipcp_theirconfig;
        ipcpconfig      pppipcp_myconfig;
        ipcpconfig      pppipcp_negotconfig;
	wantflag	pppmyflag;
	wantflag	ppptheirflag;
        u8              ppplcp_id;
        u8              ppppro_id;
        u8              pppipcp_id;
        u8              ppppap_id;
        u32             ppplcp_ramerr;
        u32             pppipcp_ramerr;
        u8              ppp_evin;
        u8              ppp_evout;
	u32		ppprestart;
        pppretries      pppretry[NUM_PPP_LAYERS];
        pppevent        ppp_events[256];
        u32             pppmaxterminate;
        u32             pppmaxconfigure;
        char            pap_user[32];
        char            pap_passwd[32];

	int 		getipaddr;		/* IPAhX擾@ */
	u8 		authsecret;		/* ÍpX[h̎gp */

	int		rcvcount[NUM_PACKETTYPE];	/* LCPMpPbg */
	int		sndcount[NUM_PACKETTYPE];	/* LCPMpPbg */
	int		badfcscount;		/* PPPMG[JE^ */

	int		execevent;		/* Event Type */
	OBJECT_NAME 	resultqueue; 		/* ԂL[ */
	int		parameter;		/* p[^ */
	int		asyncevent;		/* 񓯊Cxg */
	int		asyncparam;		/* 񓯊p[^ */

	int		dcd_flag;		/* DCDtO */
	int		dsr_flag;		/* DSRtO */
	int		comm_status;		/* M̏ */
	int		dcd_count;		/* DCD̃JE^ */
	int		dsr_count;		/* DSR̃JE^ */
} pspstatusT;

typedef struct pppcommon {
	/* Config ParameteriApplicationݒj */
	/* TCP/IPݒȂ */
	char 		devname[5];		/* foCX */
	void *		commdevP;		/* COMMDEṼ|C^ */
	unsigned int	max_socket;		/* \Pbg */
	unsigned long 	ipaddr;			/* IPAhX */
	unsigned long 	netmask;		/* lbg}XN */
	int 		mtu;			/* ő呗MpPbgTCY */
	unsigned long 	defrooterip;		/* ftHg[^IP */
	char 		ethernetaddress[6];	/* C[TlbgAhX */
	int 		getipaddr;		/* IPAhX擾@ */
	int 		getnetmask;		/* lbg}XN擾@ */
	/* @ˑ@PPPڑ̐ݒ  */
	lcpconfig	mylcp;
	ipcpconfig	myipcp;
	wantflag	myflag;
	/* @ˎ@PPPڑ̐ݒ */
	lcpconfig	theirlcp;
	ipcpconfig	theiripcp;
	wantflag	theirflag;
	/* F؂Ɋւݒ */
	int 		authsecret;		/* ÍpX[h̎gp */
	char 		userid[32]; 		/* Fؗp[U[ID */
	char 		passwd[32];		/* FؗppX[h */
	/* ^C}[^đ֌W̐ݒ */
	int 		ppprestart;		/* PPP^CAEg */
	int 		pppretryconfigure;	/* Configure-Requestđ */
	int 		pppretryterminate;	/* Terminate-Requestđ */
	int 		idle_timeout;		/* ACh^CAEg */
	/* Ɋւݒ */
	int 		flow_control;		/* n[ht[Rg[ */
	int 		dcd_flag;		/* DCD̎gp */
	int 		dsr_flag;		/* DSR̎gp */

	/* Status ParameteriManagerݒj */
	int 		mangversion;		/* }l[Wo[W */
	int 		pppversion;		/* pppfsmo[W */
	pspstatusT 	pspstatus;		/* PPPXe[^X */
	char 		debugstrings[10]; 	/* fobOpbZ[W */

	/* Manager Parameter (ManagerŎgp) */
	enum eventenum	execevent; 		/* AvP[VCxg */
	OBJECT_NAME 	resultqueue; 		/* ԂL[ */
	int 		parameter;			/*  */

	OBJECT_NAME 	asyncqueue;		/* 񓯊CxgML[ */
	int		crystalerr;		/* pppmangŋNCrystalErr */
	int 		dummyparam[5]; 		/* _~[p[^ */
} pppcommon;

/* Config Option */
#define AUTH_NONE		0		/* F؃vgR:Ȃ */
#define AUTH_PAP		LCP_PASSAUT	/* F؃vgR:PAP */
#define AUTH_CHAP		LCP_CHALHS	/* F؃vgR:CHAP */
#define COMP_NONE		0		/* kvgR:Ȃ */
#define COMP_VANJAC		IPCP_VANJAC	/* kvgR:VJ */

/* PPP֘AG[ */
enum ppperr {
    PPPERR = 128,
    NOHEAP,
    SLERR,
    PROCERR,
    TIMERERR,
    NOPSP,
    CANTNEGOT,
    SLCLOSED,
    PPPCLOSED,
	ALREADYOPEN,
    AUTHERR
};

#define NOEVENT			0
#define COMPLETE		1
#define QTIMEOUT		(-2)
#define STATUS_BUSY		(-3)

#define NOERR			0
#define MSGSV			-1
#define SUCCESS			0
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _PPPCMN_ */
