/*
 * pppfunc.h 
 * PowerZAURUS PPPCuwb_t@C
 * 1998/7/12 Version 1.07
 * Copyright (C) 1998 V[v
 * 쐬ҁFV[vЏVXeƖ{rhZpZ^[
 */

/*
 * tab = 8
 * indent level = 4
 * KANJI CODE = SHIFT-JIS(MS-KANJI)
 */
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#if !defined(PPPFUNC_H) /* PPPFUNC_H */

#include <zheaders.h>
#include <pimmgr.h>
#include <applfunc.h>
#include <smtp.h>
#include <mail_fnc.h>
#include <zm_conf.h>
#include <rslproc.h>
#include <maildef.h>

#include <devmodel.h> 
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/* PPP init file name */
#define PPP_INIT_FILENAME "F0:SINPPPIP.INF"

/* PPPInfo item name */
#define PPP_ITEM_DEFAULT_SPEAKER   "1" /* 1:Xs[JI 0:It */
#define PPP_ITEM_DEFAULT_DIALNUM   ""
#define PPP_ITEM_DEFAULT_MDMTYPE   "1" /* 1: 2:15pin 3:card */
#define PPP_ITEM_DEFAULT_MDMINIT   ((char *)NULL) /* Ȃ */
#define PPP_ITEM_DEFAULT_MDMSPEED  "33600"
#define PPP_ITEM_DEFAULT_MDMMAXSPD "33600" /* PHŜƂ57600 */
#define PPP_ITEM_DEFAULT_MDMOUTNUM "1" /* 1:OMԍ 0:Ȃ */
#define PPP_ITEM_DEFAULT_MDMOUTVAL "0" /* OMԍ */
#define PPP_ITEM_DEFAULT_PPPID     ""
#define PPP_ITEM_DEFAULT_PPPPASS   ""
#define PPP_ITEM_DEFAULT_SCRIPT    ((char *)NULL) /* XNvgȂ */
#define PPP_ITEM_DEFAULT_IPADDRESS ""
#define PPP_ITEM_DEFAULT_AUTOIPADR "1" /* 1:T[o擾 0:Őݒ */
#define PPP_ITEM_DEFAULT_GATEWAY   ""
#define PPP_ITEM_DEFAULT_ADDRMASK  ""
#define PPP_ITEM_DEFAULT_DNS1ADDR  ""
#define PPP_ITEM_DEFAULT_DNS2ADDR  ""
#define PPP_ITEM_DEFAULT_ZPACKSIZE "1500"
#define PPP_ITEM_DEFAULT_SPACKSIZE "1500"
#define PPP_ITEM_DEFAULT_ZAUTH     "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_SAUTH     "1" /* 1:PAP  0:Ȃ */
#define PPP_ITEM_DEFAULT_ZPACKPRTC "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_SPACKPRTC "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_ZPACKADDR "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_SPACKADDR "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_ZCHARMAP  "0000A000"
#define PPP_ITEM_DEFAULT_SCHARMAP  "FFFFFFFF"
#define PPP_ITEM_DEFAULT_ZPACKTCP  "1" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_SPACKTCP  "0" /* 1: 0:Ȃ */
#define PPP_ITEM_DEFAULT_DIALTYPE  "1" /* 1:tone 2:pulse20 3:pulse10 */

/* PPPInfo item name */
#define PPP_ITEM_NAME_SPEAKER   "Speaker"
#define PPP_ITEM_NAME_DIALNUM   "DialNumber"
#define PPP_ITEM_NAME_MDMTYPE   "ModemType"
#define PPP_ITEM_NAME_MDMINIT   "ModemInit"
#define PPP_ITEM_NAME_MDMSPEED  "ModemSpeed"
#define PPP_ITEM_NAME_MDMMAXSPD "ModemMaxSpeed"
#define PPP_ITEM_NAME_MDMOUTNUM "ModemOutLine"
#define PPP_ITEM_NAME_MDMOUTVAL "ModemOutNumber"
#define PPP_ITEM_NAME_PPPID     "ConnectID"
#define PPP_ITEM_NAME_PPPPASS   "ConnectPassward"
#define PPP_ITEM_NAME_PPPPASS2  "ConnectPassword"
#define PPP_ITEM_NAME_SCRIPT    "ConnectScript"
#define PPP_ITEM_NAME_IPADDRESS "IPAddress"
#define PPP_ITEM_NAME_AUTOIPADR "GetIPAddress"
#define PPP_ITEM_NAME_GATEWAY   "GatewayAddress"
#define PPP_ITEM_NAME_ADDRMASK  "AddressMask"
#define PPP_ITEM_NAME_DNS1ADDR  "DNS1Address"
#define PPP_ITEM_NAME_DNS2ADDR  "DNS2Address"
#define PPP_ITEM_NAME_ZPACKSIZE "ZaurusPackSize"
#define PPP_ITEM_NAME_SPACKSIZE "ServerPackSize"
#define PPP_ITEM_NAME_ZAUTH     "ZaurusAuth"
#define PPP_ITEM_NAME_SAUTH     "ServerAuth"
#define PPP_ITEM_NAME_ZPACKPRTC "ZaurusPackPrtcl"
#define PPP_ITEM_NAME_SPACKPRTC "ServerPackPrtcl"
#define PPP_ITEM_NAME_ZPACKADDR "ZaurusPackAddr"
#define PPP_ITEM_NAME_SPACKADDR "ServerPackAddr"
#define PPP_ITEM_NAME_ZCHARMAP  "ZaurusCharMap"
#define PPP_ITEM_NAME_SCHARMAP  "ServerCharMap"
#define PPP_ITEM_NAME_ZPACKTCP  "ZaurusPackTCP"
#define PPP_ITEM_NAME_SPACKTCP  "ServerPackTCP"
#define PPP_ITEM_NAME_DIALTYPE  "DialType"

/* PPPInfo item number */
#define PPP_ITEM_SPEAKER   1        /* Speaker         */
#define PPP_ITEM_DIALNUM   2        /* DialNumber      */
#define PPP_ITEM_MDMTYPE   3        /* ModemType       */
#define PPP_ITEM_MDMINIT   4        /* ModemInit       */
#define PPP_ITEM_MDMSPEED  5        /* ModemSpeed      */
#define PPP_ITEM_MDMMAXSPD 6        /* ModemMaxSpeed   */
#define PPP_ITEM_MDMOUTNUM 7        /* ModemOutLine    */
#define PPP_ITEM_MDMOUTVAL 8        /* ModemOutNumber  */
#define PPP_ITEM_PPPID     9        /* ConnectID       */
#define PPP_ITEM_PPPPASS   10       /* ConnectPassward */
#define PPP_ITEM_SCRIPT    11       /* ConnectScript   */
#define PPP_ITEM_IPADDRESS 12       /* IPAddress       */
#define PPP_ITEM_AUTOIPADR 13       /* GetIPAddr       */
#define PPP_ITEM_GATEWAY   14       /* GatewayAddress  */
#define PPP_ITEM_ADDRMASK  15       /* AddressMask     */
#define PPP_ITEM_DNS1ADDR  16       /* DNS1Address     */
#define PPP_ITEM_DNS2ADDR  17       /* DNS2Address     */
#define PPP_ITEM_ZPACKSIZE 18       /* ZaurusPackSize  */
#define PPP_ITEM_SPACKSIZE 19       /* ServerPackSize  */
#define PPP_ITEM_ZAUTH     20       /* ZaurusAuth      */
#define PPP_ITEM_SAUTH     21       /* ServerAuth      */
#define PPP_ITEM_ZPACKPRTC 22       /* ZaurusPackPrtcl */
#define PPP_ITEM_SPACKPRTC 23       /* ServerPackPrtcl */
#define PPP_ITEM_ZPACKADDR 24       /* ZaurusPackAddr  */
#define PPP_ITEM_SPACKADDR 25       /* ServerPackAddr  */
#define PPP_ITEM_ZCHARMAP  26       /* ZaurusCharMap   */
#define PPP_ITEM_SCHARMAP  27       /* ServerCharMap   */
#define PPP_ITEM_ZPACKTCP  28       /* ZaurusPackTCP   */
#define PPP_ITEM_SPACKTCP  29       /* ServerPackTCP   */
#define PPP_ITEM_DIALTYPE  30       /* DialType        */
#define PPP_ITEM_NUMBER    30       /* g[^ */

#define PPP_ITEM_NULLSTR   ""
#define PPP_ITEM_ERROR     -1

/* ppp information structure */
typedef struct PPPInfo {
    char *item[PPP_ITEM_NUMBER + 1];
} PPPInfo;

/* PPP manager code top address */
#define PPP_CODE_TOP_MI10 ((BYTE *)0x503b00)
#define PPP_CODE_TOP_MI500 ((BYTE *)0x523400)
#define PPP_CODE_TOP_MI100 ((BYTE *)0x523400)
#define PPP_CODE_TOP_MI600 ((BYTE *)0xC09300)
#define PPP_CODE_TOP_BIT310 ((BYTE *)0xC09300)
#define PPP_CODE_TOP_MI300 ((BYTE *)0xC09300)
#define PPP_CODE_TOP_MT200 ((BYTE *)0x662000)
#define PPP_CODE_TOP_MIP1  ((BYTE *)0x4f7000)
#define PPP_CODE_TOP_MIEX1   ((BYTE *)0x1e60000)
#define PPP_CODE_TOP_BO181   ((BYTE *)0x662000)
#define PPP_CODE_TOP_MT300   ((BYTE *)0x64c000)


/* PPP model string */
#define PPP_MODEL_STR_MI10   "MI10"
#define PPP_MODEL_STR_MI500  "MI500"
#define PPP_MODEL_STR_MI100  "MI100"
#define PPP_MODEL_STR_MI600  "MI600"
#define PPP_MODEL_STR_BIT310 "MI600"
#define PPP_MODEL_STR_MI300 "MI300"
#define PPP_MODEL_STR_MT200 "MT200"
#define PPP_MODEL_STR_MIP1  "MIP1"
#define PPP_MODEL_STR_MIEX1 "MIEX1"
#define PPP_MODEL_STR_BO181 "BO181"
#define PPP_MODEL_STR_MT300 "MT300"

/* PPP model type */
typedef enum MODELTYPE{
MODEL_TYPE_MI10 = 0,
MODEL_TYPE_MI500,
MODEL_TYPE_MI100,
MODEL_TYPE_MI600,
MODEL_TYPE_MI300,
MODEL_TYPE_MT1,
MODEL_TYPE_MIP1,
MODEL_TYPE_MIEX1,
MODEL_TYPE_BO181,
MODEL_TYPE_MT300,
MODEL_TYPE_MAXNUM	/* ͕KŌ */
} MODELTYPE;

/* PPP preference-file name */
#define PPP_PREF_FILE "F0:PPPIP.INF"
#define PPP_PREF_FILE_DEFAULT 

/* function prototype */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
int   manager_create_model(BYTE *PPPcodetop);
int   manager_create_task_model(BYTE *PPPcodetop);
void  initPPPInfo(PPPInfo *pppinfo);
void  cleanPPPInfo(PPPInfo *pppinfo);
int   getPPPitem(FILE *fp);
char  *getPPPvalue(FILE *fp);
int   setPPPInfo(PPPInfo *pppinfo, char *initfile);
ULONG SCGetItem(USHORT item_no);
PTR   SDGetItem(USHORT item);
void  applsm2(int status, MESSAGE *AlertMsg, PPPConfigType *config, BYTE *PPPcodetop);
int   PPPmain(int Status, PPPConfigType *PPPconfig, BYTE *PPPcodetop);
int   PPPconnect(int Status, BYTE *PPPcodetop, char *PPPinitfile);


unsigned long resolve_addr_sync(char *hostname);
char *resolve_ptr_sync(char *ip_address);
unsigned long resolve_mx_sync(char *hostname);


int resolve_a_req(char *name,
		  OBJECT_NAME resultqueue, OBJECT_NAME resultprocess);
int resolve_ptr_req(char *ip_address,
		    OBJECT_NAME resultqueue, OBJECT_NAME resultprocess);
int resolve_mx_req(char *hostname,
		   OBJECT_NAME resultqueue, OBJECT_NAME resultprocess);
unsigned long search_a(char *name, unsigned long rslinfop, int *neterr);
char *search_ptr(char *ip_address, unsigned long rslinfop, int *neterr);
unsigned long search_mx(char *name, unsigned long rslinfop, int *neterr);
END_EXTERN_C                /* C++ support  99/9/8 */


#define PPPFUNC 1
#define PPPFUNC_H 1
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* PPPFUNC_H */
