/***********************************************************************
<t@C>	prtdrvlb.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		v^hCoCupwb_
***********************************************************************/

#ifndef _PRTDRV_H_INCLUDED
#define	_PRTDRV_H_INCLUDED
#include	"sharpgen.h"

#ifndef H2EQU
#include	"printer.h"

/* vg^Cv錾 */
BOOLEAN PrtDrvReadTable(UCHAR *Bufptr, UCHAR Kind);
BOOLEAN PrtDrvWriteTable(UCHAR *Bufptr, UCHAR Kind);
UCHAR	PrtStart( PRTCtrl *pcb, UCHAR model, UCHAR channel );
UCHAR	PrtIRCheck( PRTCtrl *pcb );
UCHAR	PrtEnd( PRTCtrl *pcb );
UCHAR	PrtResetForm( PRTCtrl *pcb );
UCHAR	PrtSetPaperSize( PRTCtrl *pcb, USHORT sizeX, USHORT sizeY );
UCHAR	PrtSetTopMargin( PRTCtrl *pcb, short tmargin, short bmargin );
UCHAR	PrtSetLeftMargin( PRTCtrl *pcb, short lmargin, short rmargin );
UCHAR	PrtSetPageLen( PRTCtrl *pcb, UCHAR line, UCHAR column );
UCHAR	PrtCRLFCtrl( PRTCtrl *pcb, UCHAR cr_lf );
UCHAR	PrtSetTabs( PRTCtrl *pcb, UCHAR *tabs );
UCHAR	PrtSetVolume( PRTCtrl *pcb, char volume );
UCHAR	PrtSetCopyPaper( PRTCtrl *pcb, UCHAR paper );
UCHAR	PrtSetPitch( PRTCtrl *pcb, UCHAR pitch );
UCHAR	PrtSetDeco( PRTCtrl *pcb, UCHAR deco );
UCHAR	PrtSetForms( PRTCtrl *pcb, PRTForms *forms );
UCHAR	PrtGetForms( PRTCtrl *pcb, PRTForms *forms );
UCHAR	PrtPrintChar( PRTCtrl *pcb, UCHAR *str, USHORT len, UCHAR mode );
UCHAR	PrtPrintDeco( PRTCtrl *pcb, UCHAR *str, USHORT len, UCHAR mode );
UCHAR	PrtPrintKeisen( PRTCtrl *pcb, UCHAR *str, USHORT len, UCHAR mode );
UCHAR	PrtImageTest( PRTCtrl *pcb, PRTImage *icb );
UCHAR	PrtPrintImage( PRTCtrl *pcb, PRTImage *icb );
UCHAR	PrtFeedLine( PRTCtrl *pcb, UCHAR num );
UCHAR	PrtFeedPage( PRTCtrl *pcb );
UCHAR	PrtImageLine( PRTCtrl *pcb, PRTImage *icb, USHORT *line );
USHORT	PrtIsZenkaku( USHORT INcode );
UCHAR	PrtByteWrite( PRTCtrl *pcb, UCHAR data );
UCHAR	PrtPrintImageHD( PRTCtrl *pcb, PRTImage *icb );
UCHAR	PrtImageLineReviceHD( PRTCtrl *pcb );
UCHAR	PrtImageLineHD( PRTCtrl *pcb, PRTImage *icb, USHORT *line );
UCHAR	PrtXDotReadHD( PRTCtrl *pcb );
UCHAR	PrtYDotReadHD( PRTCtrl *pcb );
UCHAR	PrtGetOnePageDotYHD( PRTCtrl *pcb,USHORT line );
UCHAR	PrtStartNoDev( PRTCtrl *pcb, UCHAR model, UCHAR channel );
UCHAR	PrtEndNoDev( PRTCtrl *pcb );
UCHAR	HighPrintKeisen( PRTCtrl *pcb, UCHAR *str, USHORT len, UCHAR mode );

#endif H2EQU



/* Kind̒` */
#define	KIND_WORK_ALL		0
#define	KIND_WORK_1			1
#define	KIND_WORK_2			2
#define KIND_WORK_3			3
#define KIND_WORK_4			4


#define	PrtDrvInit				0x40
#define	PrtReadTable			0x41
#define	PrtWriteTable			0x42

#define	PrtStartID				0x50
#define	PrtIRCheckID			0x51
#define	PrtEndID				0x52
#define	PrtResetFormID			0x53
#define	PrtSetPaperSizeID		0x54
#define	PrtSetTopMarginID		0x55
#define	PrtSetLeftMarginID		0x56
#define	PrtSetPageLenID			0x57
#define	PrtCRLFCtrlID			0x58
#define	PrtSetTabsID			0x59
#define	PrtSetVolumeID			0x5a
#define	PrtSetCopyPaperID		0x5b
#define	PrtSetPitchID			0x5c
#define	PrtSetDecoID			0x5d
#define	PrtSetFormsID			0x5e
#define	PrtGetFormsID			0x5f
#define	PrtPrintCharID			0x60
#define	PrtPrintDecoID			0x61
#define	PrtPrintKeisenID		0x62
#define	PrtImageTestID			0x63
#define	PrtPrintImageID			0x64
#define	PrtFeedLineID			0x65
#define	PrtFeedPageID			0x66
#define	PrtImageLineID			0x67
#define	PrtIsZenkakuID			0x68
#define	PrtByteWriteID			0x69
#define	PrtPrintImageHDID		0x6a
#define	PrtImageLineReviceHDID	0x6b
#define	PrtImageLineHDID		0x6c
#define	PrtXDotReadHDID			0x6d
#define	PrtYDotReadHDID			0x6e
#define	PrtGetOnePageDotYHDID	0x6f
#define	PrtStartNoDevID			0x70
#define	PrtEndNoDevID			0x71
#define	HighPrintKeisenID		0x72


#define	PRTDRV_LAST_FUNC		0x72

#define	_PRTDRV_H_INCLUDED

#endif
