/************************************************************************
 * NAME         : Script.h						*
 * FUNCTION     : XNvgsׂ̈̐錾				*
 *                           			                        *
 ************************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _SCRIPTH_
#define _SCRIPTH_

#include     <zheaders.h>
#include     <comdvlib.h>
#include     <modemlib.h>
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/*======================================================================*/
/*			@@ft@C				*/
/*======================================================================*/

#define NULLCODE      0x00	/* mtkkR[h			*/
#define CRCODE        0x0D	/* sR[hiPR}h؂j	*/
#define SINGLE        0x27	/* fiVOR[e[Vj		*/
#define DOUBLE        0x22	/* hi_uR[e[Vj		*/
#define KANNMA        0x2c	/* CiJ}j				*/
#define KORONN        0x3a	/* FiRj				*/
#define SEMIKO        0x3b	/* GiZ~Rj			*/
#define YENMARK       0x5c	/* i~}[Nj			*/
#define LFCODE        0x0a	/* AR[h				*/
#define TABCODE       0x09	/* ^uR[h			*/

/*		< ScriptMain() WkRet ɑ΂߂l >			*/

#define ERROR_1          1      /* R}hs̃G[iߒlj	*/
#define JUMP_RET         2      /* sR}hsłȂꍇ̖ߒl	*/
#define END_SCRIPT       3	/* nEdR}hɂv̖ߒl	*/

/*		< XNvg̐IȊO̖߂l >			*/

#define WANT_OFFLINE     2	/* ؒfv			*/
#define	BUNPO_ERR        3	/* @G[				*/
#define DM_ERR           4	/* f[^}l[W[G[		*/
#define TIME_ERR         5	/* ^C}l[W[֐G[		*/
#define NO_CAREER        0xfd	/* m[LA				*/
#define ABORT_ERR        0xfe	/* [obe[̃A{[g		*/
#define KEY_BREAK        0xff	/* L[ɂA{[g			*/
#define	LOG_ERR		 0x100

/*			< l`wl֌W >				*/

#define	OFFLINE	         1	/* ؒf				*/

/************************************************************************/
/*									*/
/*			gpR}h			*/
/*									*/
/************************************************************************/
/*	#define	TBLMAX  11	*//* R}hgp\  	*/
/*	#define	TBLMAX  13	*//* R}hgp\  	*/
/*									*/
#define	TBLMAX          12	/* R}hgp\	   	*/
/*									*/
/************************************************************************/


#define	LABELMAX  	30	/* xLGÂl`w		*/
#define	JLABELMAX       10	/* iR}hxL̂l`w		*/
#define MAX_WAIT_TIME  300	/* M҂ftHgԁibj		*/
#define MAX_TIME       255	/* M҂őw莞ԁibj		*/
#define ALBOX_MAX      200	/* A[ganw\ő啶		*/
#define LENGTH_MAX     255	/* R}ĥPső啶		*/
#define CTRLCODEMAX    255	/* Rg[R[hl`w		*/
#define HOUR_MIN      3600      /* PԂ̕b				*/
#define RCVBUF_SIZ     256	/* Mobt@̂l`w			*/
#define SCRIPTMAX     2000	/* XNvgt@Cőeʁij	*/

#define	SCR_ERR_MSG_LEN	20	/* XNvgG[bZ[W	        */
#define	TOP_MENU_BUF_LEN	100	/* snoj[obt@	*/


/*======================================================================*/
/*		XNvgł̈p\́i^錾j			*/
/*======================================================================*/

/*======================================================================*/
/*	XNvg̎M̂mtkkrΉɂύX  	*/
/*======================================================================*/
typedef struct
{
	UCHAR   *BuffTop;		/* XNvgobt@擪AhX	*/
	UCHAR   *BuffNow;		/* ݎsAhX			*/
	UCHAR   *BuffJump;		/* sړ̃AhX			*/
	UCHAR   *RcvRest;		/* M߂̎c蕶			*/
	UCHAR   *Name[LABELMAX];	/* xx(30)	*/
	UCHAR   *JLbl[JLABELMAX];	/* iR}hɂݒ胉x  (10)	*/
	USHORT    LblNo;		/* Name[]ŎɊi[Y̒l		*/
	USHORT    LblCnt;		/* Name[]Ŋi[Ăl		*/
	USHORT    Ret;		        /* R}hs			*/
	USHORT    Line;		        /* ԁiOFڑ@PFؒfj	*/
	USHORT    T_Flg;		/* gbvj[\ŏI̗L	*/
	USHORT    RcvRestLen;		/* M߂̎c̕ 94.10. 1 ǉ	*/
	UCHAR	ScrErrMsg[SCR_ERR_MSG_LEN]; 	/* XNvgG[bZ[W	*/
	UCHAR   TopMenuBuf[TOP_MENU_BUF_LEN];   /* snoj[obt@	*/
	BCOM    *BCom;                  /* BCOM\                           */
	HANDLE  CnsWrkHd;               /* R\[[Nnh             */
	HANDLE  LogWrkHd;		/* Ot@C[Nnh          	*/
	UCHAR   LocalEcho;              /* [JGR[                       */
	UCHAR   *UserID;                /* [U[hc                         */
	UCHAR   *UserPassword;          /* [U[pX[h                   */
} SCRIPTWORK;

/*======================================================================*/
/*	XNvg̎M̂mtkkrΉɂǉ  	*/
/*			MR}h̕r֐ւ̈p\	*/
/*======================================================================*/

typedef struct {
	UCHAR  *SourceStr;		/* r镶̃|C^	*/
        UCHAR  *CompStr;		/* r镶̃|C^	*/
        USHORT    SourceLen;		/* r镶̕	*/
        USHORT    CompLen;		/* r镶̕	*/
} COMPWRK;

/*======================================================================*/
/*			A[g{bNXp\			*/
/*======================================================================*/

typedef  struct
{
    UCHAR		AlboxFrame;
    UCHAR		AlboxPos;
    UCHAR		AlboxType;
    USHORT		CallBackBank;
    USHORT		(*CallBackAdr)();
    UCHAR		*CallBackWork;
    UCHAR		AlboxBtnNum;
    ALBOX_BTN_STRC	AlboxBtnStrc[3];
    USHORT		AlboxMessLen;
    UCHAR		AlboxMess[200];
} AL_WORK ;

BEGIN_EXTERN_C              /* C++ support  99/9/8 */
/*======================================================================*/
/*				R}h֐				*/
/*======================================================================*/

UCHAR   com_S();			/*	r@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_W();			/*	v@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_J();			/*	i@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_R();			/*	q@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_O();			/*	n@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_L();			/*	k@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_E();			/*	d@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_Lbl();			/*	F(x)R}h	*/ /* C++ support  Ή99/9/10*/
UCHAR   com_Cmt();			/*	f(Rg)R}h	*/ /* C++ support  Ή99/9/10*/
UCHAR   com_C();			/*	b@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_P();			/*	o@R}h		*/ /* C++ support  Ή99/9/10*/
UCHAR   com_T();			/*	s@R}h		*/ /* C++ support  Ή99/9/10*/



/*======================================================================*/
/*		[J֐( script.c  Lq )			*/
/*======================================================================*/
USHORT    ComScriptCard(SCRIPTWORK *ScriptWork, BOXHANDLE BoxHd, USHORT CardID, UCHAR *Label );  /* anwt@CXNvgs	*/
USHORT    ComScriptBuffer(SCRIPTWORK *ScriptWork, UCHAR *Buff, UCHAR *Label );  /* obt@̎wɂXNvgs	*/
USHORT    ScriptMain();		/* sR}h̔f֐ij	*/ /* C++ support  Ή99/9/10*/
UCHAR   AbtChk();		/* R}hsÕA{[g`FbN	*/ /* C++ support  Ή99/9/10*/
USHORT    CodeChk();		/* R[ĥPorQoCg̃`FbN	*/ /* C++ support  Ή99/9/10*/
UCHAR  *CrcodeSearch();		/* bqR[hs܂Ői߂	*/ /* C++ support  Ή99/9/10*/
UCHAR  *LabelSearch();		/* xobt@֐		*/ /* C++ support  Ή99/9/10*/
UCHAR  *LblNoSearch();		/* \̓ LblNo[]̌EL	*/ /* C++ support  Ή99/9/10*/
short     TimeControl();		/* ҂Ԏ擾p֐			*/ /* C++ support  Ή99/9/10*/
/*======================================================================*/
/*	MrmtkkΉɔ֐̌^ύX		*/
/*	UCHRA *CompString();   ---->  USHORT CompString();		*/
/*======================================================================*.
USHORT    CompString();		/* Mߎ̕rp֐		*/
USHORT    CtrlCode();		/* Rg[R[h̃`FbNϊ	*/ /* C++ support  Ή99/9/10*/
USHORT    ModeS_String();		/* rR}h]̕쐬		*/ /* C++ support  Ή99/9/10*/
USHORT    ModeC_String();		/* bR}h]̕쐬		*/ /* C++ support  Ή99/9/10*/
short     TimeCheck();		/* ^CAEg̃`FbN֐		*/ /* C++ support  Ή99/9/10*/
short     TimeSet();		/* R}hLq̕b𐔒lϊ		*/ /* C++ support  Ή99/9/10*/
				/* 94. 9.22 dlǉ			*/ /* C++ support  Ή99/9/10*/
void    PwrSavRcv();		/* p[Z[uM			*/ /* C++ support  Ή99/9/10*/
void    PwrSavWait();		/* p[Z[uŃEFCg		*/ /* C++ support  Ή99/9/10*/
UCHAR   ScrAbtChk();		/* A{[gƒfL[̃`FbN		*/ /* C++ support  Ή99/9/10*/
void    NulCut();		/* f[^̃kR[h폜		*/ /* C++ support  Ή99/9/10*/


void SrcOpenMsg( );		/* A[ganw̃I[v		*/ /* C++ support  Ή99/9/10*/
void ScrCloseMsg( );		/* A[ganw̃N[X		*/ /* C++ support  Ή99/9/10*/
void ScrAlboxExec( );		/* A[ganw̎s		*/ /* C++ support  Ή99/9/10*/

USHORT  ScrpSndBlock(SCRIPTWORK *DataPra, UCHAR *BufPtr, int BufLen);
USHORT  ScrpRcvBlock(SCRIPTWORK *DataPra, UCHAR *Buffer, int *Leng);
BOOLEAN ScrpRcvData(HANDLE CnsWrkHd, HANDLE LogWrkHd, UCHAR *BufPtr, int BufLen);		/* M񏈗			*/
void  ScrpExecWait(BCOM *BCom);  /* EFCĝƂ̃p[Z[u	*/
UCHAR ScrpExecBreak(BCOM *BCom); /* fL[Ă邩`FbN	*/

/*======================================================================*/
/*			XNvgW[ Cu֐		*/	/*======================================================================*/
USHORT ComScrCardLib(SCRIPTWORK *ScriptWork, BOXHANDLE BoxHd,
					USHORT CardfID,UCHAR *Label);
USHORT ComScrBufferLib(SCRIPTWORK *ScriptWork,UCHAR *Buffer,
						UCHAR *Label);
END_EXTERN_C                /* C++ support  99/9/8 */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _SCRIPTH_ */
