/***********************************************************************
<t@C>	button.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		{^c[(NXł͂ȂII)`
***********************************************************************/
#ifndef _BUTTON_H_INCLUDED
#define	_BUTTON_H_INCLUDED
#include	<sharpgen.h>
#include	<zdrawlib.h>

/************************************************/
/*	Pƃ{^XgN`錾		*/
/************************************************/

typedef UCHAR	FRAMEMODE;

/* `(bit0-2) */
#define	RECTANGLE_SHAPE	0	/* lp */
#define	ROUND_SHAPE		1	/* pێlp */
#define	POLYGON_SHAPE	2	/* ܊p` */

/* Recʒu(bit4-5) */
/* {^łATCYŵ̂̏ꍇ̕ʒu */
#define	CHAR_BTN_LEFT		0x00	/*  */
#define	CHAR_BTN_RIGHT		0x10	/* E */
#define	CHAR_BTN_CENTER		0x20	/* Z^O */

#define	CHAR_BTN_POS_MASK	0x30	/* L𓾂邽߂̃}XN */

/* IvV(bit6-7) */
#define	FB_USE_LOGICAL_BG	0x40	/* _FobNJ[ƂĎgp */
#define	FB_USE_CUSTOM_BG	0x80	/* JX^̃obNJ[gp */

/*
 * Ȃh2equʂȂ...
 * typedef void (*BTNPROC)(WINDOWHD,RECTANGLE*,GCTABLE,GCTABLESET,void*);
 */

/* e{^f[^XgN` */
typedef	struct	ButtonData	{
	USHORT		ButtonID;		/* {^hc */
	USHORT		ButtonMode;		/* {^[h */
	DISPDATA	DispData;
	CDSPMODE	CharMode;		/* {^ */
	FRAMEMODE	FrameMode;		/* Eg{^[h */
	short		ButtonPosX;		/* {^Ww */
	short		ButtonPosY;		/* {^Wx */
	USHORT		ButtonSizeX;	/* y[U[ݒsvz{^TCYw */
	USHORT		ButtonSizeY;	/* y[U[ݒsvz{^TCYx */
	GUICOLOR	CharFgColor;	/* {^tHAJ[ */
	GUICOLOR	ButtonBgColor;	/* Eg{^obNJ[ */
} BUTTON_DATA;

/* {^[h[ButtonMode]@*/ 	/* Q{^[h[DbButtonMode] */

/* (bit15-12) O */

/* (bit11)񓮍{^ */
#define	DEAD_BUTTON			0x0800		/* 񓮍 */

/* (bit10)\{^ */
#define	INVISIBLE_BUTTON	0x0400		/* \ */

/* (bit9)]Ă{^ */
#define	REVERSED_BUTTON		0x0200		/* ] */

/* (bit8)\{^̎wiQ{^ƒPƃ{^ł͈قȂ̂ŒӁj */
#define	LIGHT_BUTTON		0x0100		/* Is */

/* (bit7)񔽉{^̎w */
#define	NO_SELECT_BUTTON	0x0080		/* 񔽉 */
#define	DISABLE_BUTTON		(LIGHT_BUTTON+NO_SELECT_BUTTON)

/* (bit6)݂̃nCCgԂ̎w */
/*       Crimson肱̓ZNgԂ̂Ƃ		*/
/* 		 ]Ԃbit9Ŏ	*/
#define	BEFORE_HILITE		0x0040			/* nCCg(݊p) */
#define	SELECTED_BUTTON		BEFORE_HILITE	/* ZNg */

/* (bit5)X^[g|WVˑ̎w */
#define	FROM_START			0x0020		/* X^[g|WVˑɎw */

/* (bit4)ZNg̔]I̎w */
#define	NO_REVERSE_RETURN	0x0010		/* 񔽓]IɎw */

/* (bit3)s[g̎w */
#define	REPEAT_ON			0x0008		/* s[gLɎw */

/* (bit2)\{^̎wiQ{^ƒPƃ{^ł͈قȂ̂ŒӁj */
#define	D_LIGHT_BUTTON		0x0004		/* {^ iQ{^j*/

/* (bit2-0){^̐ݒ */
#define	ICON_BUTTON			0x0000		/* ACR{^ */
#define	CHAR_BUTTON			0x0001		/* {^(et) */
#define	CLEAR_BUTTON		0x0002		/* {^ */
#define	FRAME_BUTTON		0x0003		/* g{^(Crimson) */

#define	MASK_BUTTON_STYLE	0x0003		/* {^^Cṽ}XN */


/* {^̃^Cv[ButtonType] */		/* Q{^[h[DbMode] */

/* (bit7)]ۑ̎w */
#define	NO_SELECT_REVERSE	0x80		/* ͈͊OɏoĂ]ۑ */

/* (bit6)hbO[h̎w */
#define	DRAG_BUTTON			0x40		/* hbO[hɎwiQ */
										/* {^̂݁j */
/* (bit5)X^[g|WV̈\}XNɂ̂ݎgp */
/* CrimsonŒǉ - ̃[h͈ȉ̓̌p */
/* EX^[g|WV̈ł{^Õyɑ΂NOP */
/* EX^[g|WV̈ŕ\}XN */
/*   ]͋̈悩͂ݏo{^͑S\Ȃ */
#define	USE_SP_RECT_AS_MASK	0x20

/* (bit4)}XN\f[^̂ACR}XN\Ȃ */
#define	DO_NOT_USE_DMASK	0x10

/* (bit3)WTEhȊOgp{^ */
#define	USE_CUSTOM_SOUND	0x08

/* (bit2-0) O */

/* CheckPartIDł̖߂l */
#define	BUTTON_ST_NORMAL	0
#define	BUTTON_ST_SELECT	1
#define	BUTTON_ST_REVERSE	2

/****************************************/
/* Pƃ{^XgN`{			*/
/****************************************/
typedef	struct	ButtonWork	{
	UCHAR		ButtonWindowNo;		/* EBhEmD */			
	short		ButtonStartPosX;	/* X^[g|WV̈捶Ww	*/
	short		ButtonStartPosY;	/* X^[g|WV̈捶Wx	*/
	USHORT		ButtonStartSizeX;	/* X^[g|WV̈TCYw	*/
	USHORT		ButtonStartSizeY;	/* X^[g|WV̈TCYx	*/
	UCHAR		ButtonType;			/* {^̃^Cv	 		*/
	UCHAR		ButtonSound;		/* {^^b`̃TEh */
	USHORT		SelectButtonID;		/* y[U[ݒsvz */
									/* IĂ{^̂hc */
	USHORT		RepeatCounter;		/* Ŏgs[gJE^ */
     /* BUTTON_DATA	ButtonData[?];	*/	/* e{^f[^XgN` */
} BUTTONWORK;

/************************************************/
/*	Q{^XgN`錾		*/
/************************************************/

typedef	struct	DButtonWork	{
	UCHAR		DbWindowNo;			/* EBhEmD */
	short		DbPositionX;		/* t[Ww */
	short		DbPositionY;		/* t[Wx */
	USHORT		DbSizeX;			/* t[TCYw[P */
	USHORT		DbSizeY;			/* t[TCYx[P */
	short		DbReverseLocX;		/* ]̈捶ւ̃ItZbgw */
	short		DbReverseLocY;		/* ]̈捶ւ̃ItZbgx */
	USHORT		DbReverseSizeX;		/* ]̈TCYw */
	USHORT		DbReverseSizeY;		/* ]̈TCYx */
	UCHAR		DbWidthVolume;		/* ̃{^ */
	UCHAR		DbHeightVolume;		/* c̃{^ */
	UCHAR		DbInvalidity;		/* ŏ̖ȃ{^ */
	UCHAR		DbEffect;			/* L{^̑ */
	UCHAR		DbFirstButton;		/* ŏ̃{^[hւ̃ItZbg */
	UCHAR		DbMode;				/* Q{^[h */
	UCHAR		DbStartButton;		/* hbOJn{^ */
	UCHAR		DbEndButton;		/* hbOI{^ */
	COLOR		DbBGColor;			/* obNOEhJ[ */
	COLOR		DbReverseColor;		/* o[XJ[ */
	UCHAR		*DbButtonModeTop;	/* e{^ŗL̃[hւ̃|C^ */
	USHORT		DbRepeatCounter;	/* Ŏgs[gJE^ */
	USHORT		DbDragCounter;
} DBUTTONWORK;

/* Q{^͈̔͊O̒` */
#define	DOWN_OUT_AREA	1
#define	DOWN_IN_AREA	0

#endif
