/***********************************************************************
<t@C>	comdvlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		ʐMnn[hEFAۉhCoCCuɊւ`
***********************************************************************/

#ifndef	_COMDVLIB_H_INCLUDED
#define _COMDVLIB_H_INCLUDED

#include <sharpgen.h>
#include <abort.h>

/*--------------------------------------------------------------------*/
typedef unsigned long COMMDEVNAME;

/* foCX */
#define	BLTIN_15PIN_DEV		0x6953494f	/* 'iSIO' 15pinSIO */
#define	BLTIN_MODEM_DEV		0x694d444d	/* 'iMDM' f */
#define	BLTIN_ASK_DEV		0x6941534B	/* 'iASK' ԊOʐMiASKj*/
#define	BLTIN_IRDA1_DEV		0x69497231	/* 'iIr1' ԊOʐMiIrDA Ver.1j*/
#define	BLTIN_IRPPP_DEV		0x69495250	/* 'iIRP' ԊOʐMiIrCOMM - PPPj*/
#define	BLTIN_PDC_DEV		0x69504443	/* 'iPDC' PDCA_v^       */
#define	BLTIN_PHSNTT_DEV	0x694E5454	/* 'iNTT' PHS/NTTA_v^ MIP1ȍ~ */
#define	BLTIN_PHSDDI_DEV	0x69444449	/* 'iDDI' PHS/DDIA_v^ MIP1ȍ~ */
#define	BLTIN_PIAFS_DEV		0x69504853  /* 'iPHS' PHS/NTTA_v^ MI310̂!! */
#define	BLTIN_UART_DEV		0x69554154	/* 'iUAT' MPhnpUART        */

/* PC-CardfoCX */
#define	PCCARD0_COMM_DEV	0x50434330	/* 'PCC0' PC-Card socket#0 ̒ʐMfoCX */
#define	PCCARD1_COMM_DEV	0x50434331	/* 'PCC1' PC-Card socket#1 ̒ʐMfoCX */


/*--------------------------------------------------------------------*/
typedef	USHORT COMMDEVIRQMASK;
/*
	bit15`8	pfoCXpi\:gpj
		7`0	VAfoCXp
*/

#define	COMMDEV_IRQ_RECEIVE		0x0001	/* bit0: M */
#define	COMMDEV_IRQ_SEND		0x0002	/* bit1: M */
#define	COMMDEV_IRQ_RCV_ERROR	0x0004	/* bit2: MG[ */
#define	COMMDEV_IRQ_SIGNAL_CHG	0x0008	/* bit3: ̕ω */
#define	COMMDEV_IRQ_TIMER		0x0040	/* bit6: ^C}[	*/

#define	COMMDEV_IRQ_ALL			0xFFFF	/* S荞 */


/*--------------------------------------------------------------------*/

typedef struct COMMDEVMODE {
	char	WorkType;	/* COMMDEVMODE_TYPE1(0x10) ݒ肷 */
	char	ByteSize;	/* DATABIT_7(7)=7bit, DATABIT_8(8)=8bit */	
	char	Parity;		/* PARITY_NONE(0)=Ȃ */
						/* PARITY_ODD(1)=, PARITY_EVEN(2)= */
	char	StopBits;	/* STOPBIT_1(0)=1bit, STOPBIT_1h(1)=1.5bit, */
						/* STOPBIT_2(2)=2bit */
	ULONG	BaudRate;	/* {[[g\l */
} COMMDEVMODE;

/**** COMMDEVMODE.WorkType ****/
#define COMMDEVMODE_TYPE1	0x10

/**** COMMDEVMODE.ByteSize ****/
#define DATABIT_5	0x05	/* Tbit */
#define DATABIT_6	0x06	/* Ubit */
#define DATABIT_7	0x07	/* Vbit */
#define	DATABIT_8	0x08	/* Wbit */

/**** COMMDEVMODE.Parity ****/
#define PARITY_NONE 0x00	/* peB */
#define	PARITY_ODD	0x01	/* peB */
#define PARITY_EVEN	0x02	/* peB */
#define PARITY_MARK	0x03
#define PARITY_SPACE	0x04

/**** COMMDEVMODE.StopBits ****/
#define STOPBIT_1	0x00	/*  1 bit */
#define STOPBIT_1h	0x01	/* 1.5bit */
#define STOPBIT_2	0x02	/*  2 bit */

/**** COMMDEVMODE.BaudRateivݒj****/
#define	BR_300		   300
#define	BR_600		   600
#define	BR_900		   900
#define	BR_1200		  1200
#define	BR_1800		  1800
#define	BR_2400		  2400
#define	BR_3600		  3600
#define	BR_4800		  4800
#define	BR_7200		  7200
#define	BR_9600		  9600
#define	BR_14400	 14400
#define	BR_19200	 19200
#define	BR_28800	 28800
#define	BR_38400	 38400
#define	BR_57600	 57600
#define	BR_115200	115200
#define	BR_4000000 	4000000
/*--------------------------------------------------------------------*/

typedef struct UART_INFO {
	short	Type;			/* UART̋@ */
	short	Capability;		/* UART̔\ */
	ULONG	MaxBitRate;		/* ōf[^]x[baud] */
} UART_INFO;

/**** Type ****/
/* 0x0000`0x00FF  PC Card Standard 1995/2 ŋK肳ĂUART` */
/* (Q PC CARD STANDARD Vol.4 Metaformat Specification p.38 TPLFE_UA */
/* 0xFF00`0xFFFF  ƎUART` */
#define UART_TP_SHARP1	0xFFFF	/* G.A. UART1(15pin & f) */
#define	UART_TP_SHARP2	0xFFFE	/* G.A. UART2(for SHARP-ASK & IRDA Ver.1) */

#define	UART_TP_SH770x	0xFF77	/* SH3SCI */

/* ȉAPC Cardp */
#define	UART_TP_8250	0x0000	/* 8250 UART  */
#define	UART_TP_16450	0x0001	/* 16450 UART */
#define	UART_TP_16550	0x0002	/* 16550 UART */
#define	UART_TP_8251	0x0003	/* 8251 USART */
#define	UART_TP_8530	0x0004	/* 8530 SCC   */
#define	UART_TP_85230	0x0005	/* 85230 ESCC */
/* #define UART_TP_ 0x0006`0x001f reserved for PC Card future standardization */

/**** Capability ****/
/* '1'ɂȂĂrbguĂ@\v\ */
#define UART_C_5bitCHAR		0x0001
#define	UART_C_6bitCHAR		0x0002
#define	UART_C_7bitCHAR		0x0004
#define	UART_C_8bitCHAR		0x0008
#define	UART_C_1STOPBIT		0x0010
#define	UART_C_1hSTOPBIT	0x0020
#define	UART_C_2STOPBIT		0x0040
/*							0x0080	reserved by PC Card */
#define	UART_C_SPACE_PARITY	0x0100
#define	UART_C_MARK_PARITY	0x0200
#define	UART_C_ODD_PARITY	0x0400
#define	UART_C_EVEN_PARITY	0x0800

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
typedef struct COMMDEVSYSINFO {
	ABORTMASK	AbortMask;		/* 𒆒fA{[gv */
	ULONG		Reserved[7];
} COMMDEVSYSINFO;

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

typedef struct COMMDEVINFO {			/* on ROM or RAM */
	UART_INFO		*pUART;			/* UART */
	COMMDEVSYSINFO		*pSysInfo;	/* VXe */
	void			*rsv[14];	/* ̊gp(NULLŖ߂)*/
} COMMDEVINFO;


/*--------------------------------------------------------------------*/

typedef struct COMMDEVHEADER {
	PROC	ResetProc;		/* VXeZbgɌĂ΂Gg */
	PROC	*pProcTbl;		/* t@NṼWve[u */	
	short	TopProcNo;		/* pProcTbl̐擪t@NVԍ */
	short	LastProcNo;		/* pProcTbl̍Ō		V			*/
	COMMDEVINFO DevInfo;	/* foCX */
} COMMDEVHEADER;

/*  category */

/*--------------------------------------------------------------------*/

typedef struct COMMDEVCB {	/* R[obN */
	PROC	Proc;			/* R[obN֐Gg */
	void	*pWork;			/* R[obN֐֓n|C^ */
} COMMDEVCB;


/*--------------------------------------------------------------------*/

#define RX_BUF_SIZE 16

/* CBPROC [n] R[obN֐  ʒuCOMMDEVIRQMASKɑΉ */
#define	CBPROC_RECEIVE		0	/* M			*/
#define	CBPROC_SEND			1	/* M\		*/
#define	CBPROC_RCV_ERROR	2	/* MG[	*/
#define	CBPROC_SIGNAL_CHG	3	/* ω	*/
#define	CBPROC_RSV4			4	/* gp		*/
#define	CBPROC_RSV5			5	/* gp		*/
#define	CBPROC_TIMER		6	/* ^C}[	*/
#define	CBPROC_ABORT		7	/* A{[gigpj*/
#define	CBPROC_NUM			16


typedef volatile struct COMMDEV {		/* RAM */
	COMMDEVNAME	Name;			/*(p) foCX								*/
	USHORT		WorkType;		/*(w) COMMDEV\̂̃o[W					*/
	USHORT		WorkSize;		/*(w) COMMDEV\̂̃TCY						*/
	ABORTFLAG	*pAbortFlag;	/*(w) A{[gtÕAhX */
	ABORTMASK	AbortMask;		/*(p) A{[g}XN 							*/
	COMMDEVHEADER *pDevHeader;	/*(w) namẽfoCXwb_̃AhX			*/
	void		*pIObase;		/*(w) I/O|[g̃x[XAhX					*/
	COMMDEVMODE	Mode;			/*(p) n[h̐ݒ								*/
								/*	  mode.baudRate ͎ۂɐݒ肳ꂽ{[[g*/
	ULONG		WaitCounter10ms; /*(w)ResetWaitTimerCommDev֐A	*/
								/*	  WaitTimerCommDev֐ŎQƂ郏[N	*/
	COMMDEVIRQMASK IrqMask;		/*(p) 荞݃}XN */
	USHORT		Rsv0;			/* \ */
	ULONG		Status;			/*(w) ~ςĂXe[^X					*/
	int			ControlSig;		/*(w) ͐̏Ԃێ				*/
	COMMDEVCB	Callback[16];	/*(p) R[obN							*/
	long		Rsv1;			/* \ */
	long		Rsv2;			/* \ */
} COMMDEV;

/**** WorkTypeiMagic numberj****/
#define	COMMDEV_WORKTYPE1			((USHORT)0xCD01)
#define	COMMDEV_WORKTYPE_INVALID	((USHORT)0)

/**** COMMDEV.Status ****/
										/* << '1'̏ꍇ̈Ӗ >> */
#define	CDEVST_RCV_DATA_EXIST	0x0001	/* MFIFOɃf[^݂ */
#define	CDEVST_OVERRUN_ERR		0x0002	/* I[o[G[iMFIFOӂj */
#define	CDEVST_PARITY_ERR		0x0004	/* peB[G[ */
#define	CDEVST_FRAMING_ERR		0x0008	/* XgbvrbgMłȂ */
#define	CDEVST_RCV_BREAK		0x0010	/* u[NMM */
#define	CDEVST_SEND_FIFO_EMPTY	0x0020	/* MFIFOɋ󂫂 */
#define	CDEVST_TRANSMIT_EMPTY	0x0040	/* 񑗐Mԁitransmitter󂢂Ăj*/
#define	CDEVST_RCV_ERR			0x0080	/* MG[iMFIFÕf[^ŁA */
										/* G[𔺂̂Pȏ㑶݂j*/


/*====================================================================*/
/*					Cu֐vg^Cv錾					  */
/*====================================================================*/

/* SetSignalCommDev( , xxx ) */
typedef enum COMMDEVSIGCTRL {
	COMMSIG_DTR_INACTIVE,	/* DTR#M <- 'H' */
	COMMSIG_DTR_ACTIVE,		/* DTR#M <- 'L' */
	COMMSIG_RTS_INACTIVE,	/* RTS#M <- 'H' */
	COMMSIG_RTS_ACTIVE,		/* RTS#M <- 'L' */
	COMMSIG_OUT1_INACTIVE,	/*  */
	COMMSIG_OUT1_ACTIVE,	/*  */
	COMMSIG_OUT2_INACTIVE,	/*  */
	COMMSIG_OUT2_ACTIVE, 	/*  */
	COMMSIG_LOCAL_LOOP_ON,	/*  */
	COMMSIG_LOCAL_LOOP_OFF	/*  */
} COMMDEVSIGCTRL;

/* GetSignalCommDev( , xxx ) */
#define	COMMSIG_RXDLVL	0x40000000	/* {15pin diagp */
#define	COMMSIG_OUT2	0x00000800	/* 16550 */
#define	COMMSIG_OUT1	0x00000400	/* 16550 */
#define	COMMSIG_RTS		0x00000200
#define	COMMSIG_DTR		0x00000100

#define	COMMSIG_DCD		0x00000080
#define	COMMSIG_RI		0x00000040
#define	COMMSIG_DSR		0x00000020
#define	COMMSIG_CTS		0x00000010
#define	COMMSIG_DCDCHG	0x00000008
#define	COMMSIG_RICHG	0x00000004
#define	COMMSIG_DSRCHG	0x00000002
#define	COMMSIG_CTSCHG	0x00000001

#define COMMSIG_INACTIVE	0	/* ANeBu */


int InitCommDev( int );
int GetCommDevList( COMMDEVNAME *, UINT );
int	AddCommDev( COMMDEVNAME , const COMMDEVHEADER * );
int	RemoveCommDev( COMMDEVNAME );
int GetCommDevInfo( COMMDEVNAME, COMMDEVINFO * );

COMMDEVNAME GetNameCommDev( COMMDEV * );
ABORTMASK SetAbortMaskCommDev( COMMDEV *, ABORTMASK );
int ResetWaitTimerCommDev( COMMDEV * );
int WaitTimerCommDev( COMMDEV *, ULONG );
PROC SetCallbackCommDev( COMMDEV *, short, PROC *, void * );
PROC GetCallbackCommDev( COMMDEV *, short );

COMMDEV *LockCommDev( COMMDEVNAME );
int IsLockedCommDev( COMMDEVNAME );
int UnlockCommDev( COMMDEV * );
int SetModeCommDev( COMMDEV *, const COMMDEVMODE *, ULONG * );
int GetModeCommDev( COMMDEV *, COMMDEVMODE * );
int ReadCommDev( COMMDEV *, char *, int );
int WriteCommDev( COMMDEV *, const char *, int );
ULONG GetStatusCommDev( COMMDEV * );
int SetSignalCommDev( COMMDEV *, COMMDEVSIGCTRL );
int GetSignalCommDev( COMMDEV * );
int LookSignalCommDev( COMMDEV * );
int SetBreakCommDev( COMMDEV * );
int ClearBreakCommDev( COMMDEV * );

int ClearIRQCommDev( COMMDEV *, COMMDEVIRQMASK );
int	CauseIRQCommDev( COMMDEV *, COMMDEVIRQMASK );
COMMDEVIRQMASK EnableIRQMaskCommDev( COMMDEV *, COMMDEVIRQMASK );
COMMDEVIRQMASK DisableIRQMaskCommDev( COMMDEV *, COMMDEVIRQMASK );
COMMDEVIRQMASK SetIRQMaskCommDev( COMMDEV *, COMMDEVIRQMASK );
COMMDEVIRQMASK LookIRQMaskCommDev( COMMDEV * );

/*====================================================================*/
/*		(IOCS)ʐMnn[hEFAʃC^[tFCX(COMMDEV)		  */
/*		t@NV					trapa #COMM_HARD_HANDLER	  */
/*====================================================================*/

#define	INIT_COMM_DEV				0x40	/*  */
#define	GET_COMM_DEV_LIST			0x41	/* ʐMfoCXꗗ𓾂 */
#define	ADD_COMM_DEV				0x42	/* ʐMfoCXǉ */
#define	REMOVE_COMM_DEV				0x43	/* ʐMfoCX폜 */
#define	GET_COMM_DEV_INFO			0x44	/* ʐMfoCX̏𓾂 */
#define	GET_NAME_COMM_DEV			0x49	/* foCX𓾂 */
#define	SET_ABORT_MASK_COMM_DEV		0x4a	/* A{[g}XNݒ肷 */
#define	RESET_WAIT_TIMER_COMM_DEV	0x4c	/* ҂^C}[̃Zbg */
#define	WAIT_TIMER_COMM_DEV			0x4d	/* w莞Ԃ̒dwait */
#define	SET_CALLBACK_COMM_DEV		0x4e	/* R[obN[`Zbg */
#define	GET_CALLBACK_COMM_DEV		0x4f	/* R[obN[`𓾂 */

#define	LOCK_COMM_DEV				0x50	/* ʐMfoCXL */
#define	IS_LOCKED_COMM_DEV			0x51	/* LĂ邩q˂ */
#define	UNLOCK_COMM_DEV				0x52	/* ʐMfoCXL */
#define	SET_MODE_COMM_DEV			0x53	/* 샂[hݒ肷 */
#define	GET_MODE_COMM_DEV			0x54	/* 샂[h𓾂 */
#define	READ_COMM_DEV				0x55	/* Mf[^ǂ */
#define	WRITE_COMM_DEV				0x56	/* Mf[^ */
#define	GET_STATUS_COMM_DEV			0x57	/* Xe[^Xǂ */
#define	SET_SIGNAL_COMM_DEV			0x58	/* Miój̐ݒ */
#define	GET_SIGNAL_COMM_DEV			0x59	/* Míj(IRQ clr)*/
#define	LOOK_SIGNAL_COMM_DEV		0x5a	/* Míj */
#define	SET_BREAK_COMM_DEV			0x5b	/* u[NԂɂ */
#define	CLEAR_BREAK_COMM_DEV		0x5c	/* u[NԂ */
#define	CLEAR_IRQ_COMM_DEV			0x5e	/* 荞ݗvNA */
#define	CAUSE_IRQ_COMM_DEV			0x5f	/* 荞ݗvZbg */
#define	ENABLE_IRQ_MASK_COMM_DEV	0x60	/* 荞݂ */
#define	DISABLE_IRQ_MASK_COMM_DEV	0x61	/* 荞݂֎~ */
#define	SET_IRQ_MASK_COMM_DEV		0x62	/* 荞݃}XNݒ肷 */
#define	LOOK_IRQ_MASK_COMM_DEV		0x63	/* 荞݃}XNǂݏo */


/*====================================================================*/
/*							   }N								  */
/*====================================================================*/

#define	BuildCommDevMode( mode, baud, datalen, parity, stopbit ) \
		( mode.WorkType = COMMDEVMODE_TYPE1, \
		  mode.ByteSize = datalen,			 \
		  mode.Parity   = parity,			 \
		  mode.StopBits = stopbit,			 \
		  mode.BaudRate = baud )

/* ONLY for driver ( NOT for user ) */
/* pDevCOMMDEV\̂wĂ邩ǂ𒲂ׂ */
/* wĂꍇ true, wĂȂꍇfalseԂ */

#define IsValidCommDevPtr(pDev) ((pDev)->WorkType==COMMDEV_WORKTYPE1) 


/*====================================================================*/
/*							̑萔								  */
/*====================================================================*/

/* ReadCommDev()ŎMf[^ǂݎ̂Ă鎞́Achar[]obt@̃TCY */
#define	COMMDEV_WASTE_LEN	256


/*====================================================================*/
/*							G[R[h							  */
/*====================================================================*/

#ifndef NULL
#define	NULL ((void*)0)
#endif

#define	EC_COMMDEV_NOTEXIST			(COMMDEV_EC_BASE+0x00)
#define	EC_COMMDEV_LOCKED			(COMMDEV_EC_BASE+0x01)
#define	EC_COMMDEV_CONFLICTED		(COMMDEV_EC_BASE+0x02)
#define	EC_COMMDEV_BAD_PTR			(COMMDEV_EC_BASE+0x03) /* pDevs */
#define	EC_COMMDEV_BROKEN_CONTEXT	(COMMDEV_EC_BASE+0x04) /* [NĂ */
#define	EC_COMMDEV_BAD_WORKTYPE		(COMMDEV_EC_BASE+0x05) /* WorkType */
#define	EC_COMMDEV_BAD_PARAM		(COMMDEV_EC_BASE+0x06) /*  */
#define	EC_COMMDEV_FULL_DEVICES		(COMMDEV_EC_BASE+0xE0) /* foCXo^łȂ */
#define	EC_COMMDEV_ABORTED			(COMMDEV_EC_BASE+0xFEFF) /* aborto */
#define	EC_COMMDEV_UNSUPPORTED		(COMMDEV_EC_BASE+0xFFFE) /* `Func */
#define	EC_COMMDEV_ERROR			(COMMDEV_EC_BASE+0xFFFF) /* LȊÕG[ */


#endif	/* #ifndef _COMDVLIB_H_INCLUDED */

/* end of comdvlib.h */

