/***********************************************************************
<t@C>	csvlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		CSVtH[}bgCu
***********************************************************************/

#ifndef _CSVLIB_H_INCLUDED
#define _CSVLIB_H_INCLUDED
#include <sharpgen.h>
#include <file.h>
#include <misctool.h>
#include <dtmlib.h>

/*======================================================================
		G[R[h
======================================================================*/


#ifndef SUCCESS
#define SUCCESS	0
#endif

#define	EC_CSV_FOUND_CRLF			 -1 /* sR[hiǂݍ݁j */
#define	EC_CSV_READ_EOF				 -2	/* EOFǂݍ */
#define	EC_CSV_BROKEN_FORMAT		 -3	/* "f[^ُł" */
#define	EC_CSV_OTHERS_DATA			 -4	/* "f[^Ⴂ܂" */
#define	EC_CSV_BAD_APLNAME			 -7	/* CSV"M"sAplNameႢ܂ */
#define	EC_CSV_BAD_IDENTIFIER		-10	/* ڎʖ */
#define	EC_CSV_BAD_STRUCT_NAME		-11	/* f[^\ */
#define	EC_CSV_BAD_CONVERT_NAME		-12	/* f[^ϊ` */
#define	EC_CSV_BROKEN_BINFILE		-13	/* "BINFILE"f[^ */
#define	EC_CSV_UNKNOWN_FORMAT		-14	/* mȂ` */
#define	EC_CSV_BROKEN_TEXTFILE		-15	/* "TEXTFILE"f[^ */
#define	EC_CSV_SOME_INFO_DROPPED	-16	/* ꕔ̏񂪌 */

#define	EC_CSV_BAD_PARTNER			-20	/* ʐMłȂƌq */
#define	EC_CSV_COULDNOT_ALLOC_HEAP	-30	/* q[vmۂłȂ */

#define	EC_CSV_BROKEN_3TO4			-50	/* 3to4f[^ */
#define	EC_CSV_BROKEN_BAHEX2		-51 /* BAHEX2f[^ */
#define	EC_CSV_BROKEN_1BHEX2		-52
#define	EC_CSV_BROKEN_1WHEX4		-53
#define	EC_CSV_BROKEN_1LHEX8		-54

#define	EC_CSV_UNKNOWN_RULE			-60	/* ϊK킩Ȃ */

#define	EC_CSV_CONVERT_ERROR		-70	/* CSVϊłȂ */

#define	EC_CSV_BIGGEST_DATA		-75 /* Mf[^傫܂ */

#define	EC_CSV_DTM_ERROR			  -100 /* f[^}l[WG[ */
#define	EC_CSV_BOXOPEN_FAILED		  -101 /* BoxOpen()łȂ */
#define	EC_CSV_CREATESYSCARD_FAILED	  -102
#define	EC_CSV_CARDWRITE_FAILED		  -103
#define	EC_CSV_CARDREAD_FAILED		  -104
#define	EC_CSV_CARDCOPY_FAILED		  -105
#define	EC_CSV_BOXITEMREAD_FAILED	  -106
#define	EC_CSV_INDEXINFOREAD_FAILED	  -107
#define	EC_CSV_INDEXSEARCH_FAILED	  -108
#define	EC_CSV_INDEXNOTOCARDID_FAILED -109
#define EC_CSV_INDEXCOUNT_FAILED	  -110
#define	EC_CSV_BOXCARDTOTAL_FAILED	  -111
#define	EC_CSV_BOXCREATE_FAILED		  -112
#define EC_CSV_BOXITEMAPPEND_FAILED	  -113
#define	EC_CSV_GETMASTERINDEX_FAILED  -114

#define	EC_CSV_DTM_MEM_ERR			  -120	/* tbVfull */

#define	EC_CSV_FILEROPEN_FAILED		  -150
#define EC_CSV_CREATECTGRID_FAILED	  -151
#define	EC_CSV_GETCTGRTITLE_FAILED	  -152
#define EC_CSV_GETCTGRID_FAILED		  -153
#define	EC_CSV_CTGR_OVER			  -154	/* VḰuJeSvȂiɒBj*/

#define	EC_CSV_FILE_SYSTEM_FULL		  -200	/* "L̈悪܂" */
#define	EC_CSV_FILEOPEN_FAILED		  -201
#define	EC_CSV_FILEINFOREAD_FAILED	  -202
#define	EC_CSV_FILEBLOCKREAD_FAILED	  -203
#define	EC_CSV_FILECREATE_FAILED	  -204
#define	EC_CSV_FILEBLOCKWRITE_FAILED  -205


#define	EC_CSV_BAD_PARAM			-512	/* p[^ */


/*======================================================================
		^錾
======================================================================*/

/*----------------------------------------------------------------------
	CSV[`̃R[obN
----------------------------------------------------------------------*/

/*  */
typedef USHORT	MTOTAL;		/* 16i4 */
typedef	MTOTAL	MCOUNT;

typedef	ULONG	DTOTAL;		/* 16i8 */
typedef	DTOTAL	DCOUNT;


typedef struct CSVSTATE {
	ULONG	Count;			/* _OtpJEgl */
	ULONG	MaxCount;		/* _Otpől */
	ULONG	OldCount;		/* OCount̒liCSVW[pj*/
	MCOUNT	MCount;			/* t@Ci"M"sj*/
    MTOTAL	MTotal; 		/* t@Ci"M"sj */
    DCOUNT	DCount;		    /* "D"s */
    DTOTAL	DTotal; 		/* "D"s */
    UCHAR   FileName[96];   /* ݏ̃t@C */
} CSVSTATE;

/* R[obN֐̎dl */
typedef CBPROC CSVCBPROC;

/*** CSVSTATE.MaxCount/DTotal ***/
#define	CSV_TOTAL_LINE_UNKNOWN	0xffffffff		/* ls̏ꍇɗp */
#define	CSV_TOTAL_LINE_UNKNOWN_STR	"********"


/*----------------------------------------------------------------------
	ParseCSV()̈
	
----------------------------------------------------------------------*/

typedef struct CSVPARSEPARAM {
	APLID		AplName;	/* AvP[V */
	CSVCBPROC	CBProc;		/* R[obN֐ւ̃|C^ID */
	void		*pWork;		/* R[obN֐PƂėp|C^ */
	CSVSTATE	*pState;	/* R[obN֐QƂėp|C^ */
	ULONG		Rsv[2];		/* \ */
} CSVPARSEPARAM;


/*----------------------------------------------------------------------
	ParseCSV()̌
	
----------------------------------------------------------------------*/

typedef struct CSVPARSEREPORT {
	CARDID	LastCardID;		/* Ōɓo^Card ID("BOXFILE"`L)*/
    UCHAR   FileName[96];   /* Ōɏt@C */
	UCHAR	LastCategoryID;	/* LastCardID́uŏ́vCategoryID */
	UCHAR	Rsv1[3];		/* \ */
	ULONG	LastAplName;	/* Ōɏt@CǗAv */
} CSVPARSEREPORT;

/*** CSVPARSEREPORT.LastCategoryID ***/
#define	CSV_REPORT_NO_CATEGORY	(UCHAR)0x00	/* JeS݂͑Ȃ */


/*----------------------------------------------------------------------
	BuildIdxCSV()̈
	*.IDXt@ĆAׂf[^w肷
----------------------------------------------------------------------*/
typedef	struct CSVSPECIFYIDX { 
	UCHAR	*pIdxPathName;	/* CfbNXpX */
	USHORT	TopIdxNo;		/* ŏIDX No.iID͊܂܂Ȃj*/
	USHORT	EndIdxNo;		/* ŌIDX No.iID͊܂ށj*/
	UCHAR	*pSearchCond;	/* (DTM)̃AhX */
	UCHAR	AttrMask;		/* Agr[gr}XN */
	UCHAR	AttrCond;		/* Agr[grl */
	USHORT	Rsv1;			/* \ */
} CSVSPECIFYIDX;			/* Av ɌŒ */

/*** .TopIdxNo/.EndIdxNo ***/
#define	ALL_TOP_INDEX	0
#define	ALL_END_INDEX	0xFEFF

/*----------------------------------------------------------------------
	BuildIdxCSV()̈
----------------------------------------------------------------------*/

typedef struct CSVBUILDPARAM {
	APLID		AplName;	/* AvP[V */
	CSVCBPROC	CBProc;		/* R[obN֐ւ̃|C^ID */
	void		*pWork;		/* R[obN֐PƂėp|C^ */
	CSVSTATE	*pState;	/* R[obN֐QƂėp|C^ */
	char		*pTitle;	/* "H"s^Cgɗp镶ւ̃|C^ */
	UCHAR		Model;		/* @ */
	UCHAR		FilerMode;	/* ef[^"BOOK"邩ǂH */
	UCHAR		CategoryID;	/*iPj*/
	UCHAR		Rsv1[1];	/* \ */
	ULONG		Rsv2[1];	/* \ */
} CSVBUILDPARAM;

/**** CSVBUILDPARAM.Model ***/
#define	CSV_MI10	(UCHAR)1	/* MI-10` */
#define	CSV_BV2		(UCHAR)2	/* PV-F1/PI-3000`` */
#define CSV_HYPER	(UCHAR)3	/* DBZ` */

/**** CSVBUILDPARAM.FilerMode ***/
/* "BOXFILE"`̊e"D"s'CTGR'ڂ
   o͂Ȃ^P̂ݏó^Sďo ItO */
#define	CSV_FLER_NONE	(UCHAR)0x00	/* Ȃ */
#define	CSV_FLER_ONE	(UCHAR)0x01	/* CategoryIDiPjŎw肵P̂ */
#define	CSV_FLER_ALL	(UCHAR)0xFF	/* SĂ */

/**** CSVBUILDPARAM.AplName ***/
/* MI-10 schedule/action list/LOPAvP[VŎĂ邪
   f[^MAꂼʂAӂ邢KvB*/
#define	APLNAME_SCDL	'SCDL'
#define	APLNAME_TODO	'TODO'
#define	APLNAME_ANNV	'ANNV'


/*----------------------------------------------------------------------
	CSVf[^̌`
----------------------------------------------------------------------*/

typedef enum CSVFMTTYPE_E {
	CSVFMTTYPE_NOT_SUPPORT = -1,	/* CSV[`ňȂt@C */
	CSVFMTTYPE_BOXFILE = 0,			/* BOXt@C */
	CSVFMTTYPE_BINFILE,				/* oCit@C */
	CSVFMTTYPE_TXTFILE				/* eLXgt@C */
} CSVFMTTYPE_E;


/*======================================================================
	Cu֐vg^Cv錾
======================================================================*/

/* CSVf[^ǂ */
int ParseCSV( const UCHAR *pOutputDrvName,
			  const UCHAR *pInputCsvFileName,
			  const CSVPARSEPARAM *pParam,
			  CSVPARSEREPORT *pReport );

/* P*.IDXt@CCSVf[^쐬 */
int BuildIndexCSV( const UCHAR *pOutDevName,
				   const CSVSPECIFYIDX *pSpecifyIdx,
				   const CSVBUILDPARAM *pParam );

/* Pȏ*.IDXt@CCSVf[^쐬iFILERpj*/
int BuildSomeIndexCSV( const UCHAR *pOutDevName,
					   const CSVSPECIFYIDX aSpecifyIdx[],
					   UINT IndexNum,
					   const CSVBUILDPARAM *pParam );

/* obNAbvpCSVf[^쐬 */
int	BuildBackupCSV( const UCHAR *pOutDevName,
				    const UCHAR *pBkupDevName,
				    const CSVBUILDPARAM *pParam );


#endif /* #ifndef _CSVLIB_H_INCLUDED */



