/***********************************************************************
<t@C>	drfio.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
***********************************************************************/

#ifndef	_DRFIO_H_INCLUDED
#define	_DRFIO_H_INCLUDED

#include 	"file.h"
#include	"stdiozrs.h"
#include	"dtmlib.h"

/* DRFFILE\̂̒` */

typedef	struct RESFILE {
	UCHAR	*Filename ;
	UINT	Offset ;
	USHORT	ResourceID ;
    FERROR	FError ;
}RESFILE ;

typedef struct DTMFILE {
	ITEMNAME	ItemName ;
	UINT		Offset ;
	CARDID		CardID ;
	BOXHANDLE	BoxHandle ;
	FERROR		FError ;
}DTMFILE ;

typedef struct RAMFILE {
	HANDLE	HeapHandle ;
	UINT	Offset ;
	UINT	Size ;
	FERROR	FError ;
}RAMFILE ;

typedef union DRF {
	DTMFILE	DtmFileStr ;
	RESFILE	ResFileStr ;
	FILE	*FileStr ;
	RAMFILE	RamFileStr ;
}DRF;

typedef struct DRFFILE {
	UINT	Mode ;
	FERROR	FError ;
	DRF		Drf;
}DRFFILE ;


/* Mode̒` */
#define	FileMode	1
#define	ResMode		2
#define	DtmMode		3
#define RamMode		4

/* vg^Cv */

int DRFfwrite(char *buffer,int size,int nitems,DRFFILE *FileStr);
int DRFfread(char *buffer,int size,int nitems,DRFFILE *FileStr);
int DRFferror(DRFFILE *FileStr);
int DRFfseek(DRFFILE *FileStr,long offset,int ptrname);

int DRFfwriteNew(char *buffer,int size,int nitems,DRFFILE *FileStr);

#endif
