/***********************************************************************
<t@C>	eventmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		CxgbZ[Wi\IDj̒`
***********************************************************************/

#ifndef	_EVENTMSG_H_INCLUDED
#define	_EVENTMSG_H_INCLUDED
#include <sharpgen.h>
#include <timelib.h>	/* nbZ[W TIME\̗p */
#include <file.h>
/* #include	<comdvlib.h> */
/* #include	<bcommlib.h> */

/***********************************************************************
				bZ[W\
***********************************************************************/

/*----------------------------------------------------------------------
		ʃbZ[W
----------------------------------------------------------------------*/

typedef struct EMSG_NULLMESSAGE		/*  kbZ[W  */
{
	USHORT	MessageID;		/*  NullMessageID  */
	USHORT	OccuredTime;	/*    */
} EMSG_NULLMESSAGE;


/*======================================================================
		CxgbZ[W
======================================================================*/

/*----------------------------------------------------------------------
		VXe֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_DUMMYEVENT		/*  _~[Cxg  */
{
	USHORT	MessageID;		/*  DummyEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_DUMMYEVENT;

typedef struct	EMSG_CAUTIONLOWBAT	/* R[Vx̃[obe[*/
{
	USHORT	MessageID;		/*  CautionLowBatID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_CAUTIONLOWBAT;


/*----------------------------------------------------------------------
		A{[g֌W
----------------------------------------------------------------------*/


typedef struct	EMSG_FATALLOWBAT	/* tFC^x̃[obe[*/
{
	USHORT	MessageID;		/*  FatalLowBatID   */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_FATALLOWBAT;

typedef struct	EMSG_AUTOPOWEROFF	/*  I[gp[It  */
{
	USHORT	MessageID;		/*  AutoPowerOffID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_AUTOPOWEROFF;

typedef struct	EMSG_LOCKSWOPEN		/*  J[hbNXCb`J  */
{
	USHORT	MessageID;		/*  LockSwOpenID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_LOCKSWOPEN;

typedef struct	EMSG_BATCOVEROPEN	/*  drWJ  */
{
	USHORT	MessageID;		/*  BatCoverOpenID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_BATCOVEROPEN;

typedef struct	EMSG_POWEROFF		/*  p[It  */
{
	USHORT	MessageID;		/*  PowerOffID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_POWEROFF;

typedef struct  EMSG_PCCARDABORT
{
	USHORT	MessageID;		/*  PCCardAbortID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	USHORT	Socket;			/* _\Pbgԍ */
	USHORT	Factor;			/* v */
} EMSG_PCCARDABORT;

/*** EMSG_PCCARDABORT.Factor ***/		/* abort.hABORTMASK̏16bit */
#define	PCCABT_BATT_SHORT		0x0000	/* 0: drsPCCardgps */

#define	PCCABT_BEING_EJECTED	0x0001	/* bit0: eject{^삳ꂽ */
#define	PCCABT_REMOVED			0x0002	/* bit1: J[h */
#define	PCCABT_SHUTDOWN			0x0004	/* bit2: ׂ̂ߓd */
#define	PCCABT_WPCHANGED		0x0008	/* bit3: WriteProtect삳ꂽ */


/*----------------------------------------------------------------------
		Iy[Vɂ钆f֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_ONBREAK		/*  nmuCN  */
{
	USHORT	MessageID;		/*  OnBreakID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_ONBREAK;


/*----------------------------------------------------------------------
		y֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_PENDOWN		/*  yn  */
{
	USHORT	MessageID;		/*  PenDownID */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	PenAttr;		/*  modifier key̏  */
	UCHAR	WindowNo;		/*  EBhEnhm  */
	short	PositionX;		/*  yꏉ߂Ww  */
	short	PositionY;		/*  yꏉ߂WY  */
} EMSG_PENDOWN;

typedef struct	EMSG_PENSTILLDOWN	/*  y  */
{
	USHORT	MessageID;		/*  PenStillDownID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	PenAttr;		/*  modifier key̏  */
	UCHAR	WindowNo;		/*  EBhEnhm  */
	short	PositionX;		/*  y݉ĂWw  */
	short	PositionY;		/*  y݉ĂWY  */
	short	StartPositionX;	/*  yꏉ߂Ww  */
	short	StartPositionY;	/*  yꏉ߂WY  */
} EMSG_PENSTILLDOWN;

typedef struct	EMSG_PENUP			/*  y  */
{
	USHORT	MessageID;		/*  PenUpID */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	PenAttr;		/*  modifier key̏  */
	UCHAR	WindowNo;		/*  EBhEnhm  */
	short	PositionX;		/*  yꂽWw  */
	short	PositionY;		/*  yꂽWY  */
	short	StartPositionX;	/*  yꏉ߂Ww  */
	short	StartPositionY;	/*  yꏉ߂WY  */
} EMSG_PENUP;

typedef struct	EMSG_PENRELEASED	/* i\tg[XŁjy  */
{
	USHORT	MessageID;		/*  PenReleasedID */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	PenAttr;		/*  modifier key̏  */
	UCHAR	WindowNo;		/*  EBhEnhm  */
	short	PositionX;		/*  yꂽWw  */
	short	PositionY;		/*  yꂽWY  */
	short	StartPositionX;	/*  yꏉ߂Ww  */
	short	StartPositionY;	/*  yꏉ߂WY  */
} EMSG_PENRELEASED;


/*----------------------------------------------------------------------
		L[֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_KEYDOWN		/*  L[  */
{
	USHORT	MessageID;		/*  KeyDownID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	KeyAttr;		/*  modifier key̏  */
	UCHAR	KeyRepeat;		/*  repeatǂ̃tO */
	USHORT	KeyCode;		/*  ꂽL[̃L[R[h  */
} EMSG_KEYDOWN;

/* PenAttr or KeyAttr */
#define	MODIF_2ndF		0x04		/*u@\vON */
									/* MI-10ȍ~ł͂gp邱 */
#define	MODIF_Shift		0x08		/* Shift ON */
#define	MODIF_Ctrl		0x01		/* Ctrl ON */

#define ModifierOn		MODIF_2ndF	/*iESR-P\[Xpj*/

/* KeyRepeat */
#define	KEY_FIRST		0x00		/*un߁vKeyDown */
#define	KEY_REPEAT		0x01		/* repeatĂKeyDown  */




typedef struct	EMSG_MODIFIERCHANGED	/*  modifierω  */
{
	USHORT	MessageID;		/*  ModifierChangedID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	Modifier;		/*  ωmodifier key̏  */
} EMSG_MODIFIERCHANGED;

typedef struct	EMSG_KEYDRVDOWN		/*  L[  */
{
	USHORT	MessageID;		/*  KeyDrvDownID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	UCHAR	KeyAttr;		/*  modifier key̏  */
	UCHAR	KeyRepeat;		/*  repeatǂ̃tO */
	UCHAR	KeyCode;		/*  ꂽL[̃L[R[h  */
} EMSG_KEYDRVDOWN;

typedef struct	EMSG_KEYDRVSTATUS	/*  L[{[hhCo[ω  */
{
	USHORT	MessageID;		/*  KeyDrvStatusID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	ULONG	KeyBoardName;	/*  L[{[h */
	UCHAR	Status;			/*  ω̃L[{[h̏  */
} EMSG_KEYDRVSTATUS;

/*----------------------------------------------------------------------
		菑F֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_HWRECOGCOMPLETED	/* 菑F */
{
	USHORT	MessageID;		/*  HWRecogCompletedID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
    UCHAR   FrameNo;        /*	F̘gԍ */
} EMSG_HWRECOGCOMPLETED;


/*----------------------------------------------------------------------
		^C~O֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_FASTTICK	/*  ݒ肷ƈ莞ԊԊuŔ  */
{
	USHORT	MessageID;		/*  FastTickID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)  */
	ULONG	Count;			/*	FastTickJEgl */
} EMSG_FASTTICK;


/*----------------------------------------------------------------------
		ʐMhCo֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_BCOMDATAARRIVE	/*	MQueueփf[^ */
{
	USHORT	MessageID;		/*  BCommDataArriveID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	void	*pBCom;			/*	(BCOM) BCOMnh  */
} EMSG_BCOMDATAARRIVE;

typedef struct	EMSG_BCOMVACANTTXQUE	/*	MQueue󂢂Ă */
{
	USHORT	MessageID;		/*  BCommVacantTxQueID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	void	*pBCom;			/*	(BCOM) BCOMnh  */
} EMSG_BCOMVACANTTXQUE;

typedef struct	EMSG_BCOMRIRINGING	/*	RIiĂїjMĂ */
{
	USHORT	MessageID;		/*  BCommRIRingingID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	void	*pBCom;			/*	(BCOM) BCOMnh  */
} EMSG_BCOMRIRINGING;

typedef struct	EMSG_BCOMDCDOFF	/*	DCDiLAojMOFFɂȂ */
{
	USHORT	MessageID;		/*  BCommDCDOffID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	void	*pBCom;			/*	(BCOM) BCOMnh  */
} EMSG_BCOMDCDOFF;

typedef struct mangqevent {
	int				EventType;
	unsigned int 	ResultQueue;
	int				Parameter;
} mangqevent;

typedef struct	EMSG_PPPMANAGEREVENT	/*  PPPRlNV}l[W  */
{
	USHORT		MessageID;		/*  PPPManagerEventID  */
	USHORT		OccuredTime;	/*  (bZ[WT[oǗ)i[ */
	mangqevent	Qbuf;			/*  }l[WCxg  */
} EMSG_PPPMANAGEREVENT;

typedef struct	EMSG_TCPIPNSELECTEVENT	/* TCP/IP nselect()*/
{
	USHORT		MessageID;		/*  TcpipNselectEventID     */
	USHORT		OccuredTime;	/*  (bZ[WT[oǗ)i[ */
	long		Wait;			/*  nselect()  wait time    */
	ULONG		Arg;			/*             process name */
	short		Socket;			/*             socket ID    */
	USHORT		OutFlags;		/*             outflags     */
} EMSG_TCPIPNSELECTEVENT;

typedef struct	EMSG_RESOLVEREVENT		/* resolver */
{
	USHORT		MessageID;		/*  ResolverEventID     */
	USHORT		OccuredTime;	/*  (bZ[WT[oǗ)i[ */
	UCHAR		MessageType;
	UCHAR		RequestID;
	UCHAR		Result;
	UCHAR		Reserved;		/* 󂫁ialignment̂߁j*/
	ULONG		ResultProcess;
	ULONG		ResolverInfo;
} EMSG_RESOLVEREVENT;


/*----------------------------------------------------------------------
		t@C֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_FILEDATAARRIVE	/*	̓f[^ */
{
	USHORT	MessageID;		/*  FileDataArriveID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	FILEHD	FileNo;			/*  t@Cnh */
} EMSG_FILEDATAARRIVE;


/*----------------------------------------------------------------------
		֌W
		iALARMBALARMAPM̓sŕʃO[vɂȂj
----------------------------------------------------------------------*/

typedef struct	EMSG_HOUREVENT		/*  WOOɂȂ  */
{
	USHORT	MessageID;		/*  HourEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	TIME	StandardTime;	/*  vƂȂW  */
} EMSG_HOUREVENT;

typedef struct	EMSG_MINUTEEVENT	/*  ΎOObɂȂ  */
{
	USHORT	MessageID;		/*  MinuteEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	TIME	StandardTime;	/*  vƂȂW  */
} EMSG_MINUTEEVENT;

typedef struct	EMSG_LOCALHOUREVENT	/*  [JOOɂȂ  */
{
	USHORT	MessageID;		/*  LocalHourEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	TIME	LocalTime;		/*  vƂȂ[J  */
} EMSG_LOCALHOUREVENT;

typedef struct	EMSG_LOCALDAYEVENT	/*  [JOOɂȂ  */
{
	USHORT	MessageID;		/*  LocalDayEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	TIME	LocalTime;		/*  vƂȂ[J  */
} EMSG_LOCALDAYEVENT;


/*----------------------------------------------------------------------
		A[֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_ALARMEVENT		/*  A[ɂȂ  */
{
	USHORT	MessageID;		/*  AlarmEventID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	TIME	StandardTime;	/*  vƂȂW  */
	TIME	AlarmTime;		/*  vƂȂA[  */
} EMSG_ALARMEVENT;

typedef struct	EMSG_COMMDEVRINGDETECTED
{
	USHORT	MessageID;		/* CommDevRingDetectedID */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
	ULONG	DevName;		/* COMMDEVNAME RingofoCX */
} EMSG_COMMDEVRINGDETECTED;

/*----------------------------------------------------------------------
		^C~O֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_SYSTEMTICK	/*  莞ԊԊuŔ */
{
	USHORT	MessageID;		/*  NullMessageID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)  */
	ULONG	Count;			/*	TickJEgl */
} EMSG_SYSTEMTICK;


/*----------------------------------------------------------------------
		PC-Card ֌W
----------------------------------------------------------------------*/

typedef	struct	EMSG_PCCARDDETECTED {	/* PC-CardڑĂiʑOj*/
	USHORT		MessageID;		/* PCCardDetectedID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
} EMSG_PCCARDDETECTED;

typedef struct	EMSG_PCCARDAVAILABLE {	/* PC-Cardgp\ɂȂ */
	USHORT		MessageID;		/* PCCardAvailableID */
	USHORT		OccuredTime;
	ULONG		Type;			/* J[h̎ށiރR[hj*/
	USHORT		Socket;			/* _\Pbgԍ */
	UCHAR		Name[10];
} EMSG_PCCARDAVAILABLE;

typedef	struct	EMSG_PCCARDUSELESS {	/* PC-Card͎gȂ */
	USHORT		MessageID;		/* PCCardUselessID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
} EMSG_PCCARDUSELESS;

typedef	struct	EMSG_PCCARDBEINGEJECTED {	/* PC-CardEject悤ƂĂ */
	USHORT		MessageID;		/* PCCardBeingEjectedID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
} EMSG_PCCARDBEINGEJECTED;

typedef	struct	EMSG_PCCARDREMOVED {	/* PC-CardOꂽ */
	USHORT		MessageID;		/* PCCardRemovedID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
} EMSG_PCCARDREMOVED;

typedef	struct	EMSG_PCCARDSHUTDOWN {	/* PC-Card̓d~() */
	USHORT		MessageID;		/* PCCardShutDownID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
} EMSG_PCCARDSHUTDOWN;

typedef	struct	EMSG_PCCARDWPCHANGED {	/* PC-CardWP switch삳ꂽ */
	USHORT		MessageID;		/* PCCardWPChangedID */
	USHORT		OccuredTime;
	USHORT		Socket;			/* _\Pbgԍ */
	UCHAR	   	WPState;		/* WPXCb`̏ */
} EMSG_PCCARDWPCHANGED;

/*** .WPState ***/
#define	WPSTATE_WRITEABLE	0x00	/* ݉ */
#define	WPSTATE_PROTECTED	0x01	/* ݋֎~ */


typedef enum CSEVENTCLIENTS {
	CLI_ALL,		/* SNCAg֔z */
	CLI_SOCKET,		/* P\PbgɂԂ牺ĂNCAg֔z */
	CLI_MTD,		/* eNmWhCo֔z */
	CLI_REQUESTER,	/* vi֐Ă񂾃NCAgj֔z */
	CLI_PROVIDOR	/* ֔z */
} CSEVENTCLIENTS;

typedef struct CARDSVCEVENT {
	USHORT			Socket;			/* _\Pbgԍ */
	USHORT			EventCode;		/* J[hT[rXCxgԍ */
	ULONG			Registant;		/* o^҃NCAgnh */
	CSEVENTCLIENTS	Client;			/* Cxg̔z */
	USHORT			Info;			/* Cxgɕt */
	short			Reserved;		/* ̊gp */
} CARDSVCEVENT;		/* ȏgłȂ
					   iCxgbZ[W̃TCY(20[byte])̂߁j*/

typedef	struct	EMSG_CARDSVCEVENT {		/* Card Servicesgpp */
	USHORT			MessageID;
	USHORT			OccuredTime;
	CARDSVCEVENT	CSEvent;
} EMSG_CARDSVCEVENT;


/*----------------------------------------------------------------------
		d֌W
----------------------------------------------------------------------*/

typedef struct	EMSG_ACADAPTORCONNECTED
{
	USHORT	MessageID;		/*  ACAdaptorConnectedID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_ACADAPTORCONNECTED;

typedef struct	EMSG_ACADAPTORDISCONNECTED
{
	USHORT	MessageID;		/*  ACAdaptorDisconnectedID  */
	USHORT	OccuredTime;	/*  (bZ[WT[oǗ)i[  */
} EMSG_ACADAPTORDISCONNECTED;


/*----------------------------------------------------------------------
		[U[Cxg
----------------------------------------------------------------------*/

typedef	struct	EMSG_USEREVENT {	/* [U[RɎg郁bZ[WID */
	USHORT		MessageID;		/* UserEventID */
	USHORT		OccuredTime;	/* (bZ[WT[oǗ) */
	APLID		AplName;		/* zAvP[V */
	USHORT		EventID;		/* AvP[VɓƗČ߂ID */
	char		FreeArea[10];	/* RɎgp\ȃGA */
} EMSG_USEREVENT;



/***********************************************************************
					CxgbZ[W}XN̒`


  yMESSAGE MASK̍\z
		PbZ[WO[vi20IDjɑ΂ĂPbit蓖ĂB

  (MSB)
  bit31  30  29  28  27  26  25  24  23  22  21  20  19  18  17  16
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
	|<----- APM messagep ----->|USR|<-- reserved-->|PWR PCC TMG ALM|
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
									 <---- for all applications ----

																(LSB)
  bit15  14  13  12  11  10   9   8   7   6   5   4   3   2   1   0
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
	|TIM|<----- reserved ------>|FIL COM FST HWR KEY PEN BRK ABT SYS|
	+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+
	---> <---------------- for ACTIVE application ----------------->


 ebit'1'̂ƂAYbZ[WO[vget/look̑ΏۂƂ

	bZ[WT[o[ bit31`25𖳎B
	bit24    ́AAPMbZ[WŎw肳ꂽAvP[Vւ̂
				 zCxgbZ[W
	bit23`15́AAPMSAvP[V֔zCxgbZ[W
	bit14` 0́AAPMANeBuAvP[V݂̂֔z
				 CxgbZ[W

***********************************************************************/

/* bZ[W}XŇ^ */
typedef unsigned long	EVENTMSGMASK;

#define	MSGMSK_SYSTEM	0x000001 /* SYS: VXe		ID=100`119	*/
#define	MSGMSK_ABORT	0x000002 /* ABT: A{[g		ID=120`139	*/
#define	MSGMSK_BREAK	0x000004 /* BRK: f			ID=140`159	*/
#define	MSGMSK_PEN		0x000008 /* PEN: y			ID=160`179	*/
#define	MSGMSK_KEY		0x000010 /* KEY: L[			ID=180`199	*/
#define	MSGMSK_HWRECOG	0x000020 /* HWR: 菑F	ID=200`219 */
#define	MSGMSK_FASTTMG	0x000040 /* FST: ^C~O	ID=220`239 */
#define	MSGMSK_COM		0x000080 /* COM: ʐMn(SIO)	ID=240`259	*/
#define	MSGMSK_FILE		0x000100 /* FIL: t@C		ID=260`279 */
/* #define	MSGMSK_		0x000200	\				ID=280`299 */

/* #define	MSGMSK_		0x000400	\				ID=300`319 */
/* #define	MSGMSK_		0x000800	\				ID=320`339 */
/* #define	MSGMSK_		0x001000	\				ID=340`359 */
/* #define	MSGMSK_		0x002000	\				ID=360`379 */
/* #define	MSGMSK_		0x004000	\				ID=380`399 */
#define	MSGMSK_TIME		0x008000 /* TIM: (RTC)		ID=400`419	*/
#define	MSGMSK_ALARM	0x010000 /* ALM: ALARM			ID=420`439	*/
#define	MSGMSK_TIMING	0x020000 /* TMG: ^C~O		ID=440`459	*/
#define	MSGMSK_PCCARD	0x040000 /* PCC: PC-Card		ID=460`479 */
#define	MSGMSK_POWER	0x080000 /* PWR: d֌W		ID=480`499 */
/* #define	MSGMSK_		0x100000	\				ID=500`519 */
/* #define	MSGMSK_		0x200000	\				ID=520`539 */
/* #define	MSGMSK_		0x400000	\				ID=540`559 */
/* #define	MSGMSK_		0x800000	\				ID=560`579 */

#define	MSGMSK_USER		0x1000000 /* USR: [U[`  ID=580  */


#define	MSGMSK_ALL			0xFFFFFFFF
#define	MSGMSK_ALL_EMSG		0x01FFFFFF	/* SCxgbZ[W */

#define	MSGMSK_ACTIVE_APL	0x00007FFF	/* ANeBuAvP[Vp */
#define	MSGMSK_ALL_APL		0x00FF8000	/* SAvP[Vp */


/***********************************************************************
				bZ[Whc
***********************************************************************/

/* PbZ[WO[ṽbZ[W */
#define	MSGIDs_PER_GROUP	20


/* ANeBuȃAvP[Vɂ̂ݔz郁bZ[WID */
#define	MSGID_FOR_ACTIVE_APL_TOP	100

/* SAvP[V֔z郁bZ[WID */
#define	MSGID_FOR_ALL_APL_TOP		400


/*----------------------------------------------------------------------
		APMANeBuȃAvP[V݂̂֔z郁bZ[W
		iMessageID = 100 ` 299j
----------------------------------------------------------------------*/

/****************************************/
/*@kbZ[Whc̒`			*/
/*	͈́F@O							*/
/****************************************/

#define	NullMessageID		0

/****************************************/
/*@CxgbZ[Whc̒`		*/
/*	͈́F@POO`XXX				*/
/****************************************/

/*  VXe֌W  */
#define	DummyEventID			100
#define	CautionLowBatID			101

#define SystemMsgIDTop			100		/*	VXe֌W̃bZ[Whc̍ŏ	*/
#define	SystemMsgIDEnd			119		/*	VXe֌W̃bZ[Whc̍Ō	*/


/*@A{[g֌W@*/
#define	FatalLowBatID			121
#define	AutoPowerOffID			122
#define	LockSwOpenID			123
#define	BatCoverOpenID			124
#define PowerOffID				125

#define	PCCardAbortID			139		/* PC-CardA{[g */

#define	AbortMsgIDTop			120		/*	A{[g֌W̃bZ[Whc̍ŏ	*/
#define	AbortMsgIDEnd			139		/*	A{[g֌W̃bZ[Whc̍Ō	*/


/*@[U[ɂ钆f֌W@*/
#define OnBreakID				140

#define	BreakMsgIDTop			140		/*	A{[g֌W̃bZ[Whc̍ŏ	*/
#define	BreakMsgIDEnd			159		/*	A{[g֌W̃bZ[Whc̍Ō	*/



/*  y֌W  */
#define	PenDownID				160
#define	PenStillDownID			161
#define	PenUpID					162
#define	PenReleasedID			163

#define	PenMsgIDTop				160		/*	y֌W̃bZ[Whc̍ŏ	*/
#define	PenMsgIDEnd				179		/*	y֌W̃bZ[Whc̍Ō	*/


/*  L[֌W  */
#define	KeyDownID				180
#define	ModifierChangedID		181
#define	KeyDrvDownID			182
#define	KeyDrvStatusID			183

#define	KeyMsgIDTop				180		/*	L[֌W̃bZ[Whc̍ŏ	*/
#define	KeyMsgIDEnd				199		/*	L[֌W̃bZ[Whc̍Ō	*/


/* 菑F֌W */
#define	HWRecogCompletedID		200

#define	HWRecogMsgIDTop			200		/*	菑F֌Ŵhc̍ŏ	*/
#define	HWRecogMsgIDEnd			219		/*					  hc̍Ō	*/


/* ^C~O֘A */
#define	FastTickID				220

#define	FastTimingMsgIDTop		220		/*	^C~O֌Ŵhc̍ŏ	*/
#define	FastTimingMsgIDEnd		239		/*						hc̍Ō	*/

/*  Communication(ʐM) Driver֌W  */
#define	BCommDataArriveID		240		/* MQueueփf[^ */
#define	BCommVacantTxQueID		241		/* MQueue󂢂Ă */
#define	BCommRIRingingID		242		/* RI(Ăї)MĂ */
#define	BCommDCDOffID			243		/* DCD(LAo)MOFFɂȂ */

/*	243`255 \ for BComm */
#define	PPPManagerEventID		256
#define	TcpipNselectEventID		257
#define	ResolverEventID			258

#define	CommMsgIDTop			240	/* ʐMdriver֌W̃bZ[Whc̍ŏ	*/
#define	CommMsgIDEnd			259	/* ʐMdriver֌W̃bZ[Whc̍Ō	*/


/* t@C֌W */
#define	FileDataArriveID		260	/* Mf[^ */

#define	FileMsgIDTop			260	/* File֌W̃bZ[Whc̍ŏ	*/
#define	FileMsgIDEnd			279	/* File֌W̃bZ[Whc̍Ō	*/


/*----------------------------------------------------------------------
		APMSẴAvP[V֔z郁bZ[W
		iMessageID = 400 ` j
----------------------------------------------------------------------*/

/*  ֌WiALARMj*/
#define	HourEventID				400
#define	MinuteEventID			401
#define	LocalHourEventID		402
#define	LocalDayEventID			403
/* bPʂ̃CxgbZ[W͂̃O[vɂ͓Ȃ */

#define	TimeMsgIDTop			400		/*	֌W̃bZ[Whc̍ŏ	*/
#define	TimeMsgIDEnd			419		/*	֌W̃bZ[Whc̍Ō	*/


/*  ALARM֌W  */
#define	AlarmEventID			420
#define	CommDevRingDetectedID	421	/* RIMo */

#define	AlarmMsgIDTop			420		/*	ALARM֌W̃bZ[Whc̍ŏ	*/
#define	AlarmMsgIDEnd			439		/*	ALARM֌W̃bZ[Whc̍Ō	*/


/* ^C~O֌W */
#define	SystemTickID			440	/* 莞ԊԊuŔ  */

#define	TimingMsgIDTop			440	/*	^C~O֌W̃bZ[Whc̍ŏ	*/
#define	TimingMsgIDEnd			459	/*	^C~O֌W̃bZ[Whc̍Ō	*/

/* PC-Card ֌W */
#define	PCCardDetectedID		460	/* PC-CardhĂ̂o */
#define	PCCardAvailableID		461	/* PC-Cardgp\ɂȂ */	
#define PCCardUselessID			462	/* PC-Card͎gpłȂ */


#define	CardSvcMsgID			479	/* Card Servicesp */

#define	PCCardMsgIDTop			460	/* PC-Card֌W̃bZ[WIDŏ */
#define	PCCardMsgIDEnd			479	/* PC-Card֌W̃bZ[WIDŌ */


/* d֌W */
#define	ACAdaptorConnectedID	480	/* ACA_v^ڑꂽ */
#define	ACAdaptorDisconnectedID	481	/* ACA_v^Oꂽ */

#define	PowerMsgIDTop			480	/* d֌WbZ[WID̍ŏ */
#define	PowerMsgIDEnd			499	/* d֌WbZ[WID̍Ō */


/* [U[Cxg */
#define	UserEventID				580		/* [U[ƎCxgbZ[W */

/* PbZ[WS */

#define	FirstMsgIDTop			100		/*	PbZ[Whc̍ŏ	*/
#define	FirstMsgIDEnd			599		/*	PbZ[Whc̍ŏ	*/


/*
   FirstMsgIDEnd = FirstMsgIDTop + (MsgMaskBits) * (MsgGroupDist) - 1;

   (MsgMaskBits) :	Message Server ̃t@NV MaskedGet/LookEventMsg()
					Ŏw\ȃbZ[W}XÑrbg
					= 25

   (MsgGroupDist):	PbZ[WO[ṽbZ[W
					= 20

   āA
   FirstMsgIDEnd = 100 + 25 * 20 - 1;
				 = 599;
*/


/*======================================================================*/


#define	MSGMSK_NET		0x000000 /* NET: lbg[N	*/

#define	CIEventID			991	/**/
#define MailReachID			993	/**/
#define NetDataReachID		994	/**/
#define	BundleTimeOutID		995	/**/
#define	PenUpTimeOutID		996	/**/



#endif	/* #ifndef	_EVENTMSG_H_INCLUDED */
