/***********************************************************************
<t@C>	exputil.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
***********************************************************************/
#ifndef EXPUTIL_H_INCLUDED
#define	EXPUTIL_H_INCLUDED
#include <sharpgen.h>
#include <timelib.h>
#include <zdam.h>
#include <fclib.h>

/* eӖ̂镶 */
#define CONV_TAG_END_MARK		'='		/* ^Oʎq̏I */
#define DELIM_APLNAME_TITLE		':'		/* Ytf[^̃Avƃ^CgƂ̋؂蕶 */

/* ֌Wt@C̒ obt@l̂ߗpӂ */
#define FNAME_MAX_LEN	32

/* JeS[zobt@̍őTCY */
#define	CONV_CTGR_BUF_MAX	256

/***********************************************************************
  ^O
***********************************************************************/

/* ^Oʕ̍ő咷 */
#define TAG_STR_MAX_LEN		40

/* ^Ohc */
typedef enum EXPTTAG {
	CNV_TAG_APLNAME	= 0,	/* Av */
	CNV_TAG_COMMENT	= 1,	/* t@C̐ */
	CNV_TAG_TITLE	= 2,	/* ^Cg */
	CNV_TAG_FILE	= 3,	/* j[Nȃt@C */
	CNV_TAG_BOOK	= 4,	/* ubN */
	CNV_TAG_POSTIT	= 5,	/* Ytf[^ */
	CNV_TAG_DATE	= 6		/* f[^̓t */
} EXPTTAG;

/* ^Of[^̃TCY */
/* typedef ULONG	DATALEN; */

/***********************************************************************
  GNX|[geLXgt@C
***********************************************************************/

/* GNX|[geLXgt@C '.'ȑOL */
/* typedef	UCHAR	*FCFNAME; */

/* GNX|[geLXg̃nh */
typedef struct CNVFP {
	ULONG	Len;			/* obt@̗LTCY */
	UCHAR	*Buf;			/* ǂݍ񂾃obt@ */
	int		Index;			/* t@C|C^ */
} CNVFP;

/***********************************************************************
  GNX|[g^Cge[u
***********************************************************************/

/* ^Cg̍ő咷 */
#define TITLE_LEN_MAX			16

/* ^CgP̍\ */
typedef struct TITLE_DATA {
	DATALEN	Len;					/* ^Cg̒ */
	UCHAR	Title[TITLE_LEN_MAX];	/* ^Cg (not '\0' terminate) */
} TITLE_DATA;

/* Pobt@̌ */
#define EXPTBL_TITLE_NUM		200

/* e[u\ */
typedef struct EXPTBL {
	int				Index;							/* ɓo^ʒu */
	TITLE_DATA		TitleData[EXPTBL_TITLE_NUM];	/* Lobt@ */
	struct EXPTBL	*NextTbl;						/* ̃obt@ւ̃|C^ */
} EXPTBL;

/***********************************************************************
  vg^Cv
***********************************************************************/

void CheckPostedTitleToOtherExport(APLID,UCHAR*,BOOLEAN(*)(void*,UCHAR*,DATALEN),void*);
CNVFP *open_conv_info_file(FCFNAME);
void close_conv_info_file(CNVFP*);
UCHAR *get_conv_info_item(CNVFP*,EXPTTAG,DATALEN*);
ULONG set_up_conv_info(UCHAR*,APLID);
ULONG append_conv_info_item(UCHAR*,ULONG,EXPTTAG,UCHAR*,DATALEN);
UCHAR *change_ext_name(UCHAR*,UCHAR*,UCHAR*);

CNVFP *OpenConvInfoFile(FCFNAME ConvFName);
void CloseConvInfoFile(CNVFP *ConvFp);
UCHAR *GetConvInfoItem(CNVFP *ConvFp,EXPTTAG Tag,DATALEN *pLen);
ULONG SetUpConvInfo(UCHAR *Buf,APLID AplName);
ULONG AppendConvInfoItem(UCHAR *Buf,ULONG BufLen,
						 EXPTTAG Tag,UCHAR *Data,DATALEN DataLen);
UCHAR *ChangeExtName(UCHAR*,UCHAR*,UCHAR*);

void SerPostedToOtherExport(FILEINFO *FInfoPtr,CBPROC *UserProc,void *Work);
BOOLEAN CreateConvInfoFile(FCFNAME ConvFName,
						   FILEINFO *FInfoPtr,CARDID CardID,
						   STRING AplNameStr,
						   ITEMNAME TitleItemName,ITEMNAME DateItemName);
BOOLEAN GetImportInfo(FCFNAME ImportFName,
					  UCHAR *TitleBuf,
					  CATEGORYID *CtgrArray,DATALEN *CtgrLen,
					  UCHAR *LinkInfoBuf,DATALEN *LinkInfoLen,
					  TIME *Date,DATALEN *DateLen);

/* ɂƂ낪Ȃ̂ */
UCHAR *CategoryBinToText(CATEGORYID *CtgrArray,DATALEN CtgrLen,
						 DATALEN *Len,UCHAR VolumeNo);
CATEGORYID *CategoryTextToBin(UCHAR *CtgrText,DATALEN *Len,UCHAR VolumeNo);
void DeleteConvInfoFile(FCFNAME FileName);

/* J֐ */
BOOLEAN check_category_id(CATEGORYID *CtgrArray,DATALEN CtgrLen);

#endif
