/***********************************************************************
<t@C>	file.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		t@CɊւ`t@C
		t@CRg[gp̂ɕKvȃwb_t@C
***********************************************************************/

#ifndef	_FILE_H_INCLUDED
#define	_FILE_H_INCLUDED

/***********************************************************************
  include
***********************************************************************/

#include	<sharpgen.h>
#include	<abort.h>

/***********************************************************************
  t@Cwb_
***********************************************************************/

#define FILE_HEADER_SIZE		4

/*
 *	t@Cwb_
 *	+---------------+
 *	|   FILE        |
 *	+-  _HEADER    -+	t@Cwb_}[Nihcj	QoCg
 *	|   _MARK(ID)   |
 *	+---------------+
 *	| FILE_ID_***** |	t@C̎ނ̂hc
 *	+---------------+
 *	| FILE_ID_*_VER |	t@CނƂ̃o[W
 *	+---------------+
 */

/* wb_\ItZbg */
 
#define OFS_FILE_HEADER_ID		0
#define OFS_FILE_ID				(OFS_FILE_HEADER_ID + 2)
#define OFS_FILE_ID_VERSION		(OFS_FILE_ID + 1)

/* t@Cwb_}[N */

#define FILE_HEADER_ID			0x00ff

/* t@C̎ނ̂hc		FILE_ID_**** */

#define FILE_ID_OAPPLI			0x0a	/* AvP[V(DBZ,DBZ3̃Av) */
#define FILE_ID_BOX				0x10	/* {bNXt@C */
#define FILE_ID_OIDX			0x11	/* cay}X^[CfNXt@C */
#define FILE_ID_OTDX			0x12	/* caye|CfNXt@C */
#define FILE_ID_BRD				0x13	/* ` */
#define FILE_ID_GKS				0x14	/* wKp */
#define FILE_ID_MSG				0x15	/* bZ[Wt@C */
#define FILE_ID_CLIP			0x16	/* Nbv{[h */
#define FILE_ID_SYSTEM			0x17	/* system file */
#define FILE_ID_CHECK			0x18	/* ic J[h̃`FbNt@C */
#define FILE_ID_TASK			0x19	/* ^XNt@C */
#define FILE_ID_APPLI			0x1a	/* VAvP[Viau|QAeyj */
#define FILE_ID_IDX				0x1b	/* V}X^[CfNXt@C */
#define FILE_ID_TDX				0x1c	/* Ve|CfNXt@C */
#define FILE_ID_ROBJ			0x1d	/* P[^uoCi[ */
#define FILE_ID_GAIJI			0x1e	/* Obft@C */
#define FILE_ID_FDX				0x1f	/* Vt@C[CfNXt@C */
#define FILE_ID_EX_APPLI		0x20	/* VCOAvP[V */
#define FILE_ID_MARKER			0x21	/* }[J[t@C */
#define FILE_ID_FLASH_TOOL		0x22	/* tbVc[ */
#define FILE_ID_PRTDRV			0x23	/* v^hCo */
#define FILE_ID_PREFERENCE		0x24	/* vt@Xt@C */
#define FILE_ID_LOADBIN			0x25	/* ėp[_uoCi[ */
#define FILE_ID_DL_ARCH			0x26	/* _E[hA[JCu */
#define	FILE_ID_PATCH_FILE		0x27	/* pb`f[^t@C */
#define	FILE_ID_ZIP_DIC			0x28	/* X֔ԍϊ */
#define	FILE_ID_ERC_FILE		0x29	/* CxgL^oCit@C */
#define	FILE_ID_LITEM_FILE		0x2a	/* [`ڐݒt@C */
#define	FILE_ID_ARRAYFILE		0x2b	/* zt@C */

#define FILE_ID_RES				FILE_ID_MSG

/* \[Xt@C̃o[W */
/* o[Wr 0xf0 Ń}XNĂsȂ */

#define RES_FVER_OLD			0x00
#define RES_FVER_CRIMSON		0x10
#define RES_FVER_PERIDOT		0x20

/* _E[hA[JCũo[W */
#define DL_ARCH_FVER_01			0x01
#define DL_ARCH_FVER_02			0x02	/* `FbNTt */


/***********************************************************************
  t@CRg[̃R}h
***********************************************************************/

#define	FC_INIT			0x40	/* t@CRg[VXȅ */
#define	FC_CREATE		0x41	/* create */
#define	FC_OPEN			0x42	/* open */
#define	FC_CLOSE		0x43	/* close */
#define	FC_BLOCK_READ	0x44	/* block read */
#define	FC_BLOCK_WRITE	0x45	/* block write */
#define	FC_BYTE_READ	0x46	/* 1byte read */
#define	FC_BYTE_WRITE	0x47	/* 1byte write */
#define	FC_VERIFY		0x48	/* block verify */
#define	FC_ND_READ		0x49	/* 1byte j read */
#define	FC_MOVE_PTR		0x4a	/* t@C|C^̈ړ */
#define	FC_INFO_READ	0x4b	/* t@C̓ǂݍ */
#define	FC_DIR_ACC		0x4c	/* fBNg̃ANZX */
#define	FC_SEARCH		0x4d	/* t@Č */
#define	FC_RENAME		0x4e	/* t@C̕ύX */
#define	FC_DELETE		0x4f	/* t@C̍폜 */
#define	FC_FREE			0x50	/* hCű󂫗eʂ̃`FbN */
#define	FC_FORMAT		0x51	/* format */
#define	FC_SWAP_HNDL	0x52	/* nhě */
#define	FC_DUP_HNDL		0x53	/* nhẽRs[ */
#define	FC_FILE_FLAG	0x54	/* [file_flag]̃ANZX */

/* patch */
#define FC_OFS_READ			0x55	/* ItZbg[h */
#define FC_OFS_WRITE		0x56	/* ItZbgCg */
#define FC_GET_ABORT_MASK	0x57	/* A{[g}XNݒǂݍ */
#define FC_SET_ABORT_MASK	0x58	/* A{[g}XNݒ菑o */

/***********************************************************************
  t@CRg[[eBeB̃R}h (SH^)
***********************************************************************/

#define	FCS_CMP_WILD_DN			0x11	/* fBNgr */
#define	FCS_CALC_NEW_F_PTR		0x13	/* t@C|C^̐VȈʒu߂ */
#define	FCS_CNV_DN_FN			0x14	/* fBNgt@Cɕϊ */
#define	FCS_CNV_FN_DN			0x15	/* t@CfBNgɕϊ */
#define	FCS_GET_SAME_DV_FCB		0x17	/* w肵FCBƓ DevNo,DrvNo FCBT */
#define	FCS_IS_WITH_WILD_DN		0x19	/* fBNgɃCh'?'܂܂Ă邩ׂ */
#define	FCS_GET_FIRST_FCB		0x1a	/* ŏFCBԂ */
#define	FCS_GET_NEXT_FCB		0x1b	/* w肵FCB̎FCBԂ */

#define FCS_F_OPEN_SUB			0x20	/* for only lib/fiozrs.c */
#define FCS_F_CLOSE_SUB			0x21


/***********************************************************************
  Wo͂ƂăI[vς݂̃nh
***********************************************************************/

#define	STD_OUT		0x00
#define	STD_IN		0x01
#define	STD_L		0x02
#define	STD_ER		0x03


/***********************************************************************
  K؂łȂnh
***********************************************************************/

#define	HANDLE_NOT_USE	0x0ff	/* t@Cnhgp̈ */


/***********************************************************************
  t@C̒̒`
***********************************************************************/

#define DRIVENAME_LEN	5	/* hCu̒ ':' ܂܂ */
#define	DFNAME_LEN	19		/* DriveName+FileName̍ő咷 (fBNg琶ꍇ) */

#define LONG_DFNAME_LEN		256		/* Ot@Cl[ő咷ihCu܂ށj */

/***********************************************************************
  ^錾
***********************************************************************/

typedef	USHORT	FTIME;			/* cnrԂ̂shldQoCg */
typedef	USHORT	FDATE;			/* cnrԂ̂c`sdQoCg */

typedef long	ERRORCODE;		/* ==0 : no error  ,  <0 : error */
typedef	long	FILEHDERROR;	/* >=0 : file handle  ,  <0 : error */

typedef	USHORT	DIRNO;			/* fBNgm */
typedef	UCHAR	FILEHD;			/* t@Cnh */

/* t@CtO */
typedef UCHAR	FILEFLAG;

#define	VERIFY_BIT		0x01	/* verify Ȃ */
#define	THROUGH_BIT		0x02	/* ܂߂Ƀobt@ */

/* foCX^Cv */
typedef	UCHAR	DEVTYPE;

#define FILECTRL_DEV	0x80	/* t@CRg[ňfoCX */
#define	IRREGL_DEV		0x40	/* WłȂfoCX */
#define	CHAR_DEV		0x20	/* LN^foCX */
#define DFLT_ASC_DEV	0x10	/* ftHgł̓AXL[̃foCX */
#define	CANT_RW_DEV		0x04	/* [hCgI[vłȂfoCX */
#define CAN_W_DEV		0x02	/* CgI[vłfoCX */
#define CAN_R_DEV		0x01	/* [hI[vłfoCX */

/* t@C */
typedef	UCHAR	FILEATR;

#define	PROTECT_FILE	0x01	/* ݋֎~ */
#define	INV_FILE		0x02	/* Bt@C */
#define	SYSTEM_FILE		0x04	/* VXet@C */
#define	WRITE_ALREADY	0x20	/* create ɎIɐݒ肳rbg */
    /* create ɂ͎w肷邱ƂłȂBdir_acc ő삷 */

#define	USUAL_FILE		0		/* ʏt@C̑ */

/* I[v[h */
typedef	UCHAR	FOPENMODE;

#define	INV_OPEN_MASK	0x80
#define	DUP_OPEN_MASK	0x40
#define RW_OPEN_MASK	0x03

#define	R_OPEN			0x01
#define	W_OPEN			0x02
#define	RW_OPEN			(R_OPEN+W_OPEN)
#define	R_OPEN_INV		(INV_OPEN_MASK+R_OPEN)
#define	W_OPEN_INV		(INV_OPEN_MASK+W_OPEN)
#define	RW_OPEN_INV		(INV_OPEN_MASK+RW_OPEN)

/* t@Cǂݍ݃[h */
typedef	UCHAR	FREADMODE;

#define	FC_FILE_END_1A		0		/* AXL[[h[h */
#define	FC_FILE_END_PH		1		/* oCi[h[h */

#define	FC_ASCII_FILE_END	0x1A	/* AXL[[hł̃t@CGh */

/* t@C|C^ړ̎n_ */
typedef	UCHAR	FMOVEMODE;

#define	FC_FROM_FILETOP		0		/* t@C擪 */
#define	FC_FROM_NOWPOS		1		/* ݂̃|Cgʒu */
#define	FC_FROM_FILEEND		2		/* t@CGh */

/* t@C擾̎ */
typedef	UCHAR	FINFOMODE;

#define	FC_INFO_FCB		0	/* Size,Pointer,DevType,OpenMode */
#define	FC_INFO_DFNAME	1	/* DriveName + FileName */
#define FC_INFO_FILE	2	/* Time,Date,FileAtr */

/* ANZX[h */
typedef	UCHAR	FACCMODE;

#define	FC_ACC_READ		0
#define	FC_ACC_WRITE	1

/*
 *	INFO READ p
 *		\͍̂̒DɏԕςĂ
 *		(傫16bytesȉ̏ꍇɌ)
 *		AZuŐVK쐬l̓xŃANZX邱
 */
typedef struct FINFOFCB {
	ULONG		Size;
	ULONG		Pointer;
	DEVTYPE		DevType;
	FOPENMODE	OpenMode;
} FINFOFCB;

typedef struct FINFOFILE {
	FTIME	Time;
	FDATE	Date;
	FILEATR	Atr;
} FINFOFILE;

typedef	union FINFOBUF {		/* info_read Ŏgpobt@ */
	FINFOFCB	iFCB;			/* small FCB */
	UCHAR		iDFName[19];	/* hCu+t@C̒ DFNAME_LEN=19 */
                    /* ^^^^ ӁI	19=DFNAME_LEN	(because of h2equ) */
	FINFOFILE	iFile;			/* time , date , atr */
} FINFOBUF;

/*
 *	DIR ACC p
 *		\͍̂̒DɏԕςĂ
 *		(傫16bytesȉ̏ꍇɌ)
 *		AZuŐVK쐬l̓xŃANZX邱
 */
typedef	struct FDIRBUF {		/* dir_acc Ŏgpobt@ */
	ULONG	Size;
	FTIME	Time;
	FDATE	Date;
	FILEATR	Atr;
} FDIRBUF;

/*
 *	SEARCH p
 */
typedef	UCHAR	FSEARCHBEHAV;	/* T[`@ */

#define	FC_SEARCH_NEXT			0		/* wfBNgmȍ~T */
#define	FC_SEARCH_PREV			1		/* wfBNgmȑOT */
#define	FC_SEARCH_INV_NEXT		0x80	/* INV_FILE܂ NEXT ̏ */
#define	FC_SEARCH_INV_PREV		0x81	/* INV_FILE܂ PREV ̏ */

typedef	struct FSEARCHMODE {
	DIRNO			DirNo;		/* IN:wDirNoAOUT:DirNo */
	FSEARCHBEHAV	Behav;		/* T[`@ */
} FSEARCHMODE;


/***********************************************************************
  VK쐬郋[`ɂ͎gpȂ
***********************************************************************/

#define FC_DIR_READ		FC_ACC_READ
#define FC_DIR_WRITE	FC_ACC_WRITE
#define FC_FFLAG_READ	FC_ACC_READ
#define FC_FFLAG_WRITE	FC_ACC_WRITE
#define INV_OPEN		INV_OPEN_MASK
#define DUP_OPEN		DUP_OPEN_MASK


/***********************************************************************
  t@CRg[
***********************************************************************/

/* void FileInit(x); */
FILEHDERROR FileCreate(UCHAR *,FILEATR);
FILEHDERROR FileOpen(UCHAR *,FOPENMODE);
ERRORCODE FileClose(FILEHD);
ERRORCODE FileBlockRead(FILEHD,FREADMODE,UCHAR *,ULONG *);
ERRORCODE FileBlockWrite(FILEHD,UCHAR *,ULONG *);
ERRORCODE FileByteRead(FILEHD,FREADMODE,UCHAR *);
ERRORCODE FileByteWrite(FILEHD,UCHAR);
ERRORCODE FileVerify(FILEHD,FREADMODE,UCHAR *,ULONG *);
ERRORCODE FileNdRead(FILEHD,FREADMODE,UCHAR *);
ERRORCODE FileMovePtr(FILEHD,FMOVEMODE,long);
ERRORCODE FileInfoRead(FILEHD,FINFOMODE,FINFOBUF *);
ERRORCODE FileDirAcc(UCHAR *,FACCMODE,FDIRBUF *);
ERRORCODE FileSearch(UCHAR *,FSEARCHMODE *,UCHAR *);
ERRORCODE FileRename(UCHAR *,UCHAR *);
ERRORCODE FileDelete(UCHAR *);
long FileFree(UCHAR *);
ERRORCODE FileFormat(UCHAR *);
ERRORCODE FileSwapHndl(FILEHD,FILEHD);
FILEHDERROR FileDupHndl(FILEHD);
FILEFLAG FileFileFlag(FACCMODE,FILEFLAG);
ERRORCODE FileGetAbortMask(FILEHD,ABORTMASK*);
ERRORCODE FileSetAbortMask(FILEHD,ABORTMASK);

#endif
