#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _FUPROCDEF_
#define _FUPROCDEF_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/***** sokcet manager proc *****/
#define SOCK_MANG_EVENT0            "Esm0"      /* socket manager event */
#define SOCK_MANG_EVENT1            "Esm1"      /* (0..9 = MAX_SOCKET_NUM) */
#define SOCK_MANG_EVENT2            "Esm2"
#define SOCK_MANG_EVENT3            "Esm3"
#define SOCK_MANG_EVENT4            "Esm4"
#define SOCK_MANG_EVENT5            "Esm5"
#define SOCK_MANG_EVENT6            "Esm6"
#define SOCK_MANG_EVENT7            "Esm7"
#define SOCK_MANG_EVENT8            "Esm8"
#define SOCK_MANG_EVENT9            "Esm9"
#define MAX_SOCKET_NUM              10          /* max socket */
#define SOCKMANG_EVENT_WAITVALUE    0           /* event_wait() */
#define SOCKMANG_EVENT_WAITMASK     0xffff
#define SOCKMANG_EVENT_SETVALUE     1           /* event_set() */
#define SOCKMANG_EVENT_SETMASK      0xffff

/***** ppp manager proc *****/
#define PPP_MANG_PROC               "Ppmg"
#define PPP_MANG_CODE               "Cpmg"
#define PPP_MANG_PRIORITY           1
#define PPP_MANG_STACK              0x2000
#define PPP_MANG_EVENT              "Epmg"
#define PPPMANG_EVENT_WAITVALUE     0           /* event_wait() */
#define PPPMANG_EVENT_WAITMASK      0xffff
#define PPPMANG_EVENT_SETVALUE      1           /* event_set() */
#define PPPMANG_EVENT_SETMASK       0xffff

/* ApplicationƂ̋L */
#define	PPP_COMMON_MEMORY	"Mpmg"		/* PPP-Appl Common Memory */
#define	PPP_COMMON_MEMORY_SIZE	1500		/* PPP-Appl Com-Mem Size */
#define	PPP_MEMORY_WINDOW	"Wpmg"		/* PPP Manager Memory Window */
#define	APP_MEMORY_WINDOW	"WSMP"		/* Application Memory Window */

/* bZ[WL[AWCCxg */
#define	PPPMANG_JOINE_SETVALUE	1		/* event_set() */
#define	PPPMANG_JOINE_SETMASK	0xffff		/* ׂ݂͂ēCxg */
#define APP_PPP_QUEUE     	"Qpmg"          /* Appl-PPPm message Queue */
#define APP_PPP_QUEUE_LEN	2		/* AP Queue Length */
#define APP_PPP_QUEUE_MAX	16		/* AP Queue Max Size */

/***** tcpip timer proc *****/
#define TCP_TIMER_PROC              "Pttm"
#define TCP_TIMER_CODE              "Cttm"
#define TCP_TIMER_PRIORITY          1
#define TCP_TIMER_STACK             0x1000

/***** ppp recv proc *****/
#define PPP_RECV_PROC               "Pprv"
#define PPP_RECV_CODE               "Cprv"
#define PPP_RECV_PRIORITY           1
#define PPP_RECV_STACK              0x1000
#define PPP_RECV_EVENT              "Eprv"
#define PPPRECV_EVENT_WAITVALUE     0           /* event_wait() */
#define PPPRECV_EVENT_WAITMASK      0xffff
#define PPPRECV_EVENT_SETVALUE      1           /* event_set() */
#define PPPRECV_EVENT_SETMASK       0xffff

/***** ppp sio recv proc *****/
#define PPP_SIORECV_PROC            "Ppsr"
#define PPP_SIORECV_CODE            "Cpsr"
#define PPP_SIORECV_PRIORITY        1
#define PPP_SIORECV_STACK           0x1000
#define PPP_SIORECV_EVENT           "Epsr"
#define PPP_SIORECV_INTREV          "Fpsr"
#define PPPSIORECV_EVENT_WAITVALUE  0           /* event_wait() */
#define PPPSIORECV_EVENT_WAITMASK   0xffff

/***** resolver proc *****/
#define RESOLVER_PROC               "Prsl"
#define RESOLVER_CODE               "Crsl"
#define RESOLVER_PRIORITY           1
#define RESOLVER_STACK              0x1000
/* Message Queue */
#define APP_RSL_QUEUE		    "Qrsl"	/* applresolver M.Queue */
#define APP_RSL_QUEUE_LEN	    2
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _FUPROCDEF_ */
