/***********************************************************************
<t@C>	heaplib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		q[v}l[W`
***********************************************************************/

#ifndef _HEAP_LIB_H_INCLUDED
#define	_HEAP_LIB_H_INCLUDED

#include <sharpgen.h>

/* ֐錾(J) */
BOOLEAN InitHeap(UINT MaxHeapNum);
HANDLE NewHeapHandle(int Size);
void DisposeHeapHandle(HANDLE Handle);
PTR NewHeapPtr(int Size);
void DisposeHeapPtr(PTR Pointer);
void LockHandle(HANDLE Handle);
void UnLockHandle(HANDLE Handle);
HANDLE PtrToHandle(PTR Pointer);
void PackHeapArea(void);
BOOLEAN SetHeapSize(HANDLE Handle,int NewSize);
int GetHeapSize(HANDLE Handle);
BOOLEAN IsHeapHandle(HANDLE Handle);
BOOLEAN IsHeapPtr(PTR Ptr);
HANDLE AddAlienHeap(void);
void DisposeAlienHeap(HANDLE Handle);
int GetUsedHeapNum(void);
HANDLE NewHeapHandleS(int Size);
PTR NewHeapPtrS(int Size);
int GetMaxAvailHeapSize(void);

/* t@NVԍ */
#define	INIT_HEAP			0x41
#define	NEW_HEAP_HANDLE		0x42
#define	DISPOSE_HEAP_HANDLE	0x43
#define	NEW_HEAP_PTR		0x44
#define	DISPOSE_HEAP_PTR	0x45
#define	LOCK_HANDLE			0x46
#define	UN_LOCK_HANDLE		0x47
#define	PTR_TO_HANDLE		0x48
#define	PACK_HEAP_AREA		0x49
#define	SET_HEAP_SIZE		0x4a
#define	GET_HEAP_SIZE		0x4b
#define	IS_HEAP_HANDLE		0x4c
#define	IS_HEAP_PTR			0x4d
#define	ADD_ALIEN_HEAP		0x4e
#define	DISPOSE_ALIEN_HEAP	0x4f
#define	GET_USED_HEAP_NUM	0x50
#define	NEW_HEAP_HANDLE_S	0x51
#define	NEW_HEAP_PTR_S		0x52

#define	HEAP_LAST_FUNC		NEW_HEAP_PTR_S

#endif
