/***********************************************************************
<t@C>	iconmenu.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
		ACRj[c[
*****************************************************************/

#ifndef _ICON_MENU_DEFINED
#define	_ICON_MENU_DEFINED

#include <sharpgen.h>
#include <zdrawlib.h>

#ifndef H2EQU
#include	<message.h>
#endif H2EQU

/*----------------------------------------------------------------
  \ `
----------------------------------------------------------------*/
/*	ACRj[\	*/
typedef	struct	ICONMENUWORK {
	WINDOWHD	WindowHandle;	/*	j[Window Handle			*/
	USHORT		FrameSizeX;		/*	t[TCY X - 1			*/
	USHORT		FrameSizeY;		/*	t[TCY Y - 1			*/
	UCHAR		*MenuList;		/*	j[Xg					*/
	UCHAR		*MenuAtr;		/*	j[Agr[g			*/
	UCHAR		ModeType;		/*	j[^Cv					*/
	CDSPMODE	LCDMode;		/*	\[h						*/
	USHORT		Pages;			/*	j[̖ iP`)			*/
	USHORT		DisplayPage;	/*	\Ăy[WԍiP`j	*/
	HANDLE		ButtonHandle;	/*	{^Handle				*/
	HANDLE		CloseHandle;	/*	Close{^Handle			*/
	HANDLE		PageHandle;		/*	Page{^Handle			*/
	POINT		WinPos;			/*	EBhW					*/
	USHORT		SelectButtonID;
	BOOLEAN		InWindow;
	int			SelectedPage;
	CBPROC		MenuFilterProc;
	void		*Work;
} ICONMENUWORK, *ICONMENUPTR, **ICONMENUHDL;

/*	Cj[ Xg \	*/
typedef	struct	IMMainListInfo {
	USHORT		MenuID;			/*	j[ID						*/
	UCHAR		MenuInfo;		/*	j[ڂ̏				*/
	UCHAR		*ResName;		/*	ACR\[X				*/
	USHORT		ResID;			/*	\[XID						*/
} IMMListInfo, *IMMListPtr, **IMMListHdl;

/*	Tuj[ Xg \		*/
typedef struct	IMSubListInfo {
	USHORT		MenuID;			/*	j[ID						*/
	UCHAR		MenuInfo;		/*	j[ڂ̏				*/
	UCHAR		MenuStrLength;	/*	j[ڂ̕			*/
	UCHAR		*MenuStr;		/*	j[ڂ̕			*/
} IMSListInfo, *IMSListPtr, **IMSListHdl;

/*	j[Xg p	*/
typedef union	IMListInfo {
	IMMListInfo	MM;				/*	Cj[ Xg \	*/
	IMSListInfo	SM;				/*	Tuj[ Xg \		*/
} IMListInfo, *IMListPtr, **IMListHdl;

/*	{^ \	*/
typedef struct	IMBtnInfo {		/*	{^ \	*/
	UCHAR		*ResName;		/*	ACR{^̃\[Xt@C	*/
	USHORT		ResID;			/*	ACR{^̃\[XID			*/
	USHORT		MenuID;			/*	j[ID							*/
	USHORT		PosX;			/*	ACRj[̃{^\ʒu	*/
	USHORT		Mode;			/*	{^̓샂[h					*/
} IMBtnInfo;

/*----------------------------------------------------------------
  萔 `
----------------------------------------------------------------*/
/*	ACRj[̂Py[W̍ő僁j[	*/
#define	IMBUTTON_INFO_MAX		20		/*	{^obt@̐	*/

/* ModeType ̃rbg` */
#define	IMCHANGE_PAGE_BTN		0x02	/*	ؑւ{^ /Ȃ	*/
#define	IMCHANGE_BTN_LEFT		0x01	/*	ؑւ{^ 		*/
#define	IMCHANGE_BTN_RIGHT		0x00	/*	ؑւ{^ E		*/

#define IM_SELECT_KEEP			0x10	/*	{^̑IԂێ	*/
#define	IM_NO_AUTO_CLOSE		0x20	/*  N[YȂ		*/
#define IM_NO_RESET_POS			0x80	/*	N[YWL	*/

/*	MenuInfõrbg`	*/
#define	IMSUB_MENU				0x40	/*	Tuj[			*/
#define	IMPAGE_END				0x01	/*	j[̃y[WI	*/

/*	ACRj[\[X̊eڂ̃TCY	*/
#define	IMMENUID_LENGTH			2		/*	j[ID				*/
#define	IMMENU_INFO_LENGTH		1		/*	ACe			*/
#define	IMRESFILE_LENGTH		9		/*	\[Xt@C		*/
#define	IMRESID_LENGTH			2		/*	\[XID				*/
#define	IMSTRLEN_LENGTH			1		/*	Tuj[̕	*/

/*	{^ID	*/
#define	IMCLOSE_BTN_ID			0xffff	/*	N[Y{^ID		*/
#define	IM_PREV_PAGE_ID			0xfffe	/*	y[Wؑւ{^ID	*/
#define	IM_NEXT_PAGE_ID			0xfffd	/*	y[Wؑւ{^ID	*/

/*	{^TCY	*/
#define	IMDRAG_WIDTH			(QP(8) -1)	/*	j[̃hbÖ	*/

/*----------------------------------------------------------------
  bZ[WID `
----------------------------------------------------------------*/
/*
	IMChangeMenuAtrID bZ[W̎gp@
	Ay[Wؑւ̎ɑQƂ̂
	ToolInitIDɃj[̑ύXꍇA
	lύXAEBhẼI[vԂɂ炸A
	IMChangeMenuAtrIDIconMenuObj()ɓnKv܂B
*/
/* j[lύX bZ[W	*/
#define	IMChangeMenuAtrID		MenuChangeMenuAtrID


/*	ESR-Pmenu.hŒ`Ă߁A
	SHŒ`ꎟA폜邱	*/
#define		MENU_SELECT_DISABLE	0x80	/* Is	*/
#define		MENU_SELECT_ENABLE	0x00	/* I	*/
#define		MENU_NORMAL_DISP	0x00	/* ʏ핶	*/
#define		MENU_LIGHT_DISP		0x20	/* 	*/


/*----------------------------------------------------------------
  vg^Cv 錾
----------------------------------------------------------------*/
extern	void	icon_menu_obj(MESSAGE *, ICONMENUWORK *);

void IconMenuObj(MESSAGE *Message,ICONMENUWORK *IconMenuWork);

#endif
/*	end of iconmenu.h	*/
