/***********************************************************************
<t@C>	jpeglib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/*
	iodfCu
		C^[tF[X
*/

#if !defined(__jpeglib_h)

#define __jpeglib_h

#define	BMP_WIDTH		320		/* ʉhbg */
#define	BMP_HEIGHT		240		/* ʏchbg */
#define	DSC_WIDTH		512		/* DSC̉hbg */
#define	DSC_HEIGHT		384		/* DSC̏chbg */

#define	JPEG_WIDTH_MAX	2000	/* JPEG摜̍ő啝 */
#define	JPEG_HEIGHT_MAX	2000	/* JPEG摜̍ő卂 */

#define	JPEG_PROC_LINE	16		/* xɏ郉C 16̔{ł邱 */

/* C^[tF[XE[N */
typedef	struct	tag_JPEGWK	{
	void			*BitMap;			/* ʃobt@ */

	void			*fp;				/* o̓Xg[̃|C^ 
										   Encode(o) Decode() */
	void			*fileBuf;
	long			fileBufSize;

	/* JPEGt@C摜̃TCY */
	unsigned short	vwidth;			/*  */
	unsigned short	vheight;		/*  */

	/* JPEGt@C摜̕\Ώۋ`̈ */
	unsigned short	vx;			/* XW */
	unsigned short	vy;			/* YW */
	unsigned short	vw;			/*  */
	unsigned short	vh;			/*  */

	/* Bitmapobt@̑Ώۋ`̈ */
	unsigned short	bx;			/* XW */
	unsigned short	by;			/* YW */
	unsigned short	bw;			/*  */
	unsigned short	bh;			/*  */

	/* fAXyNg */
	unsigned short	Xdensity;		/* X */
	unsigned short	Ydensity;		/* Y */

	unsigned short	cyp;			/* fR[h̊JnC */
	unsigned short	writeline;		/* vram̉CV
									   񂾂\ */

	unsigned char	direction;		/* XN[̕ 1,2,3,4 (EAAA) */
	unsigned short	vlen;			/* 摜ł̃XN[(hbgP) */

	int				ErrInfo;		/* G[ */
} JPEGWK;

/* vg^Cv錾 */
int getJPEGWKSize(void);
int encode_dsc_init(JPEGWK* inf, unsigned char quality, unsigned char smplr);
int encode_dsc(JPEGWK* inf);
int encode_vramdsc_init(JPEGWK* inf, unsigned short xl, unsigned short yl, unsigned short wl, unsigned short hl, unsigned char quality, unsigned char smplr);
int encode_vram_init(JPEGWK* inf, unsigned short xl, unsigned short yl, unsigned short wl, unsigned short hl, void *infFp);
int encode_vram(JPEGWK* inf);
int decode_init(JPEGWK* inf);
int decode(JPEGWK* inf);
int scroll_length(JPEGWK* inf);
int decode_scrl(JPEGWK* inf);
void JPEG_abort(JPEGWK* inf);


/* ߂l */
#define	JPEG_ERR	-1
	/* G[i炩̌ŃGR[h/fR[hSɏIĂȂj*/
#define	JPEG_OK		0
	/* I(GR[h/fR[hSɏI) */
#define	JPEG_AT		1
	/* I(Ŝ̃GR[h/fR[h͂܂IĂȂ) */

/* G[ */
typedef	enum	tag_JPEGERRINFO	{
	JPEG_ERR_None= 0,		/* G[Ȃ */
	JPEG_ERR_IO,			/* o̓G[ */
	JPEG_ERR_Data,			/* JPEGf[^̃G[ */
	JPEG_ERR_NotStretch,	/* L̓T|[gĂȂ */
	JPEG_ERR_Quality,		/* ʎqxs */
	JPEG_ERR_SmplRate,		/* TvO䂪s */
	JPEG_ERR_SizeOver,		/* JPEG摜̃TCY傫 */
	JPEG_ERR_NotScrl,		/* wꂽɂ̓XN[łȂ */
	JPEG_ERR_NotSupport		/* T|[gĂȂJPEG/JFIFt@C */
} JPEGERRINFO;

#endif	/* #if !defined(__jpeglib_h) */
