/***********************************************************************
 <t@C>	lcdzdm.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-500iwithout MI-10j
***********************************************************************/
#ifndef	_LCDZDM_H_DEFINED

#include <zdrawlib.h>
#include <pinklib.h>

/***********************************************************************
  ̃TCY
***********************************************************************/
typedef	UCHAR	FONTSIZE;

/***********************************************************************
  ̎
***********************************************************************/
typedef	ULONG	FONTTYPE;

#define	FT_FJNM	'FJNM'		/* Zaurs FixedtHg */

/***********************************************************************
  C
***********************************************************************/
typedef	USHORT	FONTSTYLE;

#define	FS_NORMAL		(0x00)		/* ʏX^C */
#define	FS_BOLD			(0x01)		/* {[h */
#define	FS_ITALIC		(0x02)		/* C^bN */
#define	FS_UNDERLINE		(0x04)		/* t */
#define	FS_SHADOW		(0x08)		/* e(gps) */


/***********************************************************************
  ]px
***********************************************************************/
typedef	USHORT	FONTANGLE;

#define	FA_NO_ROTATION	(0x0000)	/* ]Ȃ*/
#define	FA_180_ROTATION	(0x0001)	/* 180x] */
#define	FA_R90_ROTATION	(0x0002)	/* E90x] */
#define	FA_L90_ROTATION	(0x0003)	/* 90x] */

/***********************************************************************
  `JnW
***********************************************************************/
typedef	USHORT	STARTPOINT;

#define	STP_LEFT_LOWER	(0x00)	/*  */
#define	STP_LEFT_UPPER	(0x01)	/*  */
#define	STP_RIGHT_LOWER	(0x02)	/* E */
#define	STP_RIGHT_UPPER	(0x03)	/* E */

/***********************************************************************
  A`
***********************************************************************/
typedef	USHORT	DISPANGLE;

#define	DSPA_NORMAL	(0x00)	/* E */
#define	DSPA_REVERSE	(0x01)	/* E */
#define	DSPA_TOP_DOWN	(0x02)	/* と */
#define	DSPA_BOTTOM_UP	(0x03)	/*  */

/***********************************************************************
  Cp^[f[^
***********************************************************************/
typedef	long	LINEPTD;

/***********************************************************************
  J[\^Cv
***********************************************************************/
typedef USHORT CRSTYPE;

#define	WN_CRS_OFF		(0x00)	/* J[\OFF  */
#define	WN_CRS_ON		(0x01)	/* J[\ON  */
#define	WN_CRS_BLINK		(0x08)	/* uNw */

#define	WN_CRS_ONOFF_MASK	(0x07)	/* J[\^Cv}XNp */
#define	WN_CRS_SIZE_MASK	(0xf0)	/* J[\TCY}XNp */

/***********************************************************************
  Agr[gt\̕f[^
***********************************************************************/
typedef USHORT	STR_CHAR;

/***********************************************************************
  Agr[gt\̕\
***********************************************************************/
typedef USHORT STR_ATR;

/* \Ɋւ镶̎ */
#define	STRA_MINCHO	(0x0000)

#define STRA_TYPE_MASK	(0xe000)

#define STRA_COLOR_MASK	(0x1f00)

/* \Ɋւ镶̃TCY */
#define	STRA_40QP	(0x0000)		/* POhbg */
#define	STRA_48QP	(0x0020)		/* PQhbg */
#define	STRA_64QP	(0x0040)		/* PUhbg */
#define	STRA_96QP	(0x0060)		/* QShbg */

#define STRA_SIZE_MASK	(0x00e0)

/* \Ɋւ镶C */
#define	STRA_PLANE	(0x0000)		/* CȂ */
#define	STRA_BOLD	(0x0001)		/* {[hw */
#define	STRA_ITALIC	(0x0002)		/* C^bNw */
#define	STRA_UNDERLINE	(0x0004)		/* A_[Cw */

#define	STRA_STYLE_MASK	(0x001f)

#define	STRA_DEFAULT	(STRA_MINCHO|STRA_BLACK|STRA_48QP|STRA_PLANE)

/***********************************************************************
  Agr[gt\̕\@Ɋւrbg
***********************************************************************/
typedef	UCHAR STR_INFO;

#define	WORD_WRAP_ON	(0x01)		/* [hbv@\ ON */
#define	SYMBOL_09_ON	(0x02)		/* TAB(0x09)V{\@\ ON */
#define	SYMBOL_0C_ON	(0x04)		/* (0x0c)V{\@\ ON */
#define	SYMBOL_0D_ON	(0x08)		/* s(0x0d)V{\@\ ON */
#define	CLEAR_OFF	(0x10)		/* \\̈NA OFF */

/***********************************************************************
  Agr[gt\TABʒu\
***********************************************************************/
#define	MAX_TABS	(8)

typedef struct STR_TAB_TBL{
    USHORT	nTabs;			/* s`aʒuݒ萔i0`MAX_TABSj*/
    USHORT	TabPos[8];		/* s`aʒu (QP) */
} STR_TAB_TBL;

typedef struct FONTINFO{
	FONTSIZE	FontSize;	/* TCY */
	FONTTYPE	FontType;	/* tHg^Cv(OS) */
	FONTSTYLE	FontStyle;	/* C */
	FONTANGLE	FontAngle;	/* ]px */
} FONTINFO;

typedef struct DISP1CHR{
	short		Pitch;		/* Ԋu (QP) */
	USHORT		SJISCode;	/* shift JIS code */
	STARTPOINT	StartPoint;	/* Jn_ */
	DISPANGLE	DispAngle;	/* A` */
	FONTINFO	FontForm;	/* tHg` */
} DISP1CHR;

typedef struct DISPNCHR{
	short		Pitch;		/* Ԋu (QP) */
	USHORT		Len;		/* f[^oCg(mtkk͊܂܂) */
	UCHAR		*Str;		/* f[^擪AhX */
	STARTPOINT	StartPoint;	/* Jn_ */
	DISPANGLE	DispAngle;	/* A` */
	FONTINFO	FontForm;	/* tHg` */
} DISPNCHR;

/***********************************************************************
  Agr[gt̕\p\
***********************************************************************/

typedef struct DISPSTEXT{
	short		Pitch;		/* Ԋu (QP) */
	USHORT		Len;		/* \ */
	STR_CHAR	*Str;		/* \ */
	STR_ATR		*AttrPtr;	/* \ */
	STR_TAB_TBL	*TabTblPtr;	/* TAB ʒu */
	USHORT		Indent;		/* Cfgʒu */
	USHORT		SelSAdr;	/* ZNgJnItZbg */
	USHORT		SelEAdr;	/* ZNgIItZbg */
	COLOR		SelRevC;	/* ZNg]F */
	STR_INFO	Info;		/* \@Ɋւ */
	USHORT		Height;		/* ő\ (QP) */
	USHORT		Width;		/* \ (QP) */
} DISPSTEXT;

typedef struct DISPPOINT{
	DOTSIZE		DotSize;	/* _̑傫(QP) */
	DOTSHAPE	DotShape;	/* _` */
} DISPPOINT;

typedef struct READPOINT{
	USHORT		ReadC16;	/* 16rbgJ[i[ */
} READPOINT;

typedef struct DRAWLINE{
	DOTSIZE		DotSize;	/* _̑傫(QP) */
	DOTSHAPE	DotShape;	/* _` */
	LINEPAT		LinePt;		/* ` */
	LINEPTD		LinePtd;	/* Cp^[f[^ */
/*	LINEMODE	LineMode;	/* C[h */
} DRAWLINE;

typedef struct BOXLINE{
	DOTSIZE		DotSize;	/* _̑傫(QP) */
	DOTSHAPE	DotShape;	/* _` */
	LINEPAT		LinePt;		/* ` */
	LINEPTD		LinePtd;	/* Cp^[f[^ */
/*	LINEMODE	LineMode;	/* C[h */
} BOXLINE;

typedef struct BOXPAINT{
	PAINTPAT	PaintPt;	/* yCgp^[ */
	UPOINT		PaintOfs;	/* yCgp^[JnWItZbg */
} BOXPAINT;


typedef struct DISPICN{
	ICONDATA	*IcnData;
	ICONMODE	IcnMode;
} DISPICN;

typedef struct DISPIMG{
	IMAGEDATA	*ImgData;
} DISPIMG;

typedef struct DISPZPMIMG{
	USHORT		*ZPMImgData;
} DISPZPMIMG;

typedef UCHAR DPBUFTYPE;
#define	DP_NEW_HEAP		(0x00)
#define	DP_NEW_OFFSCRN		(0x01)
#define	DP_PTR			(0x02)
#define	DP_EXIST_OFFSCRN	(0x03)

typedef struct DPEXISTOFS{
	WINDOWHD OSHandle;
	RECTANGLE OSRect;
} DPEXISTOFS;

typedef struct DPPTR{
	IMAGEDATA *ImgData;
	USHORT ImgSize;
} DPPTR;

typedef	union DPBUFINFO{
	DPPTR Ptr;
	DPEXISTOFS ExistOS;
} DPBUFINFO;

typedef UCHAR DPDATATYPE;

typedef struct DISPPUSHPOP{
	DPBUFTYPE BufType;
	DPBUFINFO BufInfo;
	DPDATATYPE DataType;		/* IMAGE_16BIT ̂݃T|[g */
} DISPPUSHPOP;

typedef UCHAR CLEARINFO;
#define	CI_CLEAR	1

typedef struct BOXMOVE{
	short MoveX;
	short MoveY;
	CLEARINFO ClrInfo;
} BOXMOVE;

typedef struct SCROLL{
	USHORT Distance;
	CLEARINFO ClrInfo;
} SCROLL;

typedef struct DISPVPTN{
	USHORT	VPtn;
} DISPVPTN;

typedef struct DISPNVPTN{
	USHORT	*NVPtnPtr;
	USHORT	Len;
} DISPNVPTN;

typedef struct CHRFONT{
	USHORT		SJISCode;	/* IN  : shift JIS code */
	FONTINFO	*FontFormPtr;	/* IN  : tHg`擪AhX */
	USHORT		*CgPtr;		/* OUT : bff[^擪(ROM)AhX */
	UCHAR		HLoops;		/* OUT : c[vl */
	UCHAR		HDot;		/* OUT : chbg */
	USHORT		WLoops;		/* OUT : [vl */
	USHORT		LastWLoopsMask;	/* OUT : ŉ[v}XN */
} CHRFONT;

typedef struct GETFONT{
	USHORT		SJISCode;	/* IN  : shift JIS code */
	FONTINFO	*FontFormPtr;	/* IN  : tHg`擪AhX */
	USHORT		*CgBufPtr;	/* IN  : bff[^i[擪AhX */
	UCHAR		Height;		/* OUT : (dot) */
	UCHAR		Width;		/* OUT : (dot) */
	USHORT		*CgPtr;		/* OUT : bff[^擪(ROM)AhX */
} GETFONT;

typedef struct CURSOR{
	WINDOWHD	WnHandle;
	POINT		Start;		/* WŒ */
	CRSTYPE		CrsType;
	COLOR		Fg;
	COLOR		Bg;
} CURSOR;

typedef struct GETCOLOR{
	GUICOLOR	GCNo;
	COLOR		*RealCPtr;
	GCTABLE		GCTblNo;
} GETCOLOR;

typedef	union DISP_PARAM{
	DISP1CHR	Dsp1C;
	DISPNCHR	DspNC;
	DISPSTEXT	DspST;
	DISPPOINT	DspP;
	DRAWLINE	DrwL;
	DRAWLINE	DrwCL;
	BOXLINE		BoxL;
	BOXPAINT	BoxP;
	DISPICN		DspIcn;
	DISPIMG		DspImg;
	DISPZPMIMG	DspZPMImg;
	DISPPUSHPOP	DspPP;
	BOXMOVE		BoxMv;
	SCROLL		Scroll;
	DISPVPTN	DspVPtn;
	DISPNVPTN	DspNVPtn;
	READPOINT	ReadP;
} DISP_PARAM;

typedef struct ZDRAW{
	UCHAR		FuncNo;		/* t@NVNo. (gp) */
	WINDOWHD	WnHandle;	/* EBhEnh */
	CDSPMODE	Mode;		/* \[h */
 	POINT   	Start; 		/* EBhEJn_W */
	POINT		End;		/* EBhEI_W */
	RECTANGLE	Mask;		/* t[}XN̈ */
	COLOR		Fg;		/* tHAOEhJ[ */
	COLOR		Bg;		/* obNOEhJ[ */
	DISP_PARAM	DspParam;
} ZDRAW;

/***********************************************************************
  ZaurusDraw}l[Wt@NVio`
***********************************************************************/
#define	TOP_FUNC			(0x40)

#define	LCD_INIT_ZDM			(0x40)	/*  */
#define	DISP_1_CHAR_ZDM			(0x41)	/* P\ */
#define	DISP_N_CHAR_ZDM			(0x42)	/* m\ */
#define	DISP_POINT_ZDM			(0x43)	/* P_\ */
#define	DRAW_LINE_ZDM			(0x44)	/* ` */
#define	DRAW_CONT_LINE_ZDM		(0x45)	/* A`p̐` */
#define	BOX_LINE_ZDM			(0x46)	/* `` */
#define	CLS_LCD_ZDM			(0x47)	/* SʃNA */
#define	AREA_CLEAR_ZDM			(0x48)	/* w͈͂̃NA */
#define	AREA_DARK_ZDM			(0x49)	/* w͈͂̉eNA */
#define	BOX_PAINT_ZDM			(0x4a)	/* `̈̃yCg */
#define	DISP_STYLED_TEXT_ZDM		(0x4b)	/* Agr[gt m\ */
#define	DISP_ICON_ZDM			(0x4c)	/* ACR\ */
#define	DISP_IMAGE_ZDM			(0x4d)	/* C[W\ */
#define	DISP_ZPMIMAGE_ZDM		(0x4e)	/* ZPMC[W\ */
#define	DISP_PUSH_ZDM			(0x4f)	/* `̈̑ޔ */
#define	DISP_POP_ZDM			(0x50)	/* `̈̕A */
#define	BOX_MOVE_ZDM			(0x51)	/* `̈ړ */
#define	SCROLL_UP_ZDM			(0x52)	/* XN[ */
#define	SCROLL_DOWN_ZDM			(0x53)	/* XN[ */
#define	DISP_V_PATTERN_ZDM		(0x54)	/* c16hbgp^[\ */
#define	DISP_N_V_PATTERN_ZDM		(0x55)	/* c16hbgp^[\ */
#define	READ_POINT_ZDM			(0x56)

#define	CURSOR_BLINK_ZDM		(0x60)
#define	CURSOR_MOVE_ZDM			(0x61)
#define	CURSOR_DISP_ZDM			(0x62)
#define	GET_CURSOR_INFO_ZDM		(0x63)
#define	DISP_PINK_ZDM			(0x64)
#define	DISP_1BUNDLE_ZDM		(0x65)
#define	GET_REAL_COLOR_ZDM		(0x66)
#define	GET_GUI_NO_ZDM			(0x67)
#define	GET_SCREEN_SIZE_ZDM		(0x68)
#define	CHR_FONT_ZDM			(0x69)
#define	GET_FONT_ZDM			(0x6a)
#define	LCD_DIAG_ZDM			(0x6b)
#define	SET_LIGHT_ZDM			(0x6c)
#define	GET_LIGHT_ZDM			(0x6d)
#define	ENABLE_ACCESS_VRAM_ZDM	(0x70)
#define	DISABLE_ACCESS_VRAM_ZDM	(0x71)
#define	GET_VRAM_TOP_ZDM		(0x72)
#define	SET_LCD_MODE_ZDM		(0x73)
#define	GET_LCD_MODE_ZDM		(0x74)
#define	GET_GRAY_COLOR_ZDM		(0x75)
#define	SET_LCD_CONTRAST_ZDM	(0x76)
#define	GET_LCD_CONTRAST_ZDM	(0x77)

#define	LAST_FUNC		GET_LCD_CONTRAST_ZDM

void Disp1CharDM(ZDRAW *pZdraw);
void DispNCharDM(ZDRAW *pZdraw);
void DispPointDM(ZDRAW *pZdraw);
void DrawLineDM(ZDRAW *pZdraw);
void DrawContLineDM(ZDRAW *pZdraw);
void DrawContLineDM(ZDRAW *pZdraw);
void BoxLineDM(ZDRAW *pZdraw);
void LcdClsDM(ZDRAW *pZdraw);
void AreaClearDM(ZDRAW *pZdraw);
void AreaDarkDM(ZDRAW *pZdraw);
void BoxPaintDM(ZDRAW *pZdraw);
void DispStyledTextDM(ZDRAW *pZdraw);
void DispIconDM(ZDRAW *pZdraw);
void DispImageDM(ZDRAW *pZdraw);
void DispZPMImageDM(ZDRAW *pZdraw);
void DispPushDM(ZDRAW *pZdraw);
void DispPopDM(ZDRAW *pZdraw);
void BoxMoveDM(ZDRAW *pZdraw);
void ScrollUpDM(ZDRAW *pZdraw);
void ScrollDownDM(ZDRAW *pZdraw);
void DispVPatternDM(ZDRAW *pZdraw);
void DispNVPatternDM(ZDRAW *pZdraw);
void ReadPointDM(ZDRAW *pZdraw);

void CursorBlinkDM(WINDOWHD WndH);
void CursorMoveDM(CURSOR *pCursor);
void CursorDispDM(CURSOR *pCursor);
void GetCursorInfoDM(CURSOR *pCursor);
void DispPinkDM(PINK_PM	*pPinkPm,int DataBytes);
void Disp1BundleDM(PINK_PM *pPinkPm);
void GetRealColorDM(ZDRAW *pZdraw);
BOOLEAN GetGuiNoDM(GETCOLOR *pGetC);
void GetScreenSizeDM(UPOINT *pScreenSize);
void ChrFontDM(CHRFONT *pCFont);
void GetFontDM(GETFONT *pGFont);
void LcdDiagDM(UCHAR ChkNo);
void SetLightDM(UCHAR Mode,UCHAR Light);
UCHAR GetLightDM(void);


void SetLcdContrastDM(char);
char GetLcdContrastDM(void);

typedef UCHAR LCDMODE;

#define	LMD_GRAY1		(0x00)
#define	LMD_GRAY4		(0x01)
#define	LMD_COLOR16		(0x02)

typedef UCHAR RDSPMODE;

#define	RMD_NODISP		(0x00)
#define	RMD_KEEP		(0x01)
#define	RMD_CLEAR		(0x02)
#define	RMD_ALLREDISP	(0x03)

#define	GRAY1_MASK		(0x01)
#define	GRAY4_MASK		(0x0f)

BOOLEAN SetLcdMode(LCDMODE lmode,RDSPMODE rmode);
LCDMODE GetLcdMode(void);
void GetGrayColor(UCHAR gray,COLOR *color);

/***********************************************************************
  kbcRgXgl̒`
***********************************************************************/
#define	LCD_CONTRAST_MIN		(0x00)
#define LCD_CONTRAST_MAX		(0x3f)
#define	LCD_CONTRAST_DEFAULT	(0x0f)

/***********************************************************************
  Zaurus Draw Manager ( Disp Tool ) t@NVio`
***********************************************************************/
#define	CHAR_SIZE_ZDM				(0x40)
#define	GET_WIDTH_ZDM				(0x41)
#define	GET_LENGTH_FROM_WIDTH_ZDM	(0x42)
#define	GET_STRING_SIZE_ZDM			(0x43)

/* ZDRAW(DISPTOOL) Cu֐vg^Cv錾 */
void CharSizeDM( FONTINFO *, UCHAR, USHORT *, USHORT * );
USHORT GetWidthDM( DISPNCHR * );
void GetLengthFromWidthDM( DISPNCHR *, USHORT, USHORT *, USHORT * );
UCHAR GetStringSizeDM( DISPSTEXT *, POINT *, POINT * );


#define	_LCDZDM_H_DEFINED
#endif


