/***********************************************************************
<t@C>	list.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_LIST_H_INCLUDED
#define	_LIST_H_INCLUDED
#include	<sharpgen.h>
#include	<zdrawlib.h>

/****************************************/
/*	ꗗ\XgN`錾		*/
/****************************************/

#ifndef	_LISTWORK_DEFINED
typedef	struct	ListWork	{
	UCHAR		ListWindowNo ;		/*@EBhEmD@*/
	UCHAR		ListType ;		/*@ꗗ\̃^Cv@PI6 moved*/
	short		ListPosX ;		/*@t[Ww@*/
	short		ListPosY ;		/*@t[Wx@*/
	USHORT		ListSizeX ;		/*@Pڂ̃TCYw[P@*/
	USHORT		ListSizeY ;		/*@Pڂ̃TCYx[P@*/
	USHORT		ListReverseOffsetX;	/*@ڔ]̈̃ItZbg (PI-6)*/
	UCHAR		*ListAttrTop ;		/*@Agr[g擪ւ̃|C^@*/
	USHORT		ListAllDataNo ;		/*@Sf[^@*/
	USHORT		ListDispDataNo ;	 /*@\\f[^@Y */
	USHORT		ListDispDataColumn ; /*@\\f[^@X (PI-6)*/
								/*	ӁI ۂɂ UCHAR ݂ĂȂ */
	USHORT		ListDispOffset ;	/*@\Jnf[^@*/
	USHORT		ListSpaceDataNo ;	/*@f[^@*/
	USHORT		ListActiveItem ;	/*y[U[ݒsvz݃ANeBȍڔԍ@*/
	USHORT		ListSelectDButton ;	/*y[U[ݒsvz{^IuWFNgp[N@*/
	UCHAR		ListStatus ;		/*y[U[ݒsvzꗗ\̏ԃ[N@*/
	USHORT		ListSelectStart;	/*y[U[ݒsvzZNgJnڔԍ@*/
	USHORT		ListSelectEnd;		/*y[U[ݒsvzZNgIڔԍ@*/
	CBPROC		ListCallBackFunc;	/*@R[obN[`̃AhX@PI-6*/
	UCHAR		*ListCallBackWork;	/*@R[obNp[NAhX@*/
	COLOR		ListLineColor;
	COLOR		ListBGColor;
	COLOR		ListReverseColor;
	USHORT 		ListDPCount;
	USHORT		ListPressCtr;
} LISTWORK,*LISTWORKPTR,**LISTWORKHD;
#define	_LISTWORK_DEFINED
#endif


	/*@ꗗ\̃^Cv[ListType]@*/
/*@(bit7-2) O@*/
/*@(bit1)hbO̐ݒ@*/
#define	LIST_DRAG_ENABLE	0x00	/*@hbO@*/
#define	LIST_DRAG_DISENABLE	0x02	/*@hbO֎~@*/
/*@(bit0)ꗗ\[h̐ݒ@*/
#define	LIST_MENU		0x00	/*@j[[hw@*/
#define	LIST_ACTIVE_LINE	0x01	/*@ANeBC[hw@*/

#define	NO_LIST_FRAME		0x04	/* OgȂ */
#define	NO_LIST_LINE		0x08	/* rȂ */
#define	LIST_NON_CLEAR		0x10	/* Xg̈NAȂ */
#define	NO_HARD_SCROLL		0x20	/* n[hXN[Ȃ */



	/*@ꗗ\̏ԃ[N[ListStatus]@*/
/*@(bit7-2) O@*/
/*@(bit1)Ԃ̐ݒP@*/
#define	LIST_ON_TRACE		0x00	/*@g[X@*/
#define	LIST_ON_DRAG		0x02	/*@hbO@*/
/*@(bit0)Ԃ̐ݒQ@*/
#define	LIST_TRACE_ALL		0x00	/*@ꗗ\Ŝg[X@*/
#define	LIST_CLICK_ACTIVE	0x01	/*@ANeBCNbN@*/
#endif
