/***********************************************************************
***********************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _MAILH_
#define _MAILH_

#include "pimmgr.h"
#include "mail_res.h"
#include <imgcmprs.h>
/* #include "mail_str.h" */
/* #include "adrs_res.h" */
#include <modemlib.h>
#include <modemlib.h>
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/*
 * TCPSET
 */
#define	TCPSET_IPSW	0		/* 14 IPAhXݒXCb` */
#define	TCPSET_PWSW	1		/* 5  pX[hXCb` */
#define	TCPSET_PROC	2		/* 11 ڑ菇XCb` */
#define	TCPSET_ZASW	3		/* 21 UEX̔F؃vgR */
#define	TCPSET_SASW	4		/* 22 T[o̔F؃vgR */
#define	TCPSET_ZPCM	5		/* 23 UEX̃vgRk */
#define	TCPSET_SPCM	6		/* 24 T[õvgRk */
#define	TCPSET_ZACF	7		/* 25 UEX̃AhXk */
#define	TCPSET_SACF	8		/* 26 T[õAhXk */
#define	TCPSET_ZTCM	9		/* 29 UEXTCP/IPk */
#define	TCPSET_STCM	10		/* 30 T[oTCP/IPk */
#define	TCPSET_END	11		/* End */

/*
 * for fax dial
 */
#define FAX_DIAL_0	0
#define FAX_DIAL_1	1
#define FAX_DIAL_2	2
#define FAX_DIAL_3	3
#define FAX_DIAL_4	4
#define FAX_DIAL_5	5
#define FAX_DIAL_6	6
#define FAX_DIAL_7	7
#define FAX_DIAL_8	8
#define FAX_DIAL_9	9
#define FAX_DIAL_ASTA	10
#define FAX_DIAL_SHARP	11

/*
 * for alert
 */
#define	ALERT_YESNO_TITLE	1
#define	ALERT_YESNO			2
#define	ALERT_ERROR			3
#define	ALERT_CONFIRM		4
#define	ALERT_KAKUNIN		5

#define	ALERT_YES			1
#define	ALERT_NO			0
#define	ALERT_NOP			-1

/*
 * for reply
 */
#define	REP_NONE	0
#define	REP_ALL		1
#define	REP_SENDER	2

/*
 * TO/CC/BCC
 */
#define	MAIL_TO_FLAG	0x00
#define	MAIL_CC_FLAG	0x01
#define	MAIL_BCC_FLAG	0x02

/*
 *	BOX FILE
 */
/* #define RECV	0x00
#define	SEND	0x01 */
#define	INET	0x02
#define	SEND_ITEM_NUM	(9+1)
#define	RECV_ITEM_NUM	(12+1)
#define	INET_ITEM_NUM	(20+1)

/*
 *	Read/Write BOX FILE
 */
#define	WRITE	(UCHAR)1 
#define	READ	(UCHAR)0

/*
 *	mail body edit flag
 */
#define	BODY_NEW	0x00
#define	BODY_COL	0x01
#define	BODY_REPL	0x02
#define	BODY_TRAN	0x03
#define	BODY_SOUF	0x04
#define	BODY_TITL	0x05
#define	BODY_IMDM	0x06
#define	BODY_ASIG	0x07
/*
 * mail body edit option flag
 */
#define	BODY_BUF_ALL	0x00
#define	BODY_BUF_SELECT	0x01
#define BODY_BUF_WHICH	0x01
#define	BODY_TO_FROM	0x02
#define	BODY_TO_ALL		0x04
#define	BODY_TO_WHICH	0x06

/*
 *	mode Internet/Nifty/Remote
 */
#define	INTERNET	0x01
#define	NIFTY		0x02
#define	REMOTE		0x03
#define	FAX			0x04

/*
 *	mode modem inner/outer/card
 */
#define	INNER		0x01
#define	OUTER		0x02
#define	SCARD		0x03

/*
 *	dial
 */
#define	DIAL_TONE	1
#define	DIAL_PULS_10	2
#define	DIAL_PULS_20	3
#define	DIAL_NONE	4

/*
 *	speaker
 */
#define	SPEAKER_ON	1
#define	SPEAKER_OFF	2

/* 
 *	ʎʎq 
 */
#define	FLAG_ASIG	0x0001			/* [͒ǉ */ 
#define	FLAG_IMDM	0x0002			/* fߐݒ */
#define	FLAG_PROC	0x0004			/* ڑ菇ݒ */
#define	FLAG_SET1	0x0008			/* ڑݒ1 */
#define	FLAG_SET2	0x0010			/* ڑݒ2 */
#define	FLAG_SET3	0x0020			/* ڑݒ3 */
#define	FLAG_SET4	0x0040			/* ڑݒ4 */
#define	FLAG_SET5	0x0080			/* ڑݒ5 */
#define	FLAG_CPRV	0x0100			

/*
 *	Xgʎʎq
 */
#define	INBOX	1
#define	OUTBOX	2
#define	SENDN	3

#define	LIST_DATA_MAX	256		/* Xgɕ\łő吔 */
#define	MAX_MODEM_ENTRY	50

/* InBox ǂ̃[\邩̎ʎq */
#define	RDCK_ALL	0x01			/* S */
#define	RDCK_NOREAD	0x02			/*  */
#define	RDCK_READED	0x03			/* mFρiǂł܂zj */

/* ̓Xgő吔 */
#define ATESAKI_LIST_MAX    (99)

/* IMp */
typedef struct {
	int		ID ;
    char	From[16] ;
    char	Date[32] ;
    char	Title[20] ;
    int		Size ;
    BOOLEAN		IsRecv ;
} MAILLIST ;

/* ݒp */
typedef struct {
	USHORT	speaker ;				/* Xs[J[				*/
	USHORT	dial ;					/* _C					*/
	USHORT	u_modem ;				/* gpf				*/
	UCHAR	sendtome ;				/* ɂM			*/
	UCHAR	autosig ;				/* ͒ǉ				*/
	UCHAR	proof ;					/* zBؖtM			*/
	UCHAR	mime ;					/* MIMEɕϊ				*/
	UCHAR	skip ;					/* [̓XLbv		*/
	UCHAR	skip_val ;				/* [̓XLbv		*/
	UCHAR	autorecv ;				/* auto recv 				*/
	UCHAR	del ;					/* [M폜		*/
	UCHAR	pict ;					/* 摜 			( fax )	*/
	UCHAR	keisyou ;				/* h				( fax ) */
	UCHAR	header ;				/* wb_[̖O	( fax ) */
	USHORT	transpeed ;				/* ]Xs[h		( fax ) */
} CONWK ;

/* ڑݒp */
typedef struct {
	UCHAR	tmp_conid[SIZE_OF_CONID] ;		/* 4  RlNVid		   */
	UCHAR	tmp_passwd[SIZE_OF_PSWD] ;		/* 6  pX[h			   */
	UCHAR	tmp_popa[SIZE_OF_CONID] ;		/* 7  POPAJEg			   */
	UCHAR	tmp_popp[SIZE_OF_PSWD] ;		/* 8  POPpX[h			   */
	UCHAR	tmp_sad[SIZE_OF_MADR] ;			/* 9  T[oAhX		   */
	UCHAR	tmp_madr[SIZE_OF_MADR] ;		/* 10 [AhX		   */
	UCHAR	tmp_procbuf[SIZE_OF_SCRPT] ;	/* 12 ڑ菇pobt@	   */
	UCHAR	tmp_ipaddr[SIZE_OF_IP] ;		/* 13 IPAhX			   */
	UCHAR	tmp_mask[SIZE_OF_IP] ;			/* 16 Tulbg}XN		   */
	UCHAR	tmp_dns1a[SIZE_OF_IP] ;			/* 17 DNS1IPAhX		   */
	UCHAR	tmp_dns2a[SIZE_OF_IP] ;			/* 18 DNS2IPAhX		   */
	UCHAR	tmp_zpsize[SIZE_OF_PSIZE] ;		/* 19 UEX̃pPbgTCY */
	UCHAR	tmp_spsize[SIZE_OF_PSIZE] ;		/* 20 T[õpPbgTCY   */
	UCHAR	tmp_zcmap[SIZE_OF_ZSCMAP] ;		/* 27 UEX̃LN^map  */
	UCHAR	tmp_scmap[SIZE_OF_ZSCMAP] ;		/* 28 T[õLN^}bv */
	UCHAR	tmp_tcpset[SIZE_OF_TCPSET] ;	/*    eݒlQ			   */
} DSTWK ;

/* [^FAXʂ̃Gg[tO */
#define SHINKI      0x01
#define SYUSEI      0x02
#define HYOJI       0x03
/* 悪AhX̒ɂ邩ǂ̃tO */
/* J[hIDFFFFƂ̂͂炭ȂƎv̂ */
#define NO_CARDID   0xffff

/* AvP[Vؑւp}N */
#define ForbidAplSW(aplform)                \
((aplform)->FormType |= MODAL_GET_MESSAGE,  \
 (aplform)->FormEventMask = FORBID_APLSW)
#define AllowAplSW(aplform)                 \
((aplform)->FormType &= ~MODAL_GET_MESSAGE)

/*
 *	[Et[eBO[N`
 */
typedef struct  cardfloat {
	UCHAR	mode_ios ;
	UCHAR	mode_finr ;	
	UCHAR	prev_mode_finr ;
	/* Card 											*/
	UCHAR	CrntVolNo ;			/* ݒڂĂ{[io */
	/* passwd											*/
	UCHAR	ps_sw ;				/* passwd select sw 	*/
	/* data 	   										*/
	UCHAR	edit_type ;			/* new/cor/rep/tran & titl/mdmi/sig */
	UCHAR	tcpset[SIZE_OF_TCPSET] ;		/*    eݒlQ		*/
	UCHAR	recv_select ;		/* IM[h		*/
	USHORT	doing_flag ;		/* tO			*/
	/*												*/
	USHORT	CurScrn ;
	USHORT	PrevScrn ;
	/*	J[hID										*/
	CARDID	cid ;				/* MBOX 				*/
	CARDID	rid ;				/* MBOX			 	*/
	CARDID	pid ;				/* C^[lbgBOX 	*/
	CARDID	nid ;				/* jteBBOX	 		*/
	CARDID	reid ;				/* [gBOX			*/
	CARDID	adr_cid ;			/* fax / address 		*/
	UCHAR	chk;			
	/* t@C 									*/
	UCHAR	IsInfoTDXAvail ;	/* i荞݃t@C邩H */
	CATEGORYID	InfoCtgrID ;	/* t@C̍i荞ݑΏ */
	DTMFNAME	InfoTDXFName ;	/* t@C̍i荞݃t@C */
}	CARDFLOAT,*CARDFLOATPTR,**CARDFLOATHANDLE;



/*
 *	e탏[Nւ̃|C^ANZX` 
 */
/* Cxg֐łPIMExecWorkANZXp|C^[` */
#define	AplFormPIMExecWorkPtr	((PIMEXECWORK *)(AplForm->AppliWorkPtr))
/* Cxg֐łPIMInfoANZXp|C^[` */
#define	AplFormPIMInfoPtr		((PIMINFO *)(AplFormPIMExecWorkPtr->PIMInfo))
/* Cxg֐łCardWorkANZXp|C^[` */
#define	ExeWk		(*((CARDWK **)(((PIMEXECWORK *)(AplForm->AppliWorkPtr))->PIMUserWork)))
/* Cxg֐łCardFloatANZXp|C^[` */
#define	OutWk		(*((CARDFLOAT **)(((PIMEXECWORK *)(AplForm->AppliWorkPtr))->PIMInfo->PIMAplWork)))
/* PIMR[obN֐łCardWorkANZXp|C^[` */
#define	PIMExecCardWkPtr		(*((CARDWK **)(PIMExecWork->PIMUserWork)))
/* PIMR[obN֐łCardFloatANZXp|C^[` */
#define	PIMExecCardFloatPtr		(*((CARDFLOAT **)(PIMExecWork->PIMInfo->PIMAplWork)))
/* PIMInfołCardFloatANZXp|C^[` */
#define	PIMInfoCardFloatPtr		(*((CARDFLOAT **)(PIMInfo->PIMAplWork)))
/* ZDAMt@C|C^擾}N */
#define	GetFInfoPIMInfo(piminfo,i)	((*(piminfo)->PIMFInfo)[i].FInfo)

#define	MAX( a, b)				( ( (a) > (b) ) ? (a) : (b) )
#define	MIN( a, b)				( ( (a) < (b) ) ? (a) : (b) )
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _MAILH_ */
