/***********************************************************************
<t@C>	meisilib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		hǂ݂Ƃ@IOCSCCu
***********************************************************************/

#ifndef _MEISILIB_H_INCLUDED
#define _MEISILIB_H_INCLUDED

#include <sharpgen.h>
#include <dtmlib.h>
#include <comdvlib.h>
#include <bcommlib.h>
#include <abort.h>

typedef enum MEISHIERR_E {
	MRE_SUCCESS 				= 0,	/* I */
	MRE_STATE_SCANNING 			= 1,	/* LookStateMRE() ǎ撆 */
	MRE_STATE_DATA_EXIST		= 2,	/* LookStateMRE() ǎ抮 */
	MRE_STATE_REQUIRE_ANOTHER 	= 3,	/* LookStateMRE() VǎKv */
	MRE_STATE_RECOG 			= 4,	/* LookStateMRE() F */

	EC_MRE_NOT_CONNECTED		= -10,	/* "hǎ@ڑĂ" */

	EC_MRE_LOST_STX				= -20,	/* "Mf[^ُł" */
	EC_MRE_LOST_ETX				= -21,
	EC_MRE_BAD_ANSWER			= -22,
	EC_MRE_BAD_CHECKSUM			= -23,
	EC_MRE_BAD_ITEM_NO			= -24,
	EC_MRE_BAD_CMD_PACKET		= -25,
	EC_MRE_UNEXPECTED_REPLY		= -26,
	EC_MRE_MEISHI_DATA_TOO_LARGE= -27,

	EC_MRE_CMD_BAD_SUM			= -30,	/* ǎ@R}hFłȂ */
	EC_MRE_CMD_UNDEF			= -31,	/* ǎ@R}hFłȂ */
	EC_MRE_READER_SCAN_ERROR	= -32,	/* "ǂݎ蒆Ɉُ킪" */
	EC_MRE_READER_NO_MEISHI		= -33,	/* "hĉ" */
	EC_MRE_READER_QUIT_COMM		= -34,	/* "ǎ@ŃG[܂" */
	EC_MRE_READER_ERROR			= -35,	/* "ǎ@ŃG[܂" */
	EC_MRE_ERROR				= -36,	/* "ǎ@ŃG[܂" */

	EC_MRE_BOXOPEN_FAILED		= -100,	/* "VXeG[" */
	EC_MRE_BOXCLOSE_FAILED 		= -101,
	EC_MRE_CARDCREATE_FAILED	= -102,
	EC_MRE_CARDWRITE_FAILED		= -103,
	EC_MRE_CARDCOPY_FAILED		= -104,
	EC_MRE_INVALID_WORK_PTR		= -105,
	EC_MRE_CLOSEBCOMM_FAILED	= -106,
	EC_MRE_UNLOCKCOMMDEV_FAIILED= -107,

	EC_MRE_FILESYSTEM_FULL		= -104,	/* "tł" */

	EC_MRE_BREAK				= -254,	/* ufvL[ɂ钆f */
	EC_MRE_ABORTED				= -255	/* A{[gɂ钆f */

} MEISHIERR_E;


typedef struct MEISHIREADER {
	ULONG		Magic;
	COMMDEVNAME	DevName;
	DTMFNAME	BoxFName;
	COMMDEV		*pDev;
	BCOM		*pBCom;
	BOXHANDLE	ppBox;
} MEISHIREADER;

#define	MAGIC_MEISHIREADER	'MRed'

/*----------------------------------------------------------------------
				VXeR[֐vg^Cv錾
----------------------------------------------------------------------*/

MEISHIREADER *OpenMRE( COMMDEVNAME DevName, DTMFNAME *pBoxFName );
MEISHIERR_E CloseMRE( MEISHIREADER *pMre );
MEISHIERR_E ComfirmConnectionMRE( MEISHIREADER *pMre );
MEISHIERR_E LookStateMRE( MEISHIREADER *pMre );
MEISHIERR_E StartScanningMRE( MEISHIREADER *pMre );
MEISHIERR_E ReadMeishiMRE( MEISHIREADER *pMre );
MEISHIERR_E	InterruptMRE( MEISHIREADER *pMre );
ABORTMASK SetAbortMaskMRE( MEISHIREADER *pMre, ABORTMASK Mask );
ABORTMASK LookAbortMaskMRE( MEISHIREADER *pMre );


/*----------------------------------------------------------------------
				Cu֐vg^Cv錾
----------------------------------------------------------------------*/

/* lib/readmeis.c */
MEISHIERR_E ReadMeishiFromReader( DTMFNAME *pBoxFName,
								  WINDOWHD WinNo, const POINT *pDispPos );



#endif /* #ifndef _MEISILIB_H_INCLUDED */
