/***********************************************************************
<t@C>	padmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_PADMSG_H_INCLUDED
#define	_PADMSG_H_INCLUDED
/*  ̓pbhbZ[W  */
#include <sharpgen.h>

/*  bZ[W  */
struct	BOARD_CHANGE
{
	USHORT	MessageID;	/*  BoardChangeID  */
	USHORT	OccuredTime;	/*    */
	USHORT	BoardNo;	/*  {[hm  */
};

struct	PAD_MODE_CHANGE
{
	USHORT	MessageID;	/*  PadModeChangeID  */
	USHORT	OccuredTime;	/*    */
	USHORT	PadMode;	/*  [h  */
};

struct	HENKAN_MODE_SET
{
	USHORT	MessageID;	/*  HenkanModeSetID  */
	USHORT	OccuredTime;	/*    */
	USHORT	HenkanModeNo;	/*  ϊ[hm  */
};

struct	NINSHIKI_MODE_SET
{
	USHORT	MessageID;	/*  NinshikiModeSetID  */
	USHORT	OccuredTime;	/*    */
	USHORT	NinshikiModeNo;	/*  F[hm  */
};

struct	PUSH_KEY
{
	USHORT	MessageID;	/*  PushKeyID  */
	USHORT	OccuredTime;	/*    */
	USHORT	TargetID;	/*  \{^hc  */
};

struct	SET_PAD_BUF
{
	USHORT	MessageID;	/*  SetPadBufID  */
	USHORT	OccuredTime;	/*    */
};

struct	CLEAR_PAD_BUF
{
	USHORT	MessageID;	/*  ClearPadBufID  */
	USHORT	OccuredTime;	/*    */
};

struct	CHANGE_TIME_PAD_MODE
{
	USHORT	MessageID;	/*  ChangeTimePadModeID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	BarMode;	/*@o[̎Ԑ@*/
};

struct	GET_PAD_DATA
{
	USHORT	MessageID;	/*  GetPadDataID  */
	USHORT	OccuredTime;	/*    */
};

struct	PAD_KUSEJI_NOT_USE
{
	UINT	MessageID;	/*  PadKusejiNotUseID  */
	UINT	OccuredTime;	/*    */
};

struct	SELECT_NINSHIKI_DIC
{
	UINT	MessageID;	/*  SelectNinshikiDicID  */
	UINT	OccuredTime;	/*    */
	UCHAR	Dic;		/* FΏە */
};

/*@bZ[W@*/
struct	RESULT_EXIST
{
	USHORT	MessageID;	/*  ResultExistID  */
	USHORT	OccuredTime;	/*    */
	USHORT	ButtonID;	/*  f[^R[hȊO̓̓R[h  */
};

struct	RESULT_NON
{
	USHORT	MessageID;	/*  ResultNonID  */
	USHORT	OccuredTime;	/*    */
};

struct	PAD_ALREADY_CLEAR
{
	USHORT	MessageID;	/*  PadAlreadyClearID  */
	USHORT	OccuredTime;	/*    */
};

struct	PAD_AREA_PAINT
{
	USHORT	MessageID;	/*  PadAreaPaint  */
	USHORT	OccuredTime;	/*    */
};


/****************************************/
/*@̓pbhbZ[Whc̒`	*/
/*	͈́F@RWOO`RWXX	*/
/*	͈́F@RXOO`RXXX	*/
/****************************************/

	/*@bZ[W@*/
#define	KanaConvertID			3800
#define	KakuConvertID			3801
#define	ItaijiConveretID		3802
#define	ZipConvertID			3803
#define	BoardChangeID			3804
#define	HenkanModeSetID			3805
#define	NinshikiModeSetID		3806
#define	PushKeyID			3807
#define	SetPadBufID			3808
#define	ClearPadBufID			3809
#define	ChangeTimePadModeID		3810
#define	GetPadDataID			3811
#define	PadModeChangeID			3812
#define	PadKusejiNotUseID		3813
#define	SelectNinshikiDicID		3814
#define	PadAreaPaintID			3815

	/*@bZ[W@*/
#define	ResultExistID			3900
#define	ResultNonID			3901
#define	ConvertOKID			3902
#define	ConvertStartID			3903
#define	PadAlreadyClearID		3904
#endif
