/***********************************************************************
<t@C>	printer.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_PRONTER_H_INCLUDED
#define	_PRONTER_H_INCLUDED
/*
 * ou|eP^ca|yv^hCoΉwb_t@C
 */

#define		SWP(x)	   ( ( ((x) << 8) | ( ((x) >> 8) & 0xff ) ) & 0xffff )

#define 	UCHAR		unsigned char
#define 	USHORT		unsigned short
#define 	ULONG		unsigned long

/* {[[g */

#define 	BPS300		0x10	/* 00010000 */
#define 	BPS600		0x20	/* 00100000 */
#define		BPS1200		0x30	/* 00110000 */
#define		BPS2400		0x40	/* 01000000 */
#define		BPS4800		0x50	/* 01010000 */
#define		BPS9600		0x60	/* 01100000 */
#define		BPS19200	0x70	/* 01110000 */
#define 	GET_BPS		0x70	/* 01110000 */

/* peB */

#define		P_EVEN		0x00	/* 00000000 */
#define		P_ODD		0x04	/* 00000100 */
#define		P_NONE		0x08	/* 00001000 */
#define 	GET_PARITY	0x0c	/* 00001100 */

/* rbg */

#define		BIT_LEN8	0x00	/* 00000000 */
#define		BIT_LEN7	0x02	/* 00000010 */
#define 	GET_BITLEN	0x02	/* 00000010 */

/* Xgbvrbg */

#define		STOP_BIT1	0x00	/* 00000000 */
#define		STOP_BIT2	0x01	/* 00000001 */
#define 	GET_STOPBIT	0x01	/* 00000001 */

/* wnm/nee */

#define		XON_OFF		0x60	/* 00000110 00000000 */
#define 	X_NONE		0x00	/* 00000000 00000000 */
#define 	GET_X		0x60	/* 00000110 00000000 */

#define 	YES		  1
#define		NO		  0

#define 	ESC		0x1b

/*
 * v^@R[h
 */
#define 	PTYPE_CE	  0	/* bd|oqP(V[v) PC-PR like*/
#define 	PTYPE_ES	  1	/* ai|POex@(Lm) ESC/P */
#define 	PTYPE_PC	  2	/* ob|oqPTOm(mdb) PC-PR*/
#define 	PTYPE_CE3	  3	/* bd|oqR(V[v) ESC/P like*/
#define 	PTYPE_MAX	  3	/* @R[hl̏ */

/*
 * ڑ@
 */
#define		PRT_IR		  0	/* h/q|[g */
#define		PRT_DIRECT	  1	/* _CNgP[u */
#define		PRT_SIO		  2	/* rhn */
#define 	PRT_CH_MAX	  2	/* ڑ@R[hl̏ */

/*
 * rhnM (j^nmw)
 */
#define		SIO_MON_RS	0x20
#define		SIO_MON_CS	0x10
#define		SIO_MON_DR	0x08
#define		SIO_MON_CD	0x04

/*
 * ㉺Ë󎚕s\R[h
 */
#define 	TOP_DEAD	(UCHAR)0
#define 	BOTTOM_DEAD	(UCHAR)1
#define 	LEFT_DEAD	(UCHAR)2
#define 	RIGHT_DEAD	(UCHAR)3

/*
 * CR/LF
 */
#define		CR_LF_1		(UCHAR)0	/* CRCR,	LFLF */
#define 	CR_LF_2 	(UCHAR)1	/* CRCR+LF,	LFLF */
#define 	CR_LF_3		(UCHAR)2	/* CRCR,	LFCR+LF */
#define 	CR_LF_4		(UCHAR)3	/* CRCR+LF,	LFCR+LF */
#define 	CR_LF_MAX	(UCHAR)3	/* CR/LFR[h̏ */

/*
 * 󎚗p̎
 */
#define 	PAPER_1   	(UCHAR)0	/* ʏp(CE-PR1 Only) */
#define 	PAPER_2   	(UCHAR)1	/* Rs[p(CE-PR1 Only) */

/*
 * 
 */
#define 	PLANE		0x00	/* 薳		*/
#define 	UNDERLINE	0x80	/* A_[Ct	*/
#define 	DOUBLE_X	0x08	/* {p		*/
#define 	DOUBLE_Y	0x04	/* c{p		*/
#define 	BOLD		0x40	/* 			*/
#define 	TATE		0x01	/* c		*/

/*
 * 샂[h
 */
#define		PRT_MODE_1	(UCHAR)1
#define		PRT_MODE_2	(UCHAR)2
#define		PRT_MODE_3	(UCHAR)3
#define		PRT_MODE_4	(UCHAR)4

/*
 * 𑜓x
 */
#define		DPI_NORMAL	(UCHAR)0
#define 	DPI_SMALL	(UCHAR)1

/*
 * 샂[h
 */
#define		CHAR_MODE	  1
#define		IMAGE_MODE	  2

/*
 * R[h
 */
#define		CODE_BYTE	 0	/* PoCgR[h	*/
#define		CODE_WORD	 1	/* QoCgR[h	*/
#define		CODE_HALF	 0	/* pR[h		*/
#define		CODE_WHOLE	 1	/* SpR[h		*/
#define		CODE_NORMAL	 0	/* R[h		*/
#define		CODE_DAKUON	 1	/* R[h		*/

#define		SPACE_HALF	(USHORT)(0x0020)	/* pXy[X	*/
#define		SPACE_WHOLE	(USHORT)(0x2121)	/* SpXy[X	*/

/************************************************
 *		hqpnodmtO		*
 ************************************************/
#define		IR_OPEN_OK 	  0
#define 	IR_OPEN_NO 	  1

/************************************************
 *		    l      \		*
 ************************************************/
#define 	OK		  0	/* Ɏsꂽ */
#define 	EPRT_MODEL	101	/* v^@R[hĂ */
#define 	EPRT_CHANNEL	102	/* ڑ@̎w肪Ă */
#define 	EPRT_PCB	103	/* v^Rg[ubNُ̈ */
#define 	EPRT_PAPER	104	/* pTCYR[hĂ */
#define 	EPRT_UNMATCH	105	/* ݒ肪s ******************
					 * pTCY,
					 * }[W, y[Ws, 󎚃X^C
					 *************************************/
#define 	EPRT_TOP_MARGIN	106	/* }[Wl傫A܂͏ */
#define 	EPRT_LEFT_MARGIN 107	/* }[Wl傫A܂͏ */
#define 	EPRT_CRLF	108	/* bq^keR[hĂ */
#define 	EPRT_TABS	109	/* ^uݒf[^ɂȂĂȂ */
#define 	EPRT_STYLE	110	/* 󎚃X^CR[hĂ */
#define 	EPRT_X_OVER	111	/* hbg傫 */
#define 	EPRT_PAGE_OVER	112	/* Jgy[WɈ󎚃f[^[܂Ȃ */
#define 	EPRT_OTHER	113	/* v^@ݒ肪uOtherIEIIv */
#define 	EPRT_WMEM	114	/* ƗpmۂłȂ */
#define 	EPRT_COM	121	/* ʐMG[Œf */
#define 	EPRT_OPEN	122	/* o̓foCXI[vłȂ */
#define 	EPRT_VOLUME	123 	/* 󎚔ZxR[hĂ */

#define 	EPRT_ABORT	0xff	/* uONvL[Œf */
#define 	EPRT_EVENT	0xfe	/* O܈bENEdrQ`̉˟ۆf */
#define 	EPRT_TIME_OUT	0xfd	/* v^ڑĂȂ */

/************************************************
 *	    n [ h R s [  W		*
 ************************************************/
#define		MAX_X		336	/* ʕFʉ320hbg{V{GA
					 * 16hbg͂W̔{ł邱
					 *************************************/
#define		START_Y		100	/* A[g{bNX゙W */
#define		END_Y		141	/* A[g{bNXW+1 (P) */
					/* QsbZ[W̃A[g{bNX́A
					 * START_Y:92, END_Y:148
					 *************************************/
					/* ޔGÃoCg */
#define HIDE_SIZE	( MAX_X * ( END_Y - START_Y ) / 8 )

/************************************************
 *		  }  N  			*
 ************************************************/
#define		lpi( style )	( style == NORMAL_P ? 16 : 16 )
#define		cpi( style )	( style == NORMAL_P ? 10 : 12 )

/************************************************
 *		f  [  ^  \  		*
 ************************************************/
/****** ݒf[^ubN ******/
typedef struct {
	USHORT		SizeX;		/* pTCY */
	USHORT		SizeY;		/* pcTCY */
	USHORT		TopMargin;	/* }[W(POÔPC`P) */
	USHORT		LeftMargin;	/* }[W(POÔPC`P) */
	USHORT		BottomMargin;	/* }[W(POÔPC`P) */
	USHORT		RightMargin;	/* E}[W(POÔPC`P) */
	UCHAR		PageLen;	/* y[W̍s */
	UCHAR		Column;		/* y[W̌ */
	UCHAR		CRLF;		/* bq^ke@ */
	UCHAR		Tabs[8];	/* ^uݒ */
	char		Volume;		/* 󎚔Zx */
	UCHAR		PaperType;	/* p */
	UCHAR		Pitch;		/* ssb` */
	UCHAR		Decoration;	/* (rbgwAw\) */
	UCHAR		MaxPageLen;	/* y[W̍ős */
	UCHAR		MaxColumn;	/* s̍ő包 */
} PRTForms;

/****** C[Wf[^ ******/
typedef struct {
	UCHAR		*p;		/* C[Wf[^̃|C^ */
	USHORT		x;		/* hbg */
	USHORT		y;		/* chbg */
	UCHAR		density;	/* 𑜓x ****************************
					 * 0:W, 1:k
					 *************************************/
	short		margin;		/* }[W(POÔPC`P) */
} PRTImage;

/****** rhnʐM[h ******/
typedef	unsigned short	SIOMode;

/****** v^Rg[ubN ******/
typedef struct {
	UCHAR		mode;		/* ==0: not start
					 * ==1: Character mode
					 * ==2: Image mode
					 */

	UCHAR		prt_type;	/* ڑv^̋@ */
	UCHAR		prt_channel;	/* v^ڑ@ */
	USHORT		prt_sio_mode;	/* SIOʐM[h */
	UCHAR		prt_sio_mon;	/* SIOMRg[ */

	USHORT		sio_mode_save;	/* SIÕJgʐM[hޔ */
	UCHAR		sio_mon_save;	/* SIÕJgM䃂[hޔ ***
					 *   bit5:RS
					 *   bit4:CS
					 *   bit3:DR
					 *   bit2:CD
					 *************************************/
				/* [U[ݒ̃Rs[ */
	PRTForms	forms;
	PRTImage	image;
				/* e|ԊǗ */
	UCHAR*		nextstr;	/* ̃f[^obt@|C^ */
	UCHAR		file;		/* SIO or I/R's file handle */
	UCHAR		page;		/* Jgy[W */
	UCHAR		row;		/* Jgs */
					/* row == 0 ... }[W
					 * row != 0 ... ꂩ󎚂܂݈͌󎚂Ăs
					 *************************************/
	UCHAR		col;		/* Jg */
					/* col == 0 ... }[W *****
					 * col != 0 ... ꂩ󎚂錅 *
					 *************************************/
	USHORT		x;		/* JgW */
	USHORT		y;		/* JgcW */
					/* (x,y)==(0,0) ō㌴_ */
	USHORT		total_height;	/* C[W󎚍(Cv) */
	UCHAR		keisen_col;	/* rJg */
	UCHAR		ir_open_flag;	/* hqQnodm`FbNptO */
	UCHAR		ce_imege_flg;	/* bdoqPpC[W̉sflg */ 
	UCHAR		under_flg;	/* UNDERLINEL */
	UCHAR		page_flg;	/* y[WL */
	UCHAR		line_buff[80];	/* 󎚃obt@ */
	UCHAR*		buffp;		/* obt@|C^ */
} PRTCtrl;

/************************************************
 *		  O    Q  		*
 ************************************************/
/*** R}hO[v ***/
UCHAR PrtStart_B();
UCHAR PrtIRCheck_B();
UCHAR PrtEnd_B();

UCHAR PrtResetForm_B();
UCHAR PrtSetPaperSize_B();
UCHAR PrtSetTopMargin_B();
UCHAR PrtSetLeftMargin_B();
UCHAR PrtSetPageLen_B();
UCHAR PrtCRLFCtrl_B();
UCHAR PrtSetTabs_B();
UCHAR PrtSetCopyPaper_B();
UCHAR PrtSetVolume_B();
UCHAR PrtSetStyle_B();
UCHAR PrtSetPitch_B();
UCHAR PrtSetDeco_B();
UCHAR PrtSetForms_B();
UCHAR PrtGetForms_B();

UCHAR PrtPrintChar_B();
UCHAR PrtPrintDeco_B();
UCHAR PrtPrintKeisen_B();
UCHAR PrtImageTest_B();
UCHAR PrtPrintImage_B();
UCHAR PrtFeedLine_B();
UCHAR PrtFeedPage_B();

USHORT  PrtIsZenkaku_B();

UCHAR PrtStartNoDev_B();
UCHAR PrtEndNoDev_B();
UCHAR HighPrintKeisen_B();

/*** ̑ ***/
UCHAR add_char();
UCHAR add_str();
UCHAR add_strn();
UCHAR add_deci();
UCHAR flush_buff();
#endif
/*** EOF ***/
