/***********************************************************************
				<[Uݒpwb_t@C>

 <romdataread.h>

		{̃f[^ǂݏo[Uݒpwb_t@C
***********************************************************************/

#ifndef _ROMDATAREAD_H_

#include <zdam.h>
#include <dtmlib.h>
#include <sharpgen.h>

/* eAvʗpx` */
typedef enum ROMAPLNAME {
	ROM_SCHEDULE = 0,	/* XPW[ */
	ROM_SCHEDULE2,		/* XPW[iԃXPW[pj*/
	ROM_ACTION_LIST,	/* ANVXg */
	ROM_ADDRESS,		/* AhX */
	ROM_PHOTO_MEM,		/* tHg */
	ROM_PHOTO_MEM_THUM,	/* tHgi^CgƃTlĈ݁j*/
	ROM_INTERNET,		/* C^[lbgڑݒ */
	ROM_OWNER,		/* Lҏ */
	ROM_SPSHEET,		/* \vZ */
	ROM_SPSHEET_FORM	/* \vZ̃tH[ */
} ROMAPLNAME;

#define ROMAPLNUM	10

/* eAv̏e[up\ */
typedef struct ROMAPLINFO {
	UCHAR 		ResFileName[9];
	USHORT		BoxFInfoResID;
	USHORT		BoxFItemResID;
	USHORT		IdxInfoResID;
} ROMAPLINFO;


/* f[^[hp̏񃏁[N */
typedef struct ROMAPL_READ_INFO{
	ROMAPLNAME	RomAplName;
	UCHAR		Volume;	/* MAIN_VOLUME:{́ACARD_VOLUME:J[h */
	USHORT		TargetNo;  /* ǂݏof[^̃f[^ԍ */
				   /* ܂̓J[hhc */
				/* f[^ԍŎw肵ꍇ͖߂Ă */
				/* ۂɓǂݏoJ[hhcĂ */
	DTMFNAME	IndexFName; /* gpCfbNXt@C */
	UCHAR		ModelName[MODEL_NAME_MAX];	/* Ŏgp */
	UCHAR		Mode;	/* CARDID_MODE:TargerNo̓J[hhc */
				/* DATANO_MODE:TargetNo̓CfbNXNO*/
	FILEINFO* ROMFInfo;
	ZDCARDINFO* ROMCardInfo;
	BOOLEAN	IsOpened;	/* ł̏ꍇ́AOpenRomAplFile֐\ */
				/* R[Ă邩ǂ̃`FbNtO */
	BOOLEAN IsSecretIncluded; /* V[Nbgf[^̈ */
				/* DATANO_MODȄꍇɗL */
				/* true:ɃV[Nbgf[^ */
				/* false:V[Nbgݒ肳Ă */
				/*       V[Nbgf[^͈Ȃ */
} ROMAPL_READ_INFO;

/* ROMAPL_READ_INFOMode */
#define CARDID_MODE		1
#define DATANO_MODE		2

typedef struct RR_INDEXFINFO {
	STRING	SearchCond;	/* i荞ݏ */
	USHORT	SearchCondLen;	/* i荞ݏ̒ */
	STRING	SortCond;	/* \[g */
	USHORT	SortCondLen;	/* \[g̒ */
} RR_INDEXFINFO;

/* 񃏁[NROMAPL_READ_INFOModep` */

/* G[R[h */
#define RR_NO_ERR		0
#define	RR_FILE_OPEN_ERR	1
#define RR_DATA_READ_ERR	2
#define RR_HEAP_ERR		3
#define RR_FILE_INFO_ERR	4
#define RR_CARD_ERR		5
#define RR_MODE_ERR		6
#define RR_NO_OPEN_ERR		7
#define RR_DATA_FORMAT_ERR	8
#define RR_INVALID_VOLUME	9
#define RR_NO_DATA_ERR		10	/* Lҏ̊֐Ŏgp */

/* ȉROMAplDataCheck()̃G[R[h */
#define RR_INVALID_ATTR		100	/* Agr[g̒lُ */
#define RR_OVER_1ITEM_LEN	101	/* Pڂ̃f[^̒I[o[ */
#define RR_INVALID_STARTTIME	102	/* JniJnjُ */
#define RR_INVALID_ENDTIME	103	/* IiIjُ */
#define RR_NOT_SAME_DAY		104	/* JniJnjƏIiIjł͂Ȃ */
#define RR_INVALID_START_ENDTIME 105	/* JniJnjIiIj̕ߋɂȂĂ */
#define RR_INVALID_CONTACT	106	/* R^Ngo^f[^ُ */
#define RR_SAME_DAY		107	/* JniJnjƏIiIjł */
#define RR_INVALID_EXECTIME	108	/* ُ */
#define RR_INVALID_PRIORITY	109	/* vCIeBُ */
#define RR_INVALID_YOMI		110	/* u݁vf[^ُ */
#define RR_INVALID_BIRTHDAY	111	/* af[^ُ */
#define RR_INVALID_CHECKLIST	112	/* `FbNXgf[^ُ */
#define RR_OVER_1CARD_LEN	113	/* PJ[hf[^̒I[o[ */
#define RR_NO_ESSENTIAL		114	/* K{ڂݒ肳ĂȂ */
#define RR_INVALID_ALARMTIME	115	/* A[ُ */
#define RR_INVALID_THUMBNAIL	116	/* TlCf[^̃tH[}bg */
#define RR_NOT_HANKAKU_STR	117	/* pݒłȂڂɑSp܂܂Ă */
#define RR_INVALID_SWITCH	118	/* XCb`'1'A'2'ȊO̐lĂ */

/*==== eAvP[VƂ̃x ====*/
enum {
	ZD_CTGR_FIELD = 4,
	ZD_LKIF_FIELD,
	ZD_LKDT_FIELD
};
/***** XPW[p *****/
enum {
	RR_TIM1_FIELD = ZD_USER_FIELD+2,	/* Jn */
	RR_TIM2_FIELD,				/* I */
	RR_MEM1_FIELD,				/* XPW[e */
	RR_ATTM_FIELD,
	RR_ALRM_FIELD,				/* A[g */
	RR_CNTC_FIELD
};

#define RR_SCDL_TIME_BUFF_SIZE	32
#define RR_SCDL_MEM_BUFF_SIZE	(1024+2)
#define	ALARM_ON	1
/* R^Ngf[^ */
#define CNTC_TEL	1	/* db */
#define CNTC_FAX	2	/* FAX */
#define CNTC_MEET	3	/*  */
#define CNTC_MAIL	4	/* [ */
/* ǂݏof[^߂̃[N */
typedef struct RR_SCHE_DATA{
	TIME	StartTime;
	TIME	EndTime;
	UCHAR*	ContentStr;
	TIME	AlarmTime;
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	StartTimeDataLen;	/* Jnf[^Ȃ͂O */
	DATALEN	EndTimeDataLen;		/* If[^Ȃ͂O */
	DATALEN	ContentStrDataLen;	/* ef[^Ȃ͂P */
	DATALEN	AlarmTimeDataLen;	/* A[f[^Ȃ͂O */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
	UCHAR	ContactData;		/* R^Ngf[^ */
	DATALEN	ContactDataLen;		/* R^Ngf[^̒ */
		/* PFR^Ngf[^AOFR^Ngf[^͂Ȃ */
} RR_SCHE_DATA;

/***** XPW[iԃXPW[j*****/
/* CTGR,LKIF̒`̓XPW[̂̂g */
enum {
	RR_STDY_FIELD = ZD_USER_FIELD+2,	/* Jn */
	RR_EDDY_FIELD				/* I */
/*	RR_MEM1_FIELD  ̍ڂ̓XPW[̂̂g */
};
/* f[^̍őTCY̓XPW[RR_SCDL_`g */

/* ǂݏof[^߂̃[N */
/* LRR_SCHE_DATÂ܂܎gB̏ꍇAlarmTime͖Ӗ */

/***** ANVXg *****/
/* CTGR,LKIF̒`̓XPW[̂̂g */
enum {
	RR_ETDY_FIELD = ZD_USER_FIELD+2,	/* Jn */
	RR_LTDY_FIELD,				/* I */
	RR_FNDY_FIELD,				/*  */
	RR_MARK_FIELD,				/* `FbN */
	RR_PRTY_FIELD,				/* dvx */
	RR_MEM2_FIELD				/* Todoe */
};

/* f[^̍őTCY̓XPW[RR_SCDL_`g */

/* ǂݏof[^߂̃[N */
typedef struct RR_ACTION_DATA{
	TIME	StartDay;			/* Jn */
	TIME	LimitDay;			/*  */
	TIME	FinishDay;			/*  */
	UCHAR	Check;				/* `FbN */
	UCHAR	Priority;			/* dvx */
	UCHAR*	ContentStr;			/* Todoe */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	StartDayDataLen;	/* Jnf[^Ȃ͂O */
	DATALEN	LimitDayDataLen;	/* f[^Ȃ͂O */
	DATALEN	FinishDayDataLen;	/* f[^Ȃ͂O */
	DATALEN	ContentStrDataLen;	/* Todoef[^Ȃ͂P */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
} RR_ACTION_DATA;


/***** AhX *****/
enum {
	RR_NAME_FIELD = ZD_USER_FIELD+2,	/* l */
	RR_NAPR_FIELD,				/* l */
	RR_TEL1_FIELD,				/* dbԍ */
	RR_FAX1_FIELD,				/* FAXԍ */
	RR_PGR1_FIELD,				/* |Pxԍ */
	RR_CPS1_FIELD,				/* gѓdbԍ */
	RR_ZIPC_FIELD,				/* X֔ԍ */
	RR_ADR1_FIELD,				/* Z */
	RR_MAL1_FIELD,				/* [AhX */
	RR_OFCE_FIELD,				/* Ж */
	RR_OFPR_FIELD,				/* Жǂ */
	RR_TEL2_FIELD,				/* Гdbԍ */
	RR_FAX2_FIELD,				/* FAXԍ */
	RR_ZIP2_FIELD,				/* ЗX֔ԍ */
	RR_ADR2_FIELD,				/* ЏZ */
	RR_SCTN_FIELD,				/*  */
	RR_PSTN_FIELD,				/* E */
	RR_BRTH_FIELD,				/* N */
	RR_RMRK_FIELD,				/* l */
	RR_CHK1_FIELD,				/*  */
	RR_CHK2_FIELD,				/* N */
	RR_CHK3_FIELD,				/*  */
	RR_CHK4_FIELD,				/* Ε */
	RR_IMJG_FIELD				/* C[W */
};

#define RR_YOMI_BUFF_SIZE	(8*2+1)
#define RR_ADRS_1ITEM_BUFF_SIZE	1230
#define RR_ADRS_IMAGE_BUFF_SIZE	(1024*4)
#define RR_BRTH_DATA_LEN	20
#define RR_CHK_DATA_LEN		2


/* ǂݏof[^߂̃[N */
typedef struct RR_ADDRESS_DATA{
	UCHAR*	PersName;	/* O */
	UCHAR*	PersNapr;	/* Oǂ */
	UCHAR*	PersTel;	/* dbԍ */
	UCHAR*	PersFax;	/* FAXԍ */
	UCHAR*	PBell;		/* |Pxԍ */
	UCHAR*	Cps;		/* gѓdbԍ */
	UCHAR*	PersZip;	/* X֔ԍ */
	UCHAR*	PersAdr;	/* Z */
	UCHAR*	PersMail;	/* [AhX */
	UCHAR*	OffName;	/* Ж */
	UCHAR*	OffNapr;	/* Ж */
	UCHAR*	OffTel;		/* Гdbԍ */
	UCHAR*	OffFax;		/* FAXԍ */
	UCHAR*	OffZip;		/* ЗX֔ԍ */
	UCHAR*	OffAdr;		/* ЏZ */
	UCHAR*	OffSctn;	/*  */
	UCHAR*	OffPstn;	/* E */
	TIME	Birthday;	/* N */
	UCHAR*	Remark;		/* l */
	UCHAR 	Chk1Mimai;	/*  */
	UCHAR 	Chk2Nenga;	/* N */
	UCHAR 	Chk3Tyugen;	/*  */
	UCHAR 	Chk4Seibo;	/* Ε */
	UCHAR*	FaceImage;	/* C[W */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	PersNameDataLen;	/* Of[^Ȃ͂P */
	DATALEN	PersNaprDataLen;	/* Oǂ݃f[^Ȃ͂P */
	DATALEN	PersTelDataLen;	/* dbԍf[^Ȃ͂P */
	DATALEN	PersFaxDataLen;	/* FAXf[^Ȃ͂P */
	DATALEN	PBellDataLen;	/* |Pxԍf[^Ȃ͂P */
	DATALEN	CpsDataLen;	/* gѓdbԍf[^Ȃ͂P */
	DATALEN	PersZipDataLen;	/* X֔ԍf[^Ȃ͂P */
	DATALEN	PersAdrDataLen;	/* Zf[^Ȃ͂P */
	DATALEN	PersMailDataLen;/* [AhXf[^Ȃ͂P */
	DATALEN	OffNameDataLen;	/* Жf[^Ȃ͂P */
	DATALEN	OffNaprDataLen;	/* Ж݃f[^Ȃ͂P */
	DATALEN	OffTelDataLen;	/* Гdbԍf[^Ȃ͂P */
	DATALEN	OffFaxDataLen;	/* FAXԍf[^Ȃ͂P */
	DATALEN	OffZipDataLen;	/* ЗX֔ԍf[^Ȃ͂P */
	DATALEN	OffAdrDataLen;	/* ЏZf[^Ȃ͂P */
	DATALEN	OffSctnDataLen;	/* f[^Ȃ͂P */
	DATALEN	OffPstnDataLen;	/* Ef[^Ȃ͂P */
	DATALEN	BirthdayDataLen;	/* Nf[^Ȃ͂O */
	DATALEN	RemarkDataLen;	/* lf[^Ȃ͂P */
	DATALEN	FaceImageDataLen;	/* C[Wf[^Ȃ͂O */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
} RR_ADDRESS_DATA;

/* Pf[^̂ꂼ̍ڂ̃ItZbg */
#define OFFSET_NAME	0
#define OFFSET_NAPR	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*1)
#define OFFSET_TEL1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*1 + RR_YOMI_BUFF_SIZE)
#define OFFSET_FAX1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*2 + RR_YOMI_BUFF_SIZE)
#define OFFSET_PGR1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*3 + RR_YOMI_BUFF_SIZE)
#define OFFSET_CPS1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*4 + RR_YOMI_BUFF_SIZE)
#define OFFSET_ZIPC	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*5 + RR_YOMI_BUFF_SIZE)
#define OFFSET_ADR1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*6 + RR_YOMI_BUFF_SIZE)
#define OFFSET_MAL1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*7 + RR_YOMI_BUFF_SIZE)
#define OFFSET_OFCE	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*8 + RR_YOMI_BUFF_SIZE)
#define OFFSET_OFPR	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*9 + RR_YOMI_BUFF_SIZE)
#define OFFSET_TEL2	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*9 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_FAX2	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*10 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_ZIP2	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*11 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_ADR2	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*12 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_SCTN	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*13 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_PSTN	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*14 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_BRTH	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*15 + RR_YOMI_BUFF_SIZE*2)
#define OFFSET_RMRK	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*15 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)
#define OFFSET_CHK1	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*16 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)
#define OFFSET_CHK2	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*17 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)
#define OFFSET_CHK3	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*18 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)
#define OFFSET_CHK4	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*19 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)
#define OFFSET_IMJG	(OFFSET_NAME + RR_ADRS_1ITEM_BUFF_SIZE*20 + RR_YOMI_BUFF_SIZE*2 + RR_BRTH_DATA_LEN)

#define RR_ADRS_TOTAL_1DATA_SIZE OFFSET_IMJG

/***** tHg *****/
enum {
	RR_CLAS_FIELD = ZD_USER_FIELD+3,	/* ^Cg */
	RR_IMG1_FIELD,				/* rbg}bv */
	RR_TMNL_FIELD,				/* TlC */
	RR_IMGF_FIELD,				/* GIFC[W */
	RR_P_IMJG_FIELD				/* JPEGC[W */
};

#define RR_PHOT_MEM_BUFF_SIZE	(126*1024)
#define RR_PHOT_TMNL_BUFF_SIZE	(40*30*2+12+100) /* ی100oCgǉ */

/* ǂݏof[^߂̃[N */
typedef struct RR_PHOT_DATA{
	UCHAR*	Title;
	UCHAR*	Image;
	UINT	ImageSize; /* ۂɓǂݏof[^̃TCYoĂ */
	UCHAR* 	Thumbnail;	/* TlCf[^̈ */
	UINT	ThumbnailSize;	/* TlCf[^̃TCY */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	TitleDataLen;	/* ^Cgf[^Ȃ͂P */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
} RR_PHOT_DATA;


/***** \vZ *****/
enum {
	RR_XLIF_FIELD = ZD_USER_FIELD+3,	/* \vZf[^̏ */
	RR_SPCLAS_FIELD,				/* ^Cg */
	RR_ZXLS_FIELD				/* \vZf[^ */
};

#define WORKBOOK_TITLE_LENGTH 	32+1		/* ^Cg */
#define TEMPLATE_TITLE_LENGTH 	20+1		/* ev[g^Cg */
#define FILE_BUFFER_SIZE 	126 * 1024 + 10	/* XLSf[^ */
#define CHART_UNKNOWN	0
#define CHART_NONE	1
#define CHART_WITH	2

/* ǂݏof[^߂̃[N */
typedef struct RR_SPSH_DATA{
	UCHAR	SpshInfo;	/* \vZf[^̏ */
	UCHAR*	Title;
	UCHAR*	SpshData;
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	TitleDataLen;	/* ^Cgf[^Ȃ͂P */
	DATALEN	SpshDataLen;	/* \vZf[^̒ */
	UCHAR	Attr;		/* Agr[giV[Nbgpj*/
} RR_SPSH_DATA;


/***** C^[lbgڑݒ *****/

enum {
	RR_INET_NAME_FIELD = ZD_USER_FIELD+1,	/* ^Cg */
	RR_INET_NAPR_FIELD,		/* ^Cgǂ */
	RR_INET_TEL1_FIELD,		/* dbԍ */
	RR_INET_USID_FIELD,		/* RlNVhc */
	RR_INET_PSWD_FIELD,		/* RlNVpX[h */
	RR_INET_POPA_FIELD,		/* POPAJEg */
	RR_INET_POPP_FIELD,		/* POPpX[h */
	RR_INET_SVAD_FIELD,		/* T[oAhX */
	RR_INET_MLAD_FIELD,		/* [AhX */
	RR_INET_CFIP_FIELD,		/* IPAhX */
	RR_INET_NMSK_FIELD,		/* lbg}XN */
	RR_INET_DNS1_FIELD,		/* DNS1 */
	RR_INET_DNS2_FIELD,		/* DNS2 */
	RR_INET_MEM1_FIELD,		/* XNvg */
	RR_INET_IORR_FIELD,		/* C^[lbg^[g */
	RR_INET_ZPKS_FIELD,		/* UEXőMpPbgTCY */
	RR_INET_SPKS_FIELD,		/* T[oőMpPbgTCY */
	RR_INET_ZCCP_FIELD,		/* UEX񓯊̃LN^}bv */
	RR_INET_SCCP_FIELD,		/* T[o񓯊̃LN^}bv */
	RR_INET_TCPS_FIELD,		/* TCPݒ */
	RR_INET_WWHM_FIELD,		/* z[y[W */
	RR_INET_PRXY_FIELD,		/* ProxyT[o */
	RR_INET_PRXP_FIELD		/* Proxy|[g */
};

/*
 * TCPSET
 */
#define	TCPSET_IPSW	0		/* 14 IPAhXݒXCb` */
#define	TCPSET_PWSW	1		/* 5  pX[hXCb` */
#define	TCPSET_PROC	2		/* 11 ڑ菇XCb` */
#define	TCPSET_ZASW	3		/* 21 UEX̔F؃vgR */
#define	TCPSET_SASW	4		/* 22 T[o̔F؃vgR */
#define	TCPSET_ZPCM	5		/* 23 UEX̃vgRk */
#define	TCPSET_SPCM	6		/* 24 T[õvgRk */
#define	TCPSET_ZACF	7		/* 25 UEX̃AhXk */
#define	TCPSET_SACF	8		/* 26 T[õAhXk */
#define	TCPSET_ZTCM	9		/* 29 UEXTCP/IPk */
#define	TCPSET_STCM	10		/* 30 T[oTCP/IPk */
#define	TCPSET_END	11		/* End */

#define PROVMODE_ALL	0
#define PROVMODE_INET	1
#define PROVMODE_REMOTE	3
#define PROVMODE_NIF	2
#define PROVMODE_TCP	0

#define ZWWWPREFFILE	((UCHAR*)"ZWWWPREF")
#define	ITEM_HOMEPAGEMODE	((UCHAR*)"HOMD")
#define	ITEM_HOMEPAGEADR	((UCHAR*)"HOAD")
#define ITEM_PROXYMODE		((UCHAR*)"PXMD")
#define	ITEM_PROXYADR		((UCHAR*)"PXAD")
#define	ITEM_PROXYPORT		((UCHAR*)"PXPT")

#define SIZE_OF_MADR    (256+1)		/* [AhX */
#define SIZE_OF_TITLE  (64+1)		/* ^Cg */
#define SIZE_OF_YOMI    (64+1)		/* ǂ */
#define SIZE_OF_PSWD    (31+1)		/* pX[h */
#define SIZE_OF_IP      (15+1)		/* IPAhX */
#define SIZE_OF_SCRPT   (1024+1)	/* ڑXNvg */
#define SIZE_OF_TELNUM  (92+1)		/* dbԍ */
#define SIZE_OF_PSIZE   (4+1)		/* NCAgpPbgTCY */
#define SIZE_OF_MNUM    (16+1)
#define SIZE_OF_CONID   (31+1)		/* RlNVID */
#define SIZE_OF_POPA    (64+1)		/* POPAJEg(hC܂) */
#define SIZE_OF_TCPSET  (32+1)		/* eTCPݒ */
#define SIZE_OF_ZSCMAP  (8+1)		/* TCP/IPLN^}bv */
#define DAPI_HOME_LEN	128
#define DAPI_PROXY_LEN	32
#define DAPI_PORT_LEN	6
#define SIZE_OF_WHOME	(DAPI_HOME_LEN+1+1)	/* ftHgz[ */
#define SIZE_OF_PROXY	(DAPI_PROXY_LEN+1+1)	/* Proxy */
#define SIZE_OF_PRXPORT	DAPI_PORT_LEN		/* Proxy-Port */

#define RR_INET_TOTAL_BUFSIZE (SIZE_OF_TITLE + SIZE_OF_YOMI + SIZE_OF_TELNUM \
			+ SIZE_OF_CONID + SIZE_OF_PSWD + SIZE_OF_POPA \
			+ SIZE_OF_PSWD + SIZE_OF_MADR + SIZE_OF_MADR \
			+ SIZE_OF_SCRPT + SIZE_OF_IP*4 + SIZE_OF_PSIZE*2 \
			+ SIZE_OF_ZSCMAP*2 + SIZE_OF_WHOME + SIZE_OF_PROXY \
			+ SIZE_OF_PRXPORT + SIZE_OF_TCPSET + sizeof(UCHAR))

/* ǂݏof[^߂̃[N */
typedef	struct	RR_INET_DATA{
	UCHAR*	Title;		/* ^Cg */
	UCHAR*	TitleYomi;	/* ^Cgǂ	*/
	UCHAR*	TelNumber;	/* dbԍ */
	UCHAR*	CnctID;		/* RlNVID */
	UCHAR*	CnctPasswd;	/* RlNVpX[h */
	UCHAR*	PopAccount;	/* POPAJEg(hC܂) */
	UCHAR*	MailPasswd;	/* [pX[h */
	UCHAR*	MailServer;	/* [T[o[ */
	UCHAR*	MailAddress;	/* [AhX */
	UCHAR*	IPAddress;	/* IPAhX */
	UCHAR*	NetMask;	/* lbg}XN */
	UCHAR*	DNS1;		/* DNS T[o[1 */
	UCHAR*	DNS2;		/* DNS T[o[2 */
	UCHAR*	Script;		/* ڑXNvg */
	UCHAR*	ZPacketSize;	/* UEXőMpPbgTCY */
	UCHAR*	SPacketSize;	/* T[o[őMpPbgTCY */
	UCHAR*	ZCharMap;	/* UEXRg[LN^}bv */
	UCHAR*	SCharMap;	/* T[o[Rg[LN^}bv */
	UCHAR*	DefHomePage;	/* ftHgz[ */
	UCHAR*	ProxyServer;	/* ProxyT[o[ */
	UCHAR*	ProxyPort;	/* Proxy|[g */
	UCHAR	TCPInfo[TCPSET_END+1];	/* eTCPݒ */
	UCHAR	Int_Remote;	/* [g^C^[lbgݒ	*/

	DATALEN	TitleDataLen;		/* ^Cg */
	DATALEN	TitleYomiDataLen;	/* ^Cgǂݒ */
	DATALEN	TelNumberDataLen;	/* dbԍ */
	DATALEN	CnctIDDataLen;		/* RlNVID */
	DATALEN	CnctPasswdDataLen;	/* RlNVpX[h */
	DATALEN	PopAccountDataLen;	/* POPAJEg(hC܂) */
	DATALEN	MailPasswdDataLen;	/* [pX[h */
	DATALEN	MailServerDataLen;	/* [T[o[ */
	DATALEN	MailAddressDataLen;	/* [AhX */
	DATALEN	IPAddressDataLen;	/* IPAhX */
	DATALEN	NetMaskDataLen;		/* lbg}XN */
	DATALEN	DNS1DataLen;		/* DNS T[o[1 */
	DATALEN	DNS2DataLen;		/* DNS T[o[2 */
	DATALEN	ScriptDataLen;		/* ڑXNvg */
	DATALEN	ZPacketSizeDataLen;	/* UEXőMpPbgTCY */
	DATALEN	SPacketSizeDataLen;	/* T[o[őMpPbgTCY */
	DATALEN	ZCharMapDataLen;	/* UEXRg[LN^}bv */
	DATALEN	SCharMapDataLen;	/* T[o[Rg[LN^}bv */
	DATALEN	DefHomePageDataLen;	/* ftHgz[iMI-300,MT-200̂݁j */
	DATALEN	ProxyServerDataLen;	/* ProxyT[o[iMI-300,MT-200̂݁j */
	DATALEN	ProxyPortDataLen;	/* Proxy|[giMI-300,MT-200̂݁j */
	UCHAR*	UseBuffTop;
} RR_INET_DATA;




/*==== eAvP[VƂ̃x̏I ====*/

/* ǂݏof[^MOREň߂̃[N */
typedef union ROMAPL_DATAWORK{
	RR_SCHE_DATA	Schedule;
	RR_ACTION_DATA	Todo;
	RR_ADDRESS_DATA Address;
	RR_PHOT_DATA	Photo;
	RR_INET_DATA	Internet;
	RR_SPSH_DATA	Spsheet;
} ROMAPL_DATAWORK;


/* ֐̃vg^Cv錾 */
/* romdatadelete.c */
UCHAR DeleteROMAplOneData(ROMAPL_READ_INFO* RomAplDataInfo);

/* romdatawrite.c */
UCHAR WriteROMAplData(ROMAPL_READ_INFO* RomAplDataInfo, ROMAPL_DATAWORK* AplDataWork);

/* romdatacommon.c */
BOOLEAN RR_Is1_2Switch(char TargetChar);
BOOLEAN RR_IsHankakuStr(char* TargetStr);
BOOLEAN RR_CheckYOMIData(char*	TargetStr, DATALEN StrLen);
static BOOLEAN RR_IsInRange(USHORT TargetCode, USHORT MinimamCode, USHORT MaximamCode);
BOOLEAN RR_ChangeVolume(FILEINFO* ROMFInfo, UCHAR Volume);
BOOLEAN RR_IsNewerModel(USHORT ModelNumber, BOOLEAN IsTargetModelIncluded);
BOOLEAN RR_IsMI10();
BOOLEAN RR_IsMIEX1();
BOOLEAN RR_CheckAddressCheckItem(UCHAR CheckItemData);
BOOLEAN RR_CheckStrLen(UCHAR* StrData, DATALEN StrDataLen, DATALEN LimitDataLen);
APLID RR_GetAplIDFromROMAplName(ROMAPLNAME ROMAplName);
BOOLEAN RR_IsSameDay(TIME* TimeDay1, TIME* TimeDay2);
BOOLEAN RR_IsValidTimeData(TIME* TimeData, BOOLEAN IsWildcardOK);
void RR_SendAplDataUpdateMsg(ROMAPLNAME RomAplName,BOOLEAN IsNewDataAdded);

/* romdatawrite_f.c */
UCHAR WriteROMAplFile(ROMAPL_READ_INFO* RomAplReadInfo, ROMAPL_DATAWORK* AplDataWork);
UCHAR CheckROMAplOneData(ROMAPLNAME RomAplName, ROMAPL_DATAWORK* AplDataWork);

/* romdatawrite_sub.c */
ZDAMERR RR_WriteCardData(ROMAPL_READ_INFO* RomAplDataInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteScheDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteScheData(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteSche2DataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteSche2Data(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteActDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteActData(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteAddDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteAddData(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WritePhotoDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WritePhotoData(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteInternetDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteInternetData(FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,ROMAPL_DATAWORK* AplDataWork,CARDID* TargetCardID);
static BOOLEAN WriteZWWWPref(RR_INET_DATA* InetData);
UCHAR RR_WriteOwnerDataCheck(ROMAPL_DATAWORK* AplDataWork);
UCHAR RR_WriteSpsheetDataCheck(ROMAPL_DATAWORK* AplDataWork);
static ZDAMERR RR_WriteSpsheetData(FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,ROMAPL_DATAWORK* AplDataWork,CARDID* TargetCardID);
UCHAR RR_WriteSpsheetFormDataCheck(ROMAPL_DATAWORK* AplDataWork);


/* romdataread_f.c */
UCHAR OpenROMAplFile(ROMAPL_READ_INFO* RomAplDataInfo);
UCHAR ReadROMAplFile(ROMAPL_READ_INFO* RomAplDataInfo,ROMAPL_DATAWORK* AplDataWork);
void CloseROMAplFile(ROMAPL_READ_INFO* RomAplDataInfo);
UCHAR CountROMAplFile(ROMAPL_READ_INFO* pRomAplDataInfo,USHORT* DataNum);

/* romdataread.c */
void DispErrorMessage(char* errormes,char* funcname);
void DisposeROMAplWork(ROMAPL_READ_INFO* RomAplReadInfo,ROMAPL_DATAWORK* AplDataWork);
UCHAR CountROMAplDataNum(ROMAPL_READ_INFO* RomAplReadInfo, USHORT* DataNum);
UCHAR CreateROMAplIndexFile(ROMAPLNAME ROMAplName,DTMFNAME* IndexFName,RR_INDEXFINFO* IndexFInfo);
UCHAR ReadROMAplData(ROMAPL_READ_INFO* RomAplReadInfo,ROMAPL_DATAWORK* AplDataWork);

/* romdataread_sub.c */
void RR_SetupRomAplFile(FILEINFO* ROMFInfo,APLID AplName);
void RR_SetupRomAplVolumeFile(FILEINFO* ROMFInfo,APLID AplName,UCHAR VolumeNo);
static void DeleteFamilyIndex(DTMFNAME *BoxFName, UCHAR IndexNum,DTMFNAME *IndexFNameList);
void RR_DisposeRomAplCardInfo(ZDCARDINFO* RomAplCardInfo);
ZDCARDINFO* RR_SetRomAplCardInfo(ROMAPLNAME RomAplName);
void RR_DisposeRomAplFileInfo(FILEINFO* RomAplFileInfo);
FILEINFO* RR_SetRomAplFileInfo(ROMAPLNAME RomAplName);
void SetRomAplInfo();
ZDAMERR RR_ReadCardData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadPhotoData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadAddData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadActData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadSche2Data(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadScheData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
CARDID RR_GetTargetCardID(ROMAPL_READ_INFO* RomAplReadInfo);
void RR_SetWorkFromData(ROMAPL_READ_INFO* RomAplReadInfo,ROMAPL_DATAWORK* AplDataWork,ZDCARDINFO* ROMCardInfo);
BOOLEAN RR_CheckParam(ROMAPL_READ_INFO* RomAplReadInfo);
ZDAMERR RR_ReadInetData(ROMAPL_READ_INFO* RomAplReadInfo, FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, CARDID TargetCardID);
static BOOLEAN ReadZWWWPref(RR_INET_DATA* InetData);
ZDAMERR RR_ReadSpsheetData(ROMAPL_READ_INFO* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);

#define _ROMDATAREAD_H_
#endif
