/***********************************************************************
 <romdataread_ex.h>

	Copyright (c) 1995-1999 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-EX1

		EX1V[Yp{̃f[^ǂݏo[Uݒpwb_t@C
		romdataread.hƂ݂̍̂Lq
***********************************************************************/

#ifndef _ROMDATAREAD_H_

#include <zdam.h>
#include <dtmlib.h>
#include <sharpgen.h>
#include <romdataread.h>
#include <geolib.h>

/* dqAo̓ǂݏňf[^^Cv */
/* ܂Aǂݏ鎞̔ʗpɂgp */
/* JPEGAPNG𗼕ƂƂ邽߁ArbgtB[hɂ */
#define RR_JPEG_IMAGE		((UINT)0x00000001)		/* JPEGf[^ */
#define	RR_PNG_IMAGE		((UINT)0x00000002)		/* PNGf[^ */


/* f[^[hp̏񃏁[N */
typedef struct ROMAPL_READ_INFO_EX{
	ROMAPLNAME	RomAplName;
	UCHAR		Volume;	/* MAIN_VOLUME:{́ACARD_VOLUME:J[h */
	USHORT		TargetNo;  /* ǂݏof[^̃f[^ԍ */
				   /* ܂̓J[hhc */
				/* f[^ԍŎw肵ꍇ͖߂Ă */
				/* ۂɓǂݏoJ[hhcĂ */
	DTMFNAME	IndexFName; /* gpCfbNXt@C */
	UCHAR		ModelName[MODEL_NAME_MAX];	/* Ŏgp */
	UCHAR		Mode;	/* CARDID_MODE:TargerNo̓J[hhc */
				/* DATANO_MODE:TargetNo̓CfbNXNO*/
	FILEINFO* ROMFInfo;
	ZDCARDINFO* ROMCardInfo;
	BOOLEAN	IsOpened;	/* ł̏ꍇ́AOpenRomAplFile֐\ */
				/* R[Ă邩ǂ̃`FbNtO */
	BOOLEAN IsSecretIncluded; /* V[Nbgf[^̈ */
				/* DATANO_MODȄꍇɗL */
				/* true:ɃV[Nbgf[^ */
				/* false:V[Nbgݒ肳Ă */
				/*       V[Nbgf[^͈Ȃ */
	UINT	ImageType;	/*C[W^CvidqAo̎̂ݎgpj*/
						/* RR_JPEG_IMAGE		JPEGf[^݈̂ */
						/* RR_PNG_IMAGE		PNGf[^݈̂ */
					/* RR_JPEG_IMAGE+RR_PNG_IMAGE	JPEGPNG̗ */
} ROMAPL_READ_INFO_EX;


/* ȉROMAplDataCheckEx()̃G[R[h */
/* 120ȉ̔ԍromdataread.hɒ` */
#define RR_INVALID_LATITUDE		120		/* ܓxf[^ُ */
#define RR_INVALID_LONGITUDE	121		/* oxf[^ُ */


/*==== eAvP[VƂ̃x ====*/

/***** XPW[p *****/

/* ǂݏof[^߂̃[N */
typedef struct RR_SCHE_DATA_EX{
	TIME	StartTime;
	TIME	EndTime;
	UCHAR*	ContentStr;
	TIME	AlarmTime;
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	StartTimeDataLen;	/* Jnf[^Ȃ͂O */
	DATALEN	EndTimeDataLen;		/* If[^Ȃ͂O */
	DATALEN	ContentStrDataLen;	/* ef[^Ȃ͂P */
	DATALEN	AlarmTimeDataLen;	/* A[f[^Ȃ͂O */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
	UCHAR	ContactData;		/* R^Ngf[^ */
	DATALEN	ContactDataLen;		/* R^Ngf[^̒ */
		/* PFR^Ngf[^AOFR^Ngf[^͂Ȃ */
} RR_SCHE_DATA_EX;

/***** XPW[iԃXPW[j*****/

/* f[^̍őTCY̓XPW[RR_SCDL_`g */

/* ǂݏof[^߂̃[N */
/* LRR_SCHE_DATÂ܂܎gB̏ꍇAlarmTime͖Ӗ */

/***** ANVXg *****/

/* f[^̍őTCY̓XPW[RR_SCDL_`g */

/* ǂݏof[^߂̃[N */
typedef struct RR_ACTION_DATA_EX{
	TIME	StartDay;			/* Jn */
	TIME	LimitDay;			/*  */
	TIME	FinishDay;			/*  */
	UCHAR	Check;				/* `FbN */
	UCHAR	Priority;			/* dvx */
	UCHAR*	ContentStr;			/* Todoe */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	StartDayDataLen;	/* Jnf[^Ȃ͂O */
	DATALEN	LimitDayDataLen;	/* f[^Ȃ͂O */
	DATALEN	FinishDayDataLen;	/* f[^Ȃ͂O */
	DATALEN	ContentStrDataLen;	/* Todoef[^Ȃ͂P */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
} RR_ACTION_DATA_EX;


/***** AhX *****/
#if 0
enum {
	RR_NAME_FIELD = ZD_USER_FIELD+2,	/* l */
	RR_NAPR_FIELD,				/* l */
	RR_TEL1_FIELD,				/* dbԍ */
	RR_FAX1_FIELD,				/* FAXԍ */
	RR_PGR1_FIELD,				/* |Pxԍ */
	RR_CPS1_FIELD,				/* gѓdbԍ */
	RR_ZIPC_FIELD,				/* X֔ԍ */
	RR_ADR1_FIELD,				/* Z */
	RR_MAL1_FIELD,				/* [AhX */
	RR_OFCE_FIELD,				/* Ж */
	RR_OFPR_FIELD,				/* Жǂ */
	RR_TEL2_FIELD,				/* Гdbԍ */
	RR_FAX2_FIELD,				/* FAXԍ */
	RR_ZIP2_FIELD,				/* ЗX֔ԍ */
	RR_ADR2_FIELD,				/* ЏZ */
	RR_SCTN_FIELD,				/*  */
	RR_PSTN_FIELD,				/* E */
	RR_BRTH_FIELD,				/* N */
	RR_RMRK_FIELD,				/* l */
	RR_CHK1_FIELD,				/*  */
	RR_CHK2_FIELD,				/* N */
	RR_CHK3_FIELD,				/*  */
	RR_CHK4_FIELD				/* Ε */
	RR_IMJG_FIELD				/* C[W */
}
#endif
enum {
	RR_LTLD_FIELD = RR_IMJG_FIELD+1,		/* ܓx */
	RR_LTLG_FIELD,				/* ox */
	RR_ICON_FIELD				/* X|bgACRԍ */
};


/* ǂݏof[^߂̃[N */
typedef struct RR_ADDRESS_DATA_EX{
	UCHAR*	PersName;	/* O */
	UCHAR*	PersNapr;	/* Oǂ */
	UCHAR*	PersTel;	/* dbԍ */
	UCHAR*	PersFax;	/* FAXԍ */
	UCHAR*	PBell;		/* |Pxԍ */
	UCHAR*	Cps;		/* gѓdbԍ */
	UCHAR*	PersZip;	/* X֔ԍ */
	UCHAR*	PersAdr;	/* Z */
	UCHAR*	PersMail;	/* [AhX */
	UCHAR*	OffName;	/* Ж */
	UCHAR*	OffNapr;	/* Ж */
	UCHAR*	OffTel;		/* Гdbԍ */
	UCHAR*	OffFax;		/* FAXԍ */
	UCHAR*	OffZip;		/* ЗX֔ԍ */
	UCHAR*	OffAdr;		/* ЏZ */
	UCHAR*	OffSctn;	/*  */
	UCHAR*	OffPstn;	/* E */
	TIME	Birthday;	/* N */
	UCHAR*	Remark;		/* l */
	UCHAR 	Chk1Mimai;	/*  */
	UCHAR 	Chk2Nenga;	/* N */
	UCHAR 	Chk3Tyugen;	/*  */
	UCHAR 	Chk4Seibo;	/* Ε */
	UCHAR*	FaceImage;	/* C[W */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
				/* AhXBJpɋLĂB*/
	DATALEN	PersNameDataLen;	/* Of[^Ȃ͂P */
	DATALEN	PersNaprDataLen;	/* Oǂ݃f[^Ȃ͂P */
	DATALEN	PersTelDataLen;	/* dbԍf[^Ȃ͂P */
	DATALEN	PersFaxDataLen;	/* FAXf[^Ȃ͂P */
	DATALEN	PBellDataLen;	/* |Pxԍf[^Ȃ͂P */
	DATALEN	CpsDataLen;	/* gѓdbԍf[^Ȃ͂P */
	DATALEN	PersZipDataLen;	/* X֔ԍf[^Ȃ͂P */
	DATALEN	PersAdrDataLen;	/* Zf[^Ȃ͂P */
	DATALEN	PersMailDataLen;/* [AhXf[^Ȃ͂P */
	DATALEN	OffNameDataLen;	/* Жf[^Ȃ͂P */
	DATALEN	OffNaprDataLen;	/* Ж݃f[^Ȃ͂P */
	DATALEN	OffTelDataLen;	/* Гdbԍf[^Ȃ͂P */
	DATALEN	OffFaxDataLen;	/* FAXԍf[^Ȃ͂P */
	DATALEN	OffZipDataLen;	/* ЗX֔ԍf[^Ȃ͂P */
	DATALEN	OffAdrDataLen;	/* ЏZf[^Ȃ͂P */
	DATALEN	OffSctnDataLen;	/* f[^Ȃ͂P */
	DATALEN	OffPstnDataLen;	/* Ef[^Ȃ͂P */
	DATALEN	BirthdayDataLen;	/* Nf[^Ȃ͂O */
	DATALEN	RemarkDataLen;	/* lf[^Ȃ͂P */
	DATALEN	FaceImageDataLen;	/* C[Wf[^Ȃ͂O */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
	UCHAR	Latitude[GEO_LATIT_NSTR_LEN];	/* ܓx */
	UCHAR	Longitude[GEO_LONGIT_NSTR_LEN];	/* ox */
	USHORT	SpotIconNo;		/* X|bgACRԍ */
} RR_ADDRESS_DATA_EX;


/***** dqAo *****/
#if 0
enum {
	RR_CLAS_FIELD = ZD_USER_FIELD+3,	/* ^Cg */
	RR_IMG1_FIELD,				/* rbg}bv */
	RR_TMNL_FIELD,				/* TlC */
	RR_IMGF_FIELD,				/* GIFC[W */
	RR_P_IMJG_FIELD				/* JPEGC[W */
}
#endif
enum {
	RR_TMN2_FIELD = RR_P_IMJG_FIELD+1,	/* TlC */
	RR_CLPR_FIELD,				/* ^Cg */
	RR_ZD01_FIELD,				/* ꏊ */
	RR_RMK1_FIELD,				/* Rg */
	RR_ZIDO_FIELD,				/* ܓx */
	RR_ZKID_FIELD,				/* ox */
	RR_IMPG_FIELD,				/* PNGC[W */
	RR_ZICN_FIELD				/* X|bgACRԍ */
};

#define RR_PICO_DEFAULT_EDIT_SIZE	3600

#define RR_MAX_ENCODE_SIZE			(500*1024)

/* ǂݏof[^߂̃[N */
typedef struct RR_PHOT_DATA_EX{
	UCHAR*	Title;
	UCHAR*	Image;
	UINT	ImageSize; /* ۂɓǂݏof[^̃TCYoĂ */
	UCHAR* 	Thumbnail;	/* TlCf[^̈ */
	UINT	ThumbnailSize;	/* TlCf[^̃TCY */
	UCHAR*	UseBuffTop;	/* f[^̓ǂݏoɎgpobt@ */
						/* AhXBJpɋLĂB*/
	DATALEN	TitleDataLen;	/* ^Cgf[^Ȃ͂P */
	UCHAR	Attr;			/* Agr[giV[Nbgpj*/
	UCHAR*	TitleYomi;		/* ^Cgǂ */
	UCHAR*	Place;			/* ꏊ */
	UCHAR*	Comment;		/* Rg */
	UCHAR	Latitude[GEO_LATIT_NSTR_LEN];	/* ܓx */
	UCHAR	Longitude[GEO_LONGIT_NSTR_LEN];	/* ox */
	USHORT	SpotIconNo;		/* X|bgACRԍ */
	UINT	ImageType;		/* ǂݏf[^^Cv */
									/* RR_JPEG_IMAGE:JPEGC[W */
									/* RR_PNG_IMAGE:PNGC[Wj*/
	DATALEN	TitleYomiDataLen;	/* ^Cgǂ݃f[^̒ik܂ށj*/
	DATALEN	PlaceDataLen;		/* ꏊf[^̒ik܂ށj */
	DATALEN	CommentDataLen;		/* Rgf[^̒ik܂ށj*/
} RR_PHOT_DATA_EX;


/*==== eAvP[VƂ̃x̏I ====*/

/* ǂݏof[^MOREň߂̃[N */
typedef union ROMAPL_DATAWORK_EX{
	RR_SCHE_DATA_EX		Schedule;
	RR_ACTION_DATA_EX	Todo;
	RR_ADDRESS_DATA_EX 	Address;
	RR_PHOT_DATA_EX		Photo;
} ROMAPL_DATAWORK_EX;


/* ֐̃vg^Cv錾 */
/* romdatadelete_ex.c */
UCHAR DeleteROMAplOneDataEx(ROMAPL_READ_INFO_EX* RomAplDataInfo);

/* romdatawrite_ex.c */
UCHAR WriteROMAplDataEx(ROMAPL_READ_INFO_EX* RomAplDataInfo, ROMAPL_DATAWORK_EX* AplDataWork);

/* romdatacommon_ex.c */
void RR_ChangeAplDataWorkToEx(ROMAPL_DATAWORK_EX* AplDataWorkEx,ROMAPL_DATAWORK* AplDataWork);
void RR_ChangeAplDataWorkToNormal(ROMAPL_DATAWORK* AplDataWork,ROMAPL_DATAWORK_EX* AplDataWorkEx);
void RR_ChangeRomAplReadInfoToEx(ROMAPL_READ_INFO_EX* RomAplReadInfoEx,ROMAPL_READ_INFO* RomAplReadInfo);
void RR_ChangeRomAplReadInfoToNormal(ROMAPL_READ_INFO* RomAplReadInfo,ROMAPL_READ_INFO_EX* RomAplReadInfoEx);
APLID RR_GetAplIDFromROMAplNameEx(ROMAPLNAME ROMAplName);
void RR_SendAplDataUpdateMsgEx(ROMAPL_READ_INFO* RomAplReadInfo,BOOLEAN IsNewDataAdded);

/* romdatawrite_f_ex.c */
UCHAR WriteROMAplFileEx(ROMAPL_READ_INFO_EX* RomAplReadInfo, ROMAPL_DATAWORK_EX* AplDataWork);
UCHAR CheckROMAplOneDataEx(ROMAPLNAME RomAplName, ROMAPL_DATAWORK_EX* AplDataWork);

/* romdatawrite_sub_ex.c */
ZDAMERR RR_WriteCardDataEx(ROMAPL_READ_INFO_EX* RomAplDataInfo, ROMAPL_DATAWORK_EX* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WriteAddDataCheckEx(ROMAPL_DATAWORK_EX* AplDataWork);
static ZDAMERR RR_WriteAddDataEx(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK_EX* AplDataWork, CARDID* TargetCardID);
UCHAR RR_WritePhotoDataCheckEx(ROMAPL_DATAWORK_EX* AplDataWork);
static ZDAMERR RR_WritePhotoDataEx(FILEINFO* ROMFInfo, ZDCARDINFO* ROMCardInfo, ROMAPL_DATAWORK_EX* AplDataWork, CARDID* TargetCardID);


/* romdataread_f_ex.c */
UCHAR OpenROMAplFileEx(ROMAPL_READ_INFO_EX* RomAplDataInfo);
UCHAR ReadROMAplFileEx(ROMAPL_READ_INFO_EX* RomAplDataInfo,ROMAPL_DATAWORK_EX* AplDataWork);
void CloseROMAplFileEx(ROMAPL_READ_INFO_EX* RomAplDataInfo);
UCHAR CountROMAplFileEx(ROMAPL_READ_INFO_EX* pRomAplDataInfo,USHORT* DataNum);

/* romdataread_ex.c */
void DisposeROMAplWorkEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,ROMAPL_DATAWORK_EX* AplDataWork);
UCHAR CountROMAplDataNumEx(ROMAPL_READ_INFO_EX* RomAplReadInfo, USHORT* DataNum);
UCHAR ReadROMAplDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,ROMAPL_DATAWORK_EX* AplDataWork);

/* romdataread_sub_ex.c */
BOOLEAN CompressROMAplDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,ROMAPL_DATAWORK_EX* AplDataWork);
ZDCARDINFO* RR_SetRomAplCardInfoEx(ROMAPLNAME RomAplName);
FILEINFO* RR_SetRomAplFileInfoEx(ROMAPLNAME RomAplName);
void SetRomAplInfo();
ZDAMERR RR_ReadCardDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadPhotoDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
ZDAMERR RR_ReadAddDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,FILEINFO* ROMFInfo,ZDCARDINFO* ROMCardInfo,CARDID TargetCardID);
CARDID RR_GetTargetCardIDEx(ROMAPL_READ_INFO_EX* RomAplReadInfo);
void RR_SetWorkFromDataEx(ROMAPL_READ_INFO_EX* RomAplReadInfo,ROMAPL_DATAWORK_EX* AplDataWork,ZDCARDINFO* ROMCardInfo);
BOOLEAN RR_CheckParamEx(ROMAPL_READ_INFO_EX* RomAplReadInfo);

#define _ROMDATAREAD_H_
#endif
