#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _SMTPH_
#define _SMTPH_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/* DO NOT CHAGE THE ORDER OF STATUS DEFINITIONS */

#define NO_CHAR		0	/* This block is first block to be sent */
#define NO_CR_LF	1	/* Last character is not neither cr nor lf */
						/* > 1 : States the characters are buffered in pop */
#define	IS_CR		2	/* Last character is cr (no lf) */
#define IS_EOL		3	/* Last character is EndOfLine */
#define IS_PERIOD	4	/* Received period token at the beginning of line
						   Pending store this character	*/
#define AWAIT_EOM	5	/* Received \r and waiting \n at the end of message */

/* Append 1998.2.28 ZaurusSoft */
#define SmtpRsetCmd() SmtpCmd ( "RSET", NULL, NULL, 250, NULL)

/* Debug purpose only */

#ifdef Debug
extern char *DebugResp;
extern char *DefaultResp;
extern char *SMTPOK;
extern char *SMTPREADY;
extern char *STARTINPUT;
extern char *SMTPCLOSE;
extern char SmtpResp[];
#endif



extern int SmtpFusionSocketErrp;
#ifdef errp
  #undef errp
  #define errp	SmtpFusionScoketErrp
#endif


/* Function proto-type */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
int msgout (char *param1, char *param2, char *param3);
void getrep (char * buf, int size);
int getrepcode (char *string1);
int SmtpCmd (char *cmd, char *opt, char *subopt, int expect, int *repCode);
int SmtpQuitCmd (void);
int InitSmtpSocket(void);
void CleanupSmtpSocket(void);
void CloseSmtpConnection(void);
int rcptcmd (char *rcpt, char *buf);
int SmtpMailCmd (char **rcpts, char *revpath, int *neterr);
int SmtpCallHost (char *node, int *neterr);
int SmtpLogin (int *neterr);
/* int senddata (int fd, header *head, char *buf); */
/* int SmtpPutMessage (char *message, int bytes, boolean EndOfMessage); Change 98.03.11 */
int SmtpPutMessage (char *message, int bytes, BOOLEAN EndOfMessage);

#ifdef  __cplusplus
void InitSmtp ( char * rbuf, int rsize, char * wbuf, int wsize, 
				char * respbuf, int respsize, int(* abort)(...) );
#else
void InitSmtp ( char * rbuf, int rsize, char * wbuf, int wsize, 
				char * respbuf, int respsize, int(* abort)() );
#endif
END_EXTERN_C                /* C++ support  99/9/8 */

/* End of smtp.h */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _SMTPH_ */
