/* BSD socket to Fusion socket */
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _TOFUSOCKH_
#define _TOFUSOCKH_
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#define	ACCEPT( s, a, l)		accept(s, a, l, &FusionSocketErr)

#define	RECV( s, b, l, f)		recv( s, b, l, f, &FusionSocketErr)		
#define	RECVFROM( s, b, l, f, m, n)	\
			recvfrom( s, b, l, f, m, n, &FusionSocketErr)

#define	SEND( s, b, l, f)		send( s, b, l, f, &FusionSocketErr)

#define	SENDTO( s, b, l, f, o, p)	\
			sendto( s, b, l, f, o, p, &FusionSocketErr)

#define	SETSOCKOPT(s, v, n, o, l) setsopt( s, v, n, o, l)

#define	SOCKET( a, t, p)	socket( a, t, p, &FusionSocketErr)

/* End of fusock.h */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _TOFUSOCKH_ */
