/***********************************************************************
<t@C>	toolmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_TOOLMSG_H_INCLUDED
#define	_TOOLMSG_H_INCLUDED
#include <sharpgen.h>
#include <fclib.h>

/*  c[ʃbZ[W  */

/*  ec[ʂ̔bZ[W  */

struct	TOOL_SYSTEM_INIT
{
	USHORT	MessageID;		/*  ToolSystemInitID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	InitLevel;		/*  x  */
};

struct	TOOL_INIT
{
	USHORT	MessageID;		/*  ToolInitID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_CONSTRUCT_RES
{
	USHORT		MessageID;		/*  ToolConstructResID  */
	USHORT		OccuredTime;	/*  ^C~O  */
	RESOURCE	*InitRes;		/*@\[XXgN`  */
};

struct	TOOL_CONSTRUCT_PTR
{
	USHORT	MessageID;		/*  ToolConstructPtrID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*InitResPtr;	/*@\[X̃\[Xւ̃|C^  */
};

struct	TOOL_DESTRUCT
{
	USHORT	MessageID;		/*  ToolDestructID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_EXEC
{
	USHORT	MessageID;		/*  ToolDestructID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_ALL_EXEC
{
	USHORT	MessageID;		/*  ToolDestructID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_EXIT
{
	USHORT	MessageID;		/*  ToolExitID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_OPEN
{
	USHORT	MessageID;		/*  ToolOpenID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_CLOSE
{
	USHORT	MessageID;		/*  ToolCloseID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	SET_NORMAL
{
	USHORT	MessageID;		/*  SetNormalID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	SET_HILITE
{
	USHORT	MessageID;		/*  SetHiliteID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	SET_ACTIVE
{
	USHORT	MessageID;		/*  SetActiveID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	UCHAR	ActiveStatus;	/*  ANeBu  */
};

struct	SET_PAGE
{
	USHORT	MessageID;		/*  SetPageID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	PageNo;			/*  ĕ\y[WNo  */
};

struct	REVERSE
{
	USHORT	MessageID;		/*  ReverseID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	WAIT_REVERSE
{
	USHORT	MessageID;		/*  WaitReverseID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	HILITE_REPEAT_REVERSE
{
	USHORT	MessageID;		/*  HiliteRepeatReverseID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	NORMAL_REPEAT_REVERSE
{
	USHORT	MessageID;		/*  NormalRepeatReverseID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	CHECK_PART
{
	USHORT	MessageID;		/*  CheckPartID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	UCHAR	TargetStatus;	/*  ΏۂƂȂID̏  */
};

struct	CHECK_STATUS
{
	USHORT	MessageID;		/*  CheckStatusID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	/*  ̓p[^n  */	/* NX͎gȂ */
};

struct	CHECK_ACTIVE
{
	USHORT	MessageID;		/*  CheckActiveID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ݃ANeBuID  */
};

struct	REDISP
{
	USHORT	MessageID;		/*  RedispID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	PART_REDISP
{
	USHORT	MessageID;		/*  PartRedispID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
};

struct	NEXT_PAGE
{
	USHORT	MessageID;		/*  NextPageID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	PREV_PAGE
{
	USHORT	MessageID;		/*  PrevPageID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	NEXT_ITEM
{
	USHORT	MessageID;		/*  NextItemID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	PREV_ITEM
{
	USHORT	MessageID;		/*  PrevItemID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	SCROLL_UP
{
	USHORT	MessageID;		/*  ScrollUpID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	SCROLL_DOWN
{
	USHORT	MessageID;		/*  ScrollDownID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	SCROLL_UPDATE
{
	USHORT	MessageID;		/*  ScrollUpdateID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	AllDataNo;		/*  Sf[^  */
	USHORT	DispDataNo;		/*  \\f[^  */
	USHORT	DispOffset;		/*  \Jnf[^  */
};

struct	EDIT_CHAR
{
	USHORT	MessageID;		/*  EditorCharID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR*	SetStrPtr;		/*  ւ̃|C^  */
	USHORT	StrLength;		/*  ̒  */
};

struct	SCROLL_LEFT
{
	USHORT	MessageID;		/*  ScrollLeftID  */
	USHORT	OccuredTime; 	/*    */
};

struct	SCROLL_RIGHT
{
	USHORT	MessageID;		/*  ScrollRightID  */
	USHORT	OccuredTime; 	/*    */
};

struct	TEXT_SELECT
{
	USHORT	MessageID;		/*  TextSelectID  */
	USHORT	OccuredTime; 	/*    */
	USHORT	StartOffset;	/*  JnʒũItZbg  */
	USHORT	DataLength;		/*  ZNgoCg  */
};

struct	TEXT_NORMAL
{
	USHORT	MessageID;		/*  TextNormalID  */
	USHORT	OccuredTime; 	/*    */
	USHORT	StartOffset;	/*  JnʒũItZbg  */
	USHORT	DataLength;		/*  ZNgoCg  */
};

struct	TEXT_CUT
{
	USHORT	MessageID;		/*  TextCutID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR*	CopyBuffPtr;	/*  Rs[obt@̃|C^  */
	USHORT	StartOffset;	/*  JnʒũItZbg  */
	USHORT	DataLength;		/*  JbgoCg  */
};

struct	TEXT_COPY
{
	USHORT	MessageID;		/*  TextCopyID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR*	CopyBuffPtr;	/*  Rs[obt@̃|C^  */
	USHORT	StartOffset;	/*  JnʒũItZbg  */
	USHORT	DataLength;		/*  Rs[oCg  */
};

struct	TEXT_PASTE
{
	USHORT	MessageID;		/*  TextPasteID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR*	SetStrPtr;		/*  y[Xgւ̃|C^  */
	USHORT	StrLength;		/*  y[Xg̒  */
	UCHAR	PasteMode;		/*  y[Xg[h */	/* FEdit̂ */
};

struct	IMAGE_SELECT
{
	USHORT	MessageID;		/*  ImageSelectID  */
	USHORT	OccuredTime; 	/*    */
};

struct	IMAGE_CUT
{
	USHORT	MessageID;		/*  ImageCutID  */
	USHORT	OccuredTime; 	/*    */
};

struct	IMAGE_COPY
{
	USHORT	MessageID;		/*  ImageCopyID  */
	USHORT	OccuredTime; 	/*    */
};

struct	IMAGE_PASTE
{
	USHORT	MessageID;		/*  ImagePasteID  */
	USHORT	OccuredTime; 	/*    */
};

struct	CHANGE12_24
{
	USHORT	MessageID;		/*  Change12_24ID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR	TimeMode;		/*  PQ^QSw */
	UCHAR	DispMode;		/*  \[hw */	/* FEdit̂ */
};

struct	SET_SELECT
{
	USHORT	MessageID;		/*  SetSelectID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	RESET_SELECT
{
	USHORT	MessageID;		/*  ResetSelectID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  ΏۂƂȂID  */
	USHORT	TargetID2;		/*  ΏۂƂȂID  */
};

struct	IMAGE_NORMAL
{
	USHORT	MessageID;		/*  ImageNormalID  */
	USHORT	OccuredTime; 	/*    */
};

struct	WINDOW_HANDLE_SET
{
	USHORT	MessageID;		/*  WindowHandleSetID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	WindowHandle;	/*@EBhEnhio[  */
};

struct	CURSOR_LEFT
{
	USHORT	MessageID;		/*  CursorLeftID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	CURSOR_RIGHT
{
	USHORT	MessageID;		/*  CursorRightID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	CURSOR_UP
{
	USHORT	MessageID;		/*  CursorUpID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	CURSOR_DOWN
{
	USHORT	MessageID;		/*  CursorDownID  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	SET_DATA
{
	USHORT	MessageID;		/*  SetDataID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	LayerNo;		/*  C[̔ԍ  */
	UCHAR	ItemNo;			/*  Zbg鍀ڂ̔ԍ */
	UCHAR	*DataAddress;	/*@Zbgf[^̃AhX */
	USHORT	DataSize ;		/*  Zbgf[^̃TCY */
};

struct	GET_DATA
{
	USHORT	MessageID;		/*  GetDataID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	LayerNo;		/*  C[̔ԍ  */
	UCHAR	ItemNo;			/*  Zbg鍀ڂ̔ԍ */
	UCHAR	**HeapHandle;	/*@f[^i[Ăq[ṽnh */
	USHORT	DataSize;		/*  f[^̃TCY */
};

struct	SET_PROPERTY
{
	USHORT	MessageID;		/*  SetPropertyID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	PropertyID;		/*	ZbgvpeBhc */
	PROPERTY_V	Value;		/*	ZbgvpeBl */
	UCHAR	LayerNo;		/*  C[̔ԍ  */
	UCHAR	ItemNo;			/*  Zbg鍀ڂ̔ԍ */
	UCHAR	PartNo;			/*@ZbgRg[iԍ */
};

struct	GET_PROPERTY
{
	USHORT	MessageID;		/*  GetPropertyID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	PropertyID;		/*	ǂ݂vpeBhc */
	PROPERTY_V	Value;		/*	ǂ݂vpeBl */
	UCHAR	LayerNo;		/*  C[̔ԍ  */
	UCHAR	ItemNo;			/*  ǂ݂ڂ̔ԍ */
	UCHAR	PartNo;			/*@ǂ݂Rg[iԍ */
};

struct	RESUME_REDISP
{
	USHORT	MessageID;		/*  ResumeRedispID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*InfoAddress;		/* W[̃AhX */
};

struct	GET_RESUME_INFO
{
	USHORT	MessageID;		/*  GetResumeInfoID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	*InfoAddress;		/* W[̃AhX */
};

struct	TOOL_DATA_CLEAR
{
	USHORT	MessageID;			/*  ToolDataClearID  */
	USHORT	OccuredTime;		/*  ^C~O  */
};

typedef enum TZOOMMODE {
	TZM_ZOOMIN = 1,
	TZM_ZOOMOUT,
	TZM_LOOP
} TZOOMMODE;

struct	TOOL_ZOOMING
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	TZOOMMODE	ZoomingMode;
};

/*  ec[ʂ̔bZ[W  */

struct	TOOL_INIT_ERROR
{
	USHORT	MessageID;		/*  ToolInitErrorID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	ErrorCode;		/*  G[R[h  */
};

struct	TOOL_DISP_OVER
{
	USHORT	MessageID;		/*  ToolDispOverID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	FactorMessage;	/*  vƂȂbZ[WID  */
};

struct TOOL_DROP
{
	USHORT	MessageID;		/*  ToolDropID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	short	DrawPositionX;		/* hbvWw(\ʒu) */
	short	DrawPositionY;		/* hbvWx(\ʒu) */
	short	PenPositionX;		/* hbvWw(yʒu) */
	short	PenPositionY;		/* hbvWx(yʒu) */
};

struct DROP_CANCEL
{
	USHORT	MessageID;		/*  DropCancelID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	short	PositionX;		/* hbvWw */
	short	PositionY;		/* hbvWx */
};

struct	TOOL_DATA_OVER
{
	USHORT	MessageID;		/*  ToolDataOverID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	FactorMessage;	/*  vƂȂbZ[WID  */
};

struct	TOOL_ERROR
{
	USHORT	MessageID;		/*  ToolErrorID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	FactorMessage;	/*  vƂȂbZ[WID  */
};

struct	SLIDER_SET
{
	USHORT	MessageID;		/*  SliderSetID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	Value;			/*  ݒ肳ꂽl  */
};

struct	AREA_PRESS
{
	USHORT	MessageID;		/*  AreaPressID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	UCHAR	Attribute;		/* Agr[g */
	POINT	Offset;			/*	GAォ̑΍W */
};

struct	TOOL_CMD_COMPLETED
{
	USHORT	MessageID;		/*  ToolCmdCompleted  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	TOOL_CMD_CANCELED
{
	USHORT	MessageID;		/*  ToolCmdCanceled  */
	USHORT	OccuredTime;	/*  ^C~O  */
};

struct	FILE_SELECT
{
	USHORT	MessageID;		/* FileSelectID */
	USHORT	OccuredTime;	/* ^C~O */
	FCFNAME	FileName;		/* Iꂽt@C */
};


/* ̓sɂButtonPressƓo\Ƃ */
struct	TOOL_DRAG_START
{
	USHORT	MessageID;		/*  ToolDragStartID  */
	USHORT	OccuredTime;	/*  ^C~O  */
	USHORT	TargetID;		/*  Iꂽ^[QbgID  */
	USHORT	TargetID2;		/*  Iꂽ^[QbgID  */
	UCHAR	Info;			/*@  */
};


struct  BUTTON_FLASH_START
{
    USHORT  MessageID;      /*  ButtonFlashStartID  */
    USHORT  OccuredTime;    /*  ^C~O  */
    USHORT  FlashBtnID;     /*  _őΏۂ̃{^ID  */
    USHORT  FlashEndTime;   /*  _ŏI(SystemTick)    */
    /*  ](On)ʏ(Off)̏ɓ_ł   */
    USHORT  FlashOnTime;    /*  _ŊԊuP(_łP񓖂̔]\SystemTick)  */
    USHORT  FlashOffTime;   /*  _ŊԊuQ(_łP񓖂̒ʏ\SystemTick)  */
	UCHAR	FlashMode;		/*	_ŕ (0: Og 1:])	*/
};


struct  BUTTON_FLASH_END
{
    USHORT  MessageID;      /*  ButtonFlashEndID  */
    USHORT  OccuredTime;    /*  ^C~O  */
};


struct BUTTON_FLASH_CANCEL
{
    USHORT  MessageID;      /*  ButtonFlashCancelID  */
    USHORT  OccuredTime;    /*  ^C~O  */
};



/****************************************/
/*@c[ʃbZ[Whc̒`	*/
/*	͈́F@POOO`PXXX	*/
/****************************************/

	/*@bZ[W@*/
#define	SetNormalID				1000
#define	SetHiliteID				1001
#define	ReverseID				1002
#define	WaitReverseID			1003
#define	HiliteRepeatReverseID	1004
#define	NormalRepeatReverseID	1005
#define	CheckPartID				1006
#define	CheckStatusID			1007
#define	CheckActiveID			1008
#define	RedispID				1009
#define	PartRedispID			1010
#define	ToolInitID				1011
#define	ToolExitID				1012
#define	ToolOpenID				1013
#define	ToolCloseID				1014
#define	SetPageID				1015
#define	NextPageID				1016
#define	PrevPageID				1017
#define	NextItemID				1018
#define	PrevItemID				1019
#define	SetActiveID				1020
#define	ScrollDownID			1021
#define	ScrollUpID				1022
#define	ScrollUpdateID			1023
#define	EditCharID				1024
#define	ScrollLeftID			1025
#define	ScrollRightID			1026
#define	TextSelectID			1027
#define	TextNormalID			1028
#define	TextCutID				1029
#define	TextCopyID				1030
#define	TextPasteID				1031
#define	ImageSelectID			1032
#define	ImageCutID				1033
#define	ImageCopyID				1034
#define	ImagePasteID			1035
#define	Change12_24ID			1036
#define SetSelectID				1037
#define ResetSelectID			1038
#define ImageNormalID			1039
#define ToolSystemInitID		1040
#define	ToolConstructResID		1041
#define	ToolConstructPtrID		1042
#define	WindowHandleSetID		1043
#define	ToolDestructID			1044
#define	CursorLeftID			1045
#define	CursorRightID			1046
#define	CursorUpID				1047
#define	CursorDownID			1048
#define	SetDataID				1049
#define GetDataID				1050
#define SetPropertyID			1051
#define GetPropertyID			1052
#define ResumeRedispID			1053
#define GetResumeInfoID			1054
#define ToolDataClearID			1055
#define	ToolExecID				1056
#define	ToolAllExecID			1057
#define ButtonFlashStartID  	1060
#define ButtonFlashCancelID 	1061

	/*@bZ[W@*/
#define	ToolInitErrorID			1500
#define	ToolDispOverID			1501
#define	ToolDropID				1502
#define	DropCancelID			1503
#define	ToolDataOverID			1504
#define	ToolErrorID				1505
#define	SliderSetID				1506
#define	AreaPressID				1507
#define	ToolCmdCompletedID		1508
#define	ToolCmdCanceledID		1509
#define	FileSelectID			1510
#define	ToolDragStartID			1511
#define ButtonFlashEndID		1513
#endif
