/***********************************************************************
<t@C>	viewmmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_VIEWMMSG_H_INCLUDED
#define	_VIEWMMSG_H_INCLUDED
/* r[}l[WbZ[W */
#include	<sharpgen.h>

/* r[}l[W̔bZ[W */
struct VMAN_SCROLL
{
	USHORT	MessageID;	/* VManScrollID */
	USHORT	OccuredTime;	/* ^C~O */
	short	ScrollSize;
};

struct	VMAN_AUTO_SCROLL_UP
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	VMAN_AUTO_SCROLL_DOWN
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	VMAN_AUTO_SCROLL_UPDATE
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	AllDataNo;	/* Sf[^ */
	USHORT	DispDataNo;	/* \\f[^ */
	USHORT	DispOffset;	/* \Jnf[^	*/
};

struct	VCONT_AUTO_SCROLL_UP
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	VCONT_AUTO_SCROLL_DOWN
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	VCONT_AUTO_SCROLL_UPDATE
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	AllDataNo;	/* Sf[^ */
	USHORT	DispDataNo;	/* \\f[^ */
	USHORT	DispOffset;	/* \Jnf[^	*/
};

struct	STORE_DATA
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	DELETE_DATA
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};

struct	PAGE_RESET
{
	USHORT	MessageID;
	USHORT	OccuredTime;
};
struct	EDIT_MODE_ON
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	Target;
};
struct	EDIT_MODE_OFF
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	Target;
};

struct	CHECK_POSITION
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	BOOLEAN	InArea;
	USHORT	StartLineNo;
	USHORT	StartLineGap;
	USHORT	EndLineNo;
	USHORT	EndLineGap;
	USHORT	StartPos;
	USHORT	EndPos;
};

struct	VMAN_DISP_OVER
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	ErrorCode;
};

struct	FRAME_SIZE_CHANGE
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	short	ChangeSize;
};

struct	VMAN_ITEM_SELECT
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	SelectItemNo;
};

struct	VMAN_ITEM_CHANGE
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	SelectItemNo;
};

struct	TOOL_RECONSTRUCT_RES
{
	USHORT		MessageID;		/*  ToolReConstructResID  */
	USHORT		OccuredTime;	/*  ^C~O  */
	RESOURCE	*InitRes;		/*@\[XXgN`  */
};

struct	TOOL_RECONSTRUCT_PTR
{
	USHORT		MessageID;		/*  ToolReConstructPtrID  */
	USHORT		OccuredTime;	/*  ^C~O  */
	UCHAR	*InitResPtr;	/*@\[X̃\[Xւ̃|C^  */
};

struct	VMAN_YOMI_SET
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	Target;
};

struct	VMAN_EDIT_CHAR
{
	USHORT	MessageID;
	USHORT	OccuredTime;
	USHORT	InputItemNo;
	USHORT	ButtonID;
};

 /* MESSAGE ID */
#define	VManAutoScrollUpID	5700
#define	VManAutoScrollDownID	5701
#define	VManAutoScrollUpdateID	5702
#define	VManPadChangeID			5703
#define	VContAutoScrollUpID		5704
#define	VContAutoScrollDownID	5705
#define	VContAutoScrollUpdateID	5706
#define	VManScrollID			5707
#define	VManDispOverID			5708
#define	StoreDataID				5709
#define	DeleteDataID			5710
#define	PageResetID				5711
#define	EditModeOnID			5712
#define	EditModeOffID			5713
#define	CheckPositionID			5714
#define	VManSetID				5715
#define	VContPenCheckID			5716
#define	FrameSizeChangeID		5717
#define VContClearID			5718
#define	VManItemSelectID		5719
#define	VManItemChangeID		5720

#define	ToolReconstructResID	5721
#define	ToolReconstructPtrID	5722
#define	VManYomiSetID			5723
#define	VManCursorOnID			5724
#define	VManCursorOffID			5725
#define	VManEditCharID			5726
#define	VManCursorResetID		5727
#endif
